; gw49_2_asm on win1_dv1
; and win1_ass
; 15th January 2012
;
; Altered - 15th January 2012
; 1. Immediate byte data clears top byte of word	 (EA_7N0)
;
; Altered - 6th February 2011
; 1. Allow octal input
;
; Altered - 6th May 2008
; 1. Allow 12-byte inserts - EA_DL altered
;
; Altered - 13th July 2004
; 1. Allow for multiple EQU lists in recursive GNUM
; 2. Disallow XREFs in '[' EQU lists in GNUM
;
; Altered - 10th September 2003
;
; 1. Allow expressions in GNUM
; 2. Correct EA_4 for possible expressions
; 3. Altered a branch in GN_Q to short
; 4. Made GN_ER1 = GN_EROT
; 5. Added "(" to possible [
;
; Allow 21 sig figs for FP no - 3rd October 2002
; New SR DO_SIZEX
;
; Alter GN_SUB to allow non signed ADD and SUB (Note
;  This relaxes a check on numbers!) - 11th December 2001
;
; Alter MOVEP to allow ea 0(An) - 7th February 2001
;
; Set signed test for ABS known labels - 27th February 1999
;
; Altered at GN_L1 to use table lookup - 24th January 1999
;
; An ASSEMBLER program
;    PART 2
;
; Some more subroutines
;
; GNUM	 D0 A1
;   ___________________________
;  |_______|__|__________________|
;
; For entry 'GNUM'	    A1 -> 1st digit
; For entry 'GNUM1' D0 <- 1st digit & A1 -> 2nd digit
;
;  OUT: D1.L = TYPE 		D2 =  VALUE
;	-7 = FP Reg list		value as in FMOVEM
;	-6 = Register		D0 -> A7 as 0 -> 15
;	-5 = Reg list		word value as in MOVEM
;	-4 = Quad word in BUF+4	-
;	-3 = FP in BUF		-
;	-2 = String in BUF >4	-
;	   or forced by '?'
;	-1 = Error		-
;	 0 = Label undetermined	Label number*
;	 1 = N (number)		VALUE
;	 2 = PC			Label number*
;	 4 = EQ list exists 	Pointer to EQ list*
;
;				* D2(bit 31)=0 for +,1 for -
;	D0.B = new separator (D0.W used)
;
; Alters no other registers
;
; D6.L use is:-  15   3  0
;      ___________________________________
;     |  LABEL no		|.      ....|
;			        
;     Bit 3   Known label has occurred |||
;	2	   EQU list started ||
;	1   Unknown LABEL has occurred |
;	0	A number has occurred
;
GNREG	REG	D3-7/A0/A2-3/A5
;
GNUMA	PEA	2	    mark [
	BRA	GNUM2
;
GNUMB	PEA	1	    mark (
	BRA	GNUM2
;
GNUM	MOVE.B	(A1)+,D0
GNUM1	PEA	0	    mark normal
GNUM2	MOVEM.L	GNREG,-(A7)
	CMPA.L	G_LIMIT(A6),A7
	BLT	QER35	---->	not enough space on stack
	MOVE.L	36(A7),D7 	keep marker in D7
	MOVEQ	#0,D6
	MOVEA.L	D6,A5		Zero EQU pointer - 13th July 2004
	MOVEQ	#0,D2		Value
	MOVEQ	#1,D3		plus
	CMP.B	#2,D7		type of GNUM?
	BLT	GNUM3		not [
GNUM4	BSET	#15,D7		mark 1st time
	JMP	4(A2)		complete the number
;
GNUM3	CMPI.B	#"+",D0
	BEQ.S	GN_PL
	CMPI.B	#"-",D0 minus?
	BNE.S	GN_PL1
GN_PL3	MOVEQ	#-1,D3
GN_PL	MOVE.B	(A1)+,D0		next character
GN_PL1	CMPI.B	#33,D0		"!"
	BLT	GN_ER1	---->
	CMPI.B	#'a',D0
	BLT.S	GN_PL2
	SUBI.B	#32,D0		-> upper case
GN_PL2	CMPI.B	#"_",D0
	BHI	GN_ER1	---->
	EXT.W	D0
	LEA	GN_TBLE,A2
	ADDA.W	-66(A2,D0.W*2),A2
	JMP	(A2)
;
GN_TBLE DC.W	GN_IFP-GN_TBLE	!
	DC.W	GN_ASC-GN_TBLE	"
	DC.W	GN_ER1-GN_TBLE	#
	DC.W	GN_HX-GN_TBLE	$
	DC.W	GN_BI-GN_TBLE	%
	DC.W	GN_QA-GN_TBLE	&
	DC.W	GN_ASC-GN_TBLE	'
	DC.W	GN_BRL-GN_TBLE	(
	DC.W	GN_BRR-GN_TBLE	)
	DC.W	GN_PC-GN_TBLE	*
	DC.W	GN_ER1-GN_TBLE	+
	DC.W	GN_ER1-GN_TBLE	,
	DC.W	GN_ER1-GN_TBLE	-
	DC.W	GN_LA-GN_TBLE	.
	DC.W	GN_ER1-GN_TBLE	/
	DC.W	GN_DE-GN_TBLE	0
	DC.W	GN_DE-GN_TBLE	1
	DC.W	GN_DE-GN_TBLE	2
	DC.W	GN_DE-GN_TBLE	3
	DC.W	GN_DE-GN_TBLE	4
	DC.W	GN_DE-GN_TBLE	5
	DC.W	GN_DE-GN_TBLE	6
	DC.W	GN_DE-GN_TBLE	7
	DC.W	GN_DE-GN_TBLE	8
	DC.W	GN_DE-GN_TBLE	9
	DC.W	GN_FP-GN_TBLE	:
	DC.W	GN_ER1-GN_TBLE	;
	DC.W	GN_ER1-GN_TBLE	<
	DC.W	GN_ER1-GN_TBLE	=
	DC.W	GN_ER1-GN_TBLE	>
	DC.W	GN_FSTR-GN_TBLE	?
	DC.W	GN_OC-GN_TBLE	@
	DC.W	GN_LA-GN_TBLE	A
	DC.W	GN_LA-GN_TBLE	B
	DC.W	GN_LA-GN_TBLE	C
	DC.W	GN_LA-GN_TBLE	D
	DC.W	GN_LA-GN_TBLE	E
	DC.W	GN_LA-GN_TBLE	F
	DC.W	GN_LA-GN_TBLE	G
	DC.W	GN_LA-GN_TBLE	H
	DC.W	GN_LA-GN_TBLE	I
	DC.W	GN_LA-GN_TBLE	J
	DC.W	GN_LA-GN_TBLE	K
	DC.W	GN_LA-GN_TBLE	L
	DC.W	GN_LA-GN_TBLE	M
	DC.W	GN_LA-GN_TBLE	N
	DC.W	GN_LA-GN_TBLE	O
	DC.W	GN_LA-GN_TBLE	P
	DC.W	GN_LA-GN_TBLE	Q
	DC.W	GN_LA-GN_TBLE	R
	DC.W	GN_LA-GN_TBLE	S
	DC.W	GN_LA-GN_TBLE	T
	DC.W	GN_LA-GN_TBLE	U
	DC.W	GN_LA-GN_TBLE	V
	DC.W	GN_LA-GN_TBLE	W
	DC.W	GN_LA-GN_TBLE	X
	DC.W	GN_LA-GN_TBLE	Y
	DC.W	GN_LA-GN_TBLE	Z
	DC.W	GN_ER1-GN_TBLE	[
	DC.W	GN_ER1-GN_TBLE	\
	DC.W	GN_ER1-GN_TBLE	]
	DC.W	GN_ER1-GN_TBLE	^
	DC.W	GN_LA-GN_TBLE	_
;
GN_LA	BSR	GN_NS		See if [ needed
	MOVEM.L	D2,-(A7)
	BSR	STRG1
	MOVEM.L	(A7)+,D2
	BMI	GN_ER2	---->
	CMPI.W	#32,(A2)
	BLE.S	GN_L4
	MOVE.W	#32,(A2)
	BSR	PR_W4		warning of size restriction
GN_L4	MOVE.B	D0,D4		keep in D4
	BSR	NLAB_NO
	BEQ	GN_LABF
	BSR	NNEW_LAB
GN_L2	CMPI.W	#1,D3
	BLE	GN_L13
	BTST	#6,DIP(A6)	extension? . .
	BEQ	GN_ER1	---->	. . no
	BSET	#4,D6		mark EQU type 2
GN_L13	BTST	#2,D6		has EQ list started?
	BNE	GN_Q1		yes
	BSET	#1,D6		first unknown LABEL? (& mark this)
	BNE	GN_Q2		not first
	BTST	#0,D6		has a number occurred? . .
	BEQ	GN_L19		. . no
	BTST	#4,D6		EQU type 2? . .
	BEQ	GN_Q1		. . no - normal
	MOVEM.L	D1/D3,-(A7)
	MOVE.L	D2,D5		constant so far
	MOVEQ	#0,D2		set new constant to 0
	BSR	GN_DUM		get dummy label for old constant
	MOVEQ	#1,D3		set + for 1st entry in EQU list
	BSR	GN_SETQ		1st entry op|label
	MOVEM.L	(A7)+,D1/D3
	BRA	GN_Q1		set up current op|label
;	 BNE	 GN_Q1		 yes
GN_L19	SWAP	D6
	MOVE.W	D1,D6		label no -> D6
	SWAP	D6
	TST.B	D3
	BPL.S	GN_L3		plus
	BSET	#31,D6		mark minus
GN_L3	MOVE.B	D4,D0		restore char -> D0.B
GN_L1	BSR	GN_OP
	CMPI.B	#2,D7		EXP_ON? . .
	BNE	GN_L7		. . no
	CMPI.B	#2,D3
	BLT	GN_OT		if [ +, - and others end it
	BSR	GN_CT		is new operator higher type than before [? . .
	BLE	GN_OT		. . no, so ]
	BRA	GN_PL
GN_L7	CMPI.B	#1,D3
	BGT	GN_PL		2 to 7
	CMPI.B	#-2,D3
	BGT	GN_PL		go back for +, -
	BNE	GN_OT		end for others
	CMPI.B	#1,D7
	BNE	GN_OT		")" ends it for normal GNUM
	MOVE.B	(A1)+,D0		skip ")" for GNUMB
	BRA	GN_OT
;
GN_OP	MOVEQ	#-3,D3		others
	CMPI.B	#'!',D0
	BLT	GN_OP1		not arithmetical . .
	CMPI.B	#'>',D0
	BGT	GN_OP1		. . combination
	EXT.W	D0
	LEA	GN_AR,A2
	ADDA.W	-'!'*2(A2,D0.W*2),A2
	JMP	(A2)
;
GN_AR	DC.W	GN_L9-GN_AR	  !
	DC.W	GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR
	DC.W	GN_L8-GN_AR	  &
	DC.W	GN_OP1-GN_AR,GN_OP1-GN_AR
	DC.W	GN_L16-GN_AR	  )
	DC.W	GN_L14-GN_AR	  *
	DC.W	GN_L17-GN_AR	  +
	DC.W	GN_OP1-GN_AR
	DC.W	GN_L5-GN_AR	  -
	DC.W	GN_OP1-GN_AR
	DC.W	GN_L6-GN_AR	  /
	DC.W	GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR
	DC.W	GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR
	DC.W	GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR,GN_OP1-GN_AR
	DC.W	GN_L15-GN_AR	  <
	DC.W	GN_OP1-GN_AR
	DC.W	GN_L10-GN_AR	  >
;
GN_L15	CMPI.B	#'<',(A1)
	BNE	GN_OP1
	ADDQ.L	#1,A1		skip extra <
	BRA	GN_L12		'>>' -> 5
;
GN_L10	CMPI.B	#'>',(A1) 	'>>' -> 6
	BNE	GN_OP1
	ADDQ.L	#1,A1		skip extra >
	BRA	GN_L11
;
GN_L6	ADDQ.L	#1,D3		7 DIV
GN_L11	ADDQ.L	#1,D3		6 >>
GN_L12	ADDQ.L	#1,D3		5 <<
GN_L9	ADDQ.L	#1,D3		4 OR
GN_L8	ADDQ.L	#1,D3		3 AND
GN_L14	ADDQ.L	#1,D3		2 MUL
	BTST	#6,DIP(A6)	EXP? . . .
	BNE	GN_L18		. . yes
	CMPI.W	#1,D6
	BLE	GN_L17
	ADDQ.L	#4,A7
	BRA	GN_ER1	---->
GN_L18	BTST	#1,D6		has unknown lab been? . .
	BEQ	GN_L17		. . no
	BSET	#4,D6		. . yes so set EQU type 2
GN_L17	ADDQ.L	#2,D3		 1 +
GN_L5	ADDQ.L	#1,D3		-1 -
GN_L16	ADDQ.L	#1,D3		-2 )
GN_OP1	RTS
;
;
GN_EQ1	MOVEM.L	D1/D3,-(A7)
	MOVEQ	#1,D3
	BCLR	#31,D6		clear minus
	BEQ.S	GN_EQ2
	MOVEQ	#-1,D3		minus
GN_EQ2	SWAP	D6
	MOVE.W	D6,D1		label no
	SWAP	D6
	BSR	GN_SETQ
	BNE	GN_EQ3	--->
	MOVEQ	#0,D1		set Z
GN_EQ3	MOVEM.L	(A7)+,D1/D3
	RTS
;
GDUM	REG	D3/A0/A4
;
GN_DUMQ	PEA	8		for EQU list
	BRA	GN_DUM2
GN_DUM	PEA	5		for N
GN_DUM2	MOVEM.L	GDUM,-(A7)
	BSR	SDUM
	BMI	GN_DUM1 ---->
	MOVE.L	D5,VAL(A0)	set number to label
	MOVE.W	14(A7),TYPE(A0)	set type N or EQU list
	MOVE.W	D3,D1		set label number to D1
	MOVEM.L	(A7)+,GDUM
	ADDQ.L	#4,A7		adjust stack for PEA
	RTS
;
GN_DUM1	MOVEM.L	(A7)+,GDUM
	LEA	8(A7),A7
	BRA	GN_ER11	---->

GN_PC	MOVE.B	(A1)+,D0		sets D0.B to separator
	BSR	TST_SEP		OK?
	BMI	GN_ER1	---->	no
	MOVE.B	D0,D4		keep D0
	MOVE.L	D3,-(A7)
	BSR	SDUM		do dummy label
	BMI	GN_PC1	---->
	MOVE.W	D3,D1		set label no to D1
	MOVE.L	(A7)+,D3		restore D3
	MOVE.W	#6,TYPE(A0)	'PC'
	MOVE.L	PC_NOW(A6),VAL(A0)	set *
	MOVE.W	CRT_SEC(A6),(A0)	set section no
	BRA	GN_L2
GN_PC1	ADDQ.L	#4,A7		adjust stack
	BRA	GN_ER11	---->
;
; GN_PMT tests for + and - and sets D3 accordingly
;
GN_PMT	TST.L	D3
	BMI	GN_PMT6		'-'
	CMPI.W	#1,D3
	BNE	GN_PMT4		ignore all but '+'
GN_PMT6	CMPI.B	#"-",(A1)
	BEQ.S	GN_PMT2
	CMPI.B	#"+",(A1)
	BEQ.S	GN_PMT3
	BRA.S	GN_PMT4
GN_PMT2	TST.L	D3
	BMI.S	GN_PMT5		set D3 -> 1
	MOVEQ	#-3,D3		set D3 -> -1
GN_PMT5	ADDQ.L	#2,D3
GN_PMT3	ADDQ.L	#1,A1		step over sign
GN_PMT4	RTS
;
GN_HX	BSR.W	GN_NS2		See if [ needed
	BSR	GN_PMT
GN_HX4	BSR	HEX
	BNE	GN_ER1	---->
GN_HX1	BTST	#4,D6		EQU type 2? . .
	BEQ	GN_HX2		. . no
;
	BSR	GN_DUM		set dummy label
	MOVE.B	D0,D4
	BRA	GN_L13
;
GN_HX2	BTST	#2,D6		EQ list?
	BNE.S	GN_HXPQ		yes
	BTST	#1,D6		unknown LABEL been?
	BEQ.S	GN_HXP1		no
	BSR	GN_EQ1		set up EQ list
GN_HXP1	BSET	#0,D6		mark 'number been'

GN_HXPQ	PEA	0
	MOVE.L	D5,-(A7)
	MOVE.L	D2,-(A7)
	BSR	ARITH
	MOVEM.L	(A7)+,D2		answer
	LEA	8(A7),A7		adjust stack
	BNE	GN_ER1	---->
	BRA	GN_L1

GN_ASC	BSR.W	GN_NS5		see if [ needed
	BSR	RAS
	BMI	GN_EROT ---->
	CMPI.B	#10,D3
	BEQ	GN_EROT1		mark string (after '?')
	MOVE.L	A2,-(A7)
	LEA	BUF(A6),A2
	CMPI.W	#4,(A2)
	MOVEA.L	(A7)+,A2
	BGT	GN_EROT1 ---->
	BRA	GN_HX1
;
; "("
;
GN_BRL	BSR.W	GN_NS14		See if [ needed
	MOVE.B	(A1)+,D0		skip "(" or ")"
	MOVE.L	D2,-(A7)
	BSR	GNUMB
	BRA	GN_NS13
;
; ")"
;
GN_BRR	BTST	#6,DIP(A6)
	BEQ	GN_ER1	---->
	CMPI.B	#1,D7		"(" type SR?
	BNE	GN_ER1	---->	no
	BRA	GN_OT
;
GN_FP	BSET	#31,D4		mark FP
GN_FP7	CMPI.B	#1,D3
	BNE	GN_ER1	 ---->	('-' not allowed)
	TST.L	D6
	BNE	GN_ER1	---->	(EQU list not allowed)
	MOVEA.L	A1,A3		keep pointer to number
	BSR	STRGA
	BMI	GN_ER2	---->
	MOVEA.L	A3,A1
	MOVE.W	(A2),D3		length
	BEQ	GN_ER1	---->	too short
	CMPI.W	#24,D3
	BGT	GN_ER2	---->	too long
	MOVE.W	D3,D6		length
	SUBQ.W	#1,D6		set length - 1 in ...
	SWAP	D6		... D6.T for FP_SDX
	MOVE.W	D3,D6
	LSR.W	#3,D6		len DIV 8 (= r)
	NEG.W	D6		-r
	LEA	BUF(A6),A2
	MOVE.W	#2,D4
GN_FP1	CLR.L	(A2)+		clear 24 bytes
	DBF	D4,GN_FP1
	LEA	BUF(A6),A2	reset A2
	ANDI.W	#7,D3		len MOD 8 (= b)
	BEQ.S	GN_FP5		no partial HEX
GN_FP6	MOVE.B	(A1,D3.W),D4	keep character
	MOVE.B	#10,(A1,D3.W)	set LF for HEX routine
	BSR	HEX
	BMI	GN_ER1	---->
	MOVE.B	D4,-(A1)		reset A1
	MOVE.L	D5,8(A2,D6.W*4)	set 1st lwd
GN_FP2	TST.W	D6
	BEQ.S	GN_FP3		end
GN_FP5	MOVE.B	8(A1),D4		keep next character
	MOVE.B	#10,8(A1) 	set LF at end of 8 bytes
	BSR	HEX
	BMI	GN_ER1	---->
	MOVE.B	D4,-(A1)		reset A1
	MOVE.L	D5,12(A2,D6.W*4)
	ADDQ.W	#1,D6		step -r to 0
	BNE.S	GN_FP5
GN_FP3	TST.L	D4
	BPL	GN_QA1		quad word
	LEA	BUF(A6),A0	-> FP no
	BSR	FP_SDX		set no to X_type
	BMI	GN_ER1	---->	OOPS
	MOVE.B	(A1)+,D4		replace separator
GN_FP4	MOVEQ	#-3,D1		mark FP number
GN_FP8	MOVE.B	D4,D0		restore separator
	BRA	GN_OT1
;
; GN_QA brings in a quad word in hex
;
GN_QA	BCLR	#31,D4		mark QA
	BRA	GN_FP7
;
GN_QA1	MOVE.B	(A1)+,D4
GN_QA2	MOVEQ	#-4,D1		mark 'quad word'
	BRA	GN_FP8
;
; GN_FSTR forces 'string' output
;	and disallows '-' & EQU lists
;
GN_FSTR	CMPI.B	#1,D3
	BNE	GN_ER1	---->	(only '+' allowed)
	TST.L	D6
	BNE	GN_ER1	---->	(EQU list not allowed)
	MOVEQ	#10,D3		mark '?'
	MOVE.B	(A1)+,D0		next character
	CMPI.B	#"'",D0
	BEQ	GN_ASC
	CMPI.B	#'"',D0
	BEQ	GN_ASC
	BRA	GN_ER1	---->	not a string after '?'
;
GN_DE	BSR.W	GN_NS5		see if [ needed
	BSR	DEC
	BNE	GN_ER1	---->
	BRA	GN_HX1
;
GN_BI	BSR.W	GN_NS4		see if [ needed
	BSR	GN_PMT
	BSR	BI
	BNE	GN_ER50	---->
	BRA	GN_HX1
;
GN_OC	BSR.W	GN_NS21
	BSR	GN_PMT
	BSR	OCT
	BNE	GN_ER1	---->
	BRA	GN_HX1
;
; D1.W = label no
;
GN_LABF	MOVE.W	TYPE(A0),D0
	BFTST	D0{22:2}            reg or reg list? . .
	BNE	GN_REG		. . yes
	BFTST	D0{26:2}
	BNE	GN_FPL		FP, STRING or quad label
	BTST	#2,D0
	BEQ	GN_L2		not defined -> EQ list
	BTST	#1,D0
	BNE	GN_LPC		treat as not defined (PC)
	BTST	#4,D6		EQU type 2? . .
	BNE	GN_LPC		. . yes so set number as label
	MOVE.L	VAL(A0),D5
	MOVE.B	D4,D0		replace char in D0
	BRA	GN_HX1
GN_LPC	BSET	#3,D6		mark 'known label'
	BRA	GN_L2
;
; LABEL  is FP or STRING
;
GN_FPL	CMPI.B	#1,D3
	BNE	GN_ER47	---->	only '+' allowed
	TST.B	D6
	BNE	GN_ER47	---->	EQ list not allowed
	ANDI.B	#$3F,D0		strip off SET bit
	CMPI.B	#21,D0
	BEQ.S	GN_FPK		known FP label
	CMPI.B	#$35,D0
	BEQ.S	GN_STRK		known string label
	CMPI.B	#$25,D0
	BEQ	GN_QAK		known quad word
	CMPI.B	#$21,D0
	BEQ	GN_L2		not yet known quad word
	CMPI.B	#17,D0
	BEQ	GN_L2		(D6.B=0 and D3.B is +)
	BRA	GN_ER5	---->
GN_FPK	MOVE.L	([VAL,A0]),BUF(A6)		set FP no
	MOVE.L	([VAL,A0],4),BUF+4(A6)	to
	MOVE.L	([VAL,A0],8),BUF+8(A6)	BUF
	BRA	GN_FP4			& mark known FP
GN_STRK	MOVEA.L	VAL(A0),A2
	MOVE.W	(A2)+,D3		string length
	LEA	BUF(A6),A0
	MOVE.W	D3,(A0)+
	BRA.S	GN_STRK1
GN_STRK2	MOVE.B	(A2)+,(A0)+	put string
GN_STRK1	DBF	D3,GN_STRK2	to BUF
	MOVE.B	D4,D0		restore the separator
	BRA	GN_EROT1		& mark 'string'
;
GN_QAK	MOVE.L	([VAL,A0]),BUF+4(A6)
	MOVE.L	([VAL,A0],4),BUF+8(A6)
	BRA	GN_QA2
;
; FP input
;
FP_SIG	EQU	21
;
GN_IFP	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#0,D4
	BTST	#0,D3
	BEQ	GN_ER1	---->	only '+' and '-' allowed
	TST.B	D3
	BPL.S	GN_IFP6		+
	BSET	#1,D4		mark minus
GN_IFP6	MOVEQ	#FP_SIG,D3	no of significant digits allowed
	MOVEQ	#0,D5
	MOVE.B	(A1)+,D0		next char
	CMPI.B	#"+",D0
	BEQ.S	GN_IFP1
	CMPI.B	#"-",D0
	BNE.S	GN_IFP2
	EORI.B	#2,D4		switch N_S minus/plus
GN_IFP1	MOVE.B	(A1)+,D0		next char
GN_IFP2	CMPI.B	#".",D0
	BEQ	GN_IFD		do DOT_ACTION
	CMPI.B	#"E",D0
	BEQ	GN_IFPE		do E_ACTION
	CMPI.B	#"e",D0
	BEQ	GN_IFPE		"
	CMPI.B	#"9",D0
	BGT	GN_IFPS		set separator
	SUBI.B	#"0",D0
	BMI	GN_IFPS		"
	BNE.S	GN_IFP3		not zero
	CMPI.W	#FP_SIG,D3
	BEQ.S	GN_IFP4		no sig figs yet
GN_IFP3	MOVE.L	D3,-(A7)		keep D3
	ADD.L	D2,D2
	ADDX.L	D1,D1		x2
	MOVE.L	D1,D3
	MOVE.L	D2,D6
	ADD.L	D6,D6
	ADDX.L	D3,D3		x4
	ADD.L	D6,D6
	ADDX.L	D3,D3		x8
	ADD.L	D6,D2
	ADDX.L	D3,D1		x10
	MOVE.L	(A7)+,D3		restore D3
	EXTB.L	D0
	ADD.L	D0,D2		plus new char
	BCC.S	GN_IFP5		no overflow
	ADDQ.L	#1,D1
GN_IFP5	DBF	D3,GN_IFP4	count down no of sig figs . .
	BRA	GN_ER1	---->	. . too many
GN_IFP4	BSET	#3,D4		mark a character been
	BTST	#0,D4		.?
	BEQ	GN_IFP1		no
	SWAP	D3
	SUBQ.W	#1,D3		decrease EXP_10
	SWAP	D3
	BRA	GN_IFP1
;
; DOT_ACTION
;
GN_IFD	BSET	#0,D4		set DOT_MARKER
	BEQ	GN_IFP1
	BRA	GN_IFN		END
;
; TEST SEP ACTION
;
GN_IFPS	BTST	#3,D4		1st char?
	BEQ	GN_ER1	---->	yes
	MOVE.B	-1(A1),D0 	replace character
	BSR	TST_SEPA		(no need to test for ".")
	BMI	GN_ER1	---->
	BRA	GN_IFN		END
;
; E_ACTION
;
GN_IFPE	CMPI.W	#FP_SIG,D3
	MOVE.B	(A1)+,D0		next char
	CMPI.B	#"+",D0
	BEQ.S	GN_IFPE1
	CMPI.B	#"-",D0
	BNE.S	GN_IFPE2
	BSET	#2,D4		set E_S to -
GN_IFPE1	MOVE.B	(A1)+,D0		next char
GN_IFPE2	BSR	DEC		get exponent to D5
	BMI	GN_ER1	---->
;
; END
;
GN_IFN	SWAP	D3
	BTST	#2,D4
	BEQ.S	GN_IFN8		+exp in D5
	SUB.W	D5,D3
	BRA.S	GN_IFN9
GN_IFN8	ADD.W	D5,D3
GN_IFN9	CMPI.W	#5000,D3
	BGT	GN_ER1	---->	exp>5000
	CMPI.W	#-5000,D3
	BLT	GN_ER1	---->	exp>-5000
;
; D1,D2 = input mantissa
;
	TST.L	D1
	BEQ.S	GN_IFN10		only in D2
	BFFFO	D1{0:32},D5         k free spaces
	LSL.L	D5,D1		move up to top of D1
	BFEXTU	D2{0:D5},D0         put k bits from top of D2 to D0
	OR.L	D0,D1		and insert in D1
	LSL.L	D5,D2		move up D2 k bits
	SUB.W	#63,D5		set true exponent(2)
	BRA.S	GN_IFN11
GN_IFN10	BFFFO	D2{0:32},D5         k free spaces
	BEQ	GN_IFN12
	LSL.L	D5,D2		move up
	MOVE.L	D2,D1
	MOVEQ	#0,D2
	SUB.W	#31,D5		set true exponent(2)
GN_IFN11	NEG.W	D5
;
; D5 = power of 2 (+-)
; D1:D2 = mantissa D1.31=1
; D3 = power of 10 (+-)
;
;	       A4      A2		   A3		 A1
;   BUF	       	     		   		  
;     _________________________________________________________
;    |0         |24	  |40	   |56   	67|
;      answer			   input mantissa
;
	TST.W	D3
	BPL.S	GN_IFN1
	NEG.W	D3
	LEA	FP_TM,A0		negative powers of 10
	BRA.S	GN_IFN2
GN_IFN1	LEA	FP_TP,A0		positive powers of 10
GN_IFN2	MOVEM.L	D4/D6-7/A1/A4,-(A7)
;
	MOVE.L	D1,56+BUF(A6)	set 1st mantissa
	MOVE.L	D2,60+BUF(A6)
	CLR.L	64+BUF(A6)
	LEA	68+BUF(A6),A1	address of input mantissa
	MOVE.L	D1,BUF(A6)
	MOVE.L	D2,4+BUF(A6)	set no -> BUF in case D3.W=0
	CLR.L	8+BUF(A6)
GN_IFN3	TST.W	D3
	BEQ	GN_IFN7		finished
	LEA	16(A0),A0 	step A0 to end of number
	LSR.W	#1,D3		look @ next power of 2
	BCC.S	GN_IFN3		not this one
;
;
; A0 -> end of power of ten for multiplication
;
	LEA	BUF(A6),A3
	MOVEQ	#13,D6		to clear 14 long words
GN_TEN1	CLR.L	(A3)+
	DBF	D6,GN_TEN1
;
; Choice between 40 & 60
;
	IF	VNUM=?"40"
	LEA	BUF+36(A6),A2	Model 40
	ELSE
	LEA	BUF+38(A6),A2	Model 60
	ENDIF
;
	LEA	BUF+24(A6),A4
	ADD.W	-16(A0),D5
	SUBI.W	#$3FFF,D5 	true exponent
;
	IF	VNUM=?"40"
;
; MODEL 40
;
	MOVEQ	#2,D4
GN_TEN2	MOVE.L	-(A1),D7		1st 'digit'
	MOVEQ	#2,D6
GN_TEN3	MOVE.L	D7,D0
	MULU.L	-(A0),D1:D0
	MOVE.L	D0,-(A3)		bottom
	MOVE.L	D1,-(A2)		top
	DBF	D6,GN_TEN3
	LEA	12(A0),A0 reset A0
	LEA	12(A3),A3 reset A3
	LEA	16(A2),A2 & A2 (+4)
	MOVEQ	#3,D6
	MOVE	#0,CCR		clear X
GN_TEN4	ADDX.L	-(A3),-(A2)
	DBF	D6,GN_TEN4
	LEA	16(A2),A2 	set to end of num
	MOVEQ	#3,D6
GN_TEN5	ADDX.L	-(A2),-(A4)	now add to result
	DBF	D6,GN_TEN5
	LEA	12(A4),A4 	reset A4 (less one long word)
	MOVEQ	#3,D6
GN_TEN6	CLR.L	(A2)+
	CLR.L	(A3)+
	DBF	D6,GN_TEN6	clear working space
	LEA	-4(A2),A2
	DBF	D4,GN_TEN2
;
	ELSE
;
; MODEL 60
;
	MOVEQ	#5,D4
GN_TEN2	MOVE.W	-(A1),D7		1st 'digit'
	MOVEQ	#5,D6
GN_TEN3	MOVE.W	D7,D0
	MULU.W	-(A0),D0
	MOVE.W	D0,-(A3)		bottom
	SWAP	D0
	MOVE.W	D0,-(A2)		top
	DBF	D6,GN_TEN3
	LEA	12(A0),A0 	reset A0
	LEA	12(A3),A3 	reset A3
	LEA	14(A2),A2 	& A2 (+2)
	MOVEQ	#6,D6
	MOVE	#0,CCR		clear X
GN_TEN4	ADDX.W	-(A3),-(A2)
	DBF	D6,GN_TEN4
	LEA	14(A2),A2 	set to end of num
	MOVEQ	#6,D6
GN_TEN5	ADDX.W	-(A2),-(A4)	now add to result
	DBF	D6,GN_TEN5
	LEA	12(A4),A4 	reset A4 (less one word)
	MOVEQ	#3,D6
	LEA	-2(A2),A2 	set A2 -> 24(BUF)
	LEA	-2(A3),A3 	set A3 -> 40(BUF)
GN_TEN6	CLR.L	 (A2)+
	CLR.L	(A3)+
	DBF	D6,GN_TEN6	clear working space
	LEA	-2(A2),A2
	DBF	D4,GN_TEN2
;
	ENDIF
;
; End of choice between 40 & 60
;
	LEA	BUF(A6),A4	set A4 to its start
	BTST	#7,(A4)
	BNE	GN_TEN7		don't move up
	LEA	24(A4),A4 	reset A4 to end
	MOVEQ	#5,D4		count of 6
	MOVE	#0,CCR
GN_TEN8	MOVE.L	-4(A4),(A2)+
	ADDX.L	-(A2),-(A4)
	DBF	D4,GN_TEN8
	CLR.L	(A2)
	SUBQ.W	#1,D5		adjust exponent
GN_TEN7	ADDQ.W	#1,D5
;
; A0 x A1 is in A4 : exponent in D5
;
; now set no in BUF+56
;
	LEA	BUF+56(A6),A1
	MOVEQ	#2,D6
GN_TEN9	MOVE.L	(A4)+,(A1)+
	DBF	D6,GN_TEN9
	BRA	GN_IFN3
;
FP_TM	DC.L	$3FFB0000,$CCCCCCCC,$CCCCCCCC,$CCCCCCCD 10^-1
	DC.L	$3FF80000,$A3D70A3D,$70A3D70A,$3D70A3D7 10^-2
	DC.L	$3FF10000,$D1B71758,$E219652B,$D3C36113 10^-4
	DC.L	$3FE40000,$ABCC7711,$8461CEFC,$FDC20D2A 10^-8
	DC.L	$3FC90000,$E69594BE,$C44DE15B,$4C2EBE65 10^-16
	DC.L	$3F940000,$CFB11EAD,$453994BA,$67DE18E7 10^-32
	DC.L	$3F2A0000,$A87FEA27,$A539E9A5,$3F2398CC 10^-64
	DC.L	$3E550000,$DDD0467C,$64BCE4A0,$AC7CB3D9 10^-128
	DC.L	$3CAC0000,$C0314325,$637A1939,$FA911122 10^-256
	DC.L	$395A0000,$9049EE32,$DB23D21C,$7132D2E4 10^-512
	DC.L	$32B50000,$A2A682A5,$DA57C0BD,$87A600A6 10^-1024
	DC.L	$256B0000,$CEAE534F,$34362DE4,$4925110F 10^-2048
	DC.L	$0AD80000,$A6DD04C8,$D2CE9FDE,$2DE37E46 10^-4096
;
FP_TP	DC.L	$40020000,$A0000000,$00000000,$00000000 10^1
	DC.L	$40050000,$C8000000,$00000000,$00000000 10^2
	DC.L	$400C0000,$9C400000,$00000000,$00000000 10^4
	DC.L	$40190000,$BEBC2000,$00000000,$00000000 10^8
	DC.L	$40340000,$8E1BC9BF,$04000000,$00000000 10^16
	DC.L	$40690000,$9DC5ADA8,$2B70B59D,$F0200000 10^32
	DC.L	$40D30000,$C2781F49,$FFCFA6D5,$3CBF6B71 10^64
	DC.L	$41A80000,$93BA47C9,$80E98CDF,$C66F336B 10^128
	DC.L	$43510000,$AA7EEBFB,$9DF9DE8D,$DDBB9018 10^256
	DC.L	$46A30000,$E319A0AE,$A60E91C6,$CC655C4B 10^512
	DC.L	$4D480000,$C9767586,$81750C17,$650D3D17 10^1024
	DC.L	$5A920000,$9E8B3B5D,$C53D5DE4,$A74D28B1 10^2048
	DC.L	$75250000,$C4605202,$8A20979A,$C94C14F7 10^4096
;
GN_IFN7 MOVEM.L (A7)+,D4/D6-7/A1/A4
	MOVE.L	BUF(A6),D1
	MOVE.L	BUF+4(A6),D2
	BTST	#7,BUF+8(A6)	guard bit
	BEQ	GN_IFN22		no rounding
	BTST	#6,BUF+8(A6)	round bit
	BNE	GN_IFN21		round
	BFTST	BUF+8(A6){2:30}     sticky bit
	BNE	GN_IFN21		round
	BTST	#0,D2		LSB (tie case)
	BEQ	GN_IFN22		don't round
GN_IFN21	ADDQ.L	#1,D2
	BCC	GN_IFN22		done
	ADDQ.L	#1,D1
	BCC	GN_IFN22		done
	MOVE.L	#$80000000,D1
	MOVEQ	#0,D2
	ADDQ.W	#1,D5		+1 to exponent
GN_IFN22	ADDI.W	#$3FFF,D5 	set D5 = biassed exponent
	BVS	GN_IFINF		infinity
	BMI	GN_IFZR		zero
	CMPI.W	#$7FFF,D5
	BEQ	GN_IFINF		infinity
	BTST	#1,D4
	BEQ.S	GN_IFN20		plus number
	BSET	#15,D5		set sign
GN_IFN20	LEA	BUF(A6),A0
	MOVE.W	D5,(A0)+		sign/exp 80-95
	CLR.W	(A0)+		zeros 64-79
	MOVE.L	D1,(A0)+		mantissa 32-63
	MOVE.L	D2,(A0)+		mantissa 0-31
GN_IFN23	MOVE.B	-1(A1),D4 	restore sep to D4
	BRA	GN_FP4
;
GN_IFN12	LEA	BUF(A6),A0	zero
GN_IFN25	CLR.L	(A0)+
	CLR.L	(A0)+
	CLR.L	(A0)+		set 0 to BUF
	BTST	#1,D4		sign
	BEQ.S	GN_IFN23		plus
	BSET	#7,BUF(A6)
	BRA	GN_IFN23
;
GN_IFINF	BSR	PR_W5		set warning
	LEA	BUF(A6),A0
	MOVE.L	#$7FFF0000,(A0)+
	BRA	GN_IFN25
GN_IFZR	PEA	GN_IFN12
	BRA	PR_W6		set warning
;
GN_REG	CMPI.B	#1,D3		only + allowed
	BNE	GN_ER47	---->
	TST.B	D6		must be sole
	BNE	GN_ER47	---->
	MOVE.L	VAL(A0),D2
	BFEXTU	D0{22:2},D1
	ADDQ.L	#4,D1
	NEG.L	D1		D1 = -5 or -6
	BRA	GN_FP8
;
; Altered -  13th July 2004
;
GN_SETQ	MOVEM.L	D0/A0,-(A7)
	BSET	#2,D6		mark EQU started
	MOVE.L	A5,D0
	BNE	GN_SETQ1		exists
	BSR	GN_GTL		get a link to A0
	BNE	GN_SETQ5	---->
	MOVEA.L	A0,A5		set A5
GN_SETQ1	MOVEA.L	A5,A2
GN_SETQ2	CMPI.L	#7,(A2)		space? . .
	BLT	GN_SETQ3		. . yes
	BEQ	GN_SETQ4		just full - get a new link
	MOVEA.L	(A2),A2		go to the next link
	BRA	GN_SETQ2
GN_SETQ4	BSR	GN_GTL		new link at A0
	BNE	GN_SETQ5	---->
	MOVE.L	A0,(A2)		set link in old chunk
	MOVEA.L	A0,A2		set A2 as the new chunk address
GN_SETQ3	MOVE.L	(A2),D0
	ADDQ.L	#1,(A2)		advance pointer
	MOVE.W	D3,4(A2,D0.W*4)	set 'op'
	MOVE.W	D1,6(A2,D0.W*4)	set 'label'
	MOVEQ	#0,D0
GN_SETQ5	MOVEM.L	(A7)+,D0/A0
	RTS

;	 PEA	 EQB(A6)
;	 BSET	 #2,D6
;	 BNE.S	 GN_Q
;	 PEA	 10		 space needed
;	 PEA	 0		 mark 'no relocation'
;	 BSR	 GSP		 ask for 10 bytes
;	 LEA	 12(A7),A7	 reset stack
;	 MOVEA.L	 EQB(A6),A5
;	 LEA	 6(A5),A5
;	 BRA	 GN_Q_1
;GN_Q	 SUB.L	 EQB(A6),A5
;	 MOVE.L	 A5,-(A7)
;	 ADDQ.L	 #4,(A7)		 ask for 4 more
;	 PEA	 0		 mark no 'relocation'
;	 BSR.S	 GSP
;	 LEA	 12(A7),A7	 reset stack
;	 ADD.L	 EQB(A6),A5	 reset pointer
;GN_Q_1	 MOVE.W	 D3,(A5)+
;	 MOVE.W	 D1,(A5)+
;	 RTS
;
GN_OT
	MOVEQ	#0,D1
	BTST	#2,D6		EQ list?
	BNE.S	GN_XX		yes
	BTST	#1,D6		Unknown LABEL?
	BEQ.S	GN_NOQ		no
	SWAP	D6
	MOVE.W	D6,D2		LABEL no -> D2
	SWAP	D6
	BTST	#3,D6
	BEQ.S	GN_OT2		not known PC
	MOVEQ	#2,D1		mark PC known
GN_OT2	BCLR	#15,D2		clear minus
	BEQ.S	GN_OT1
	BSET	#31,D2		set minus
	BRA.S	GN_OT1
;
; To set the EQU list
;  (Altered - 13th July 2004)
;
GN_XX
;	 PEA	 EQB(A6)
;	 SUB.L	 EQB(A6),A5	 length so far
;	 MOVE.L	 A5,D1
;	 ADDQ.L	 #2,D1		 total length needed
;	 MOVE.L	 D1,-(A7)
;	 PEA	 0		 mark no 'relocation'
;	 BSR	 GSP
;	 LEA	 12(A7),A7	 reset stack
;	 MOVE.L	 EQB(A6),A3	 start to A3
;	 ADDA.L	 A3,A5		 new pointer
;	 CLR.W	 (A5)+		 mark end of list
;	 MOVE.L	 D0,D4
;	 BSR	 NN_LG2		 get D1.L space
;	 EXG	 D0,D4		 replace D0.B and leave CCR
;	 BNE	 GN_ER3	 ---->
;
; A0 is the address of the EQU list proper
;
;	 MOVE.L	 D2,(A3)		 constant
;	 MOVE.L	 A0,D2		 'value'
;	 CLR.W	 4(A3)
;	 BRA	 GN_XX1
;GN_XX2	 SWAP	 D1
;GN_XX3	 MOVE.B	 (A3)+,(A0)+	 fill EQU list
;GN_XX1	 DBF	 D1,GN_XX3
;	 SWAP	 D1
;	 DBF	 D1,GN_XX2

	MOVEQ	#2,D1		initial ct
	MOVEA.L	A5,A2		pointer to op|label list
GN_XX1	BSR	GN_RTA		set pointer A2 as available
	CMPI.L	#7,(A2)		final chunk? . .
	BLE	GN_XX2		. . yes
	ADDQ.L	#7,D1		add 7 to ct
	MOVEA.L	(A2),A2		to next chunk
	BRA	GN_XX1
GN_XX2	ADD.L	(A2),D1		complete ct
	LSL.L	#2,D1		set the number of bytes needed (ct*4)
	MOVE.L	D0,D4		keep D0
	BSR	NN_LG2		A0 -> required space
	EXG	D0,D4		replace D0 and leave CCR unchanged
	BNE	GN_ER3	---->	Out of space!!!
	MOVE.L	D2,(A0)		set 'constant'
	MOVE.L	A0,D2		set 'value' as EQU pointer
	ADDQ.L	#4,A0		move to next item
	CLR.W	(A0)+		SPC = 0
	MOVEA.L	A5,A2		1st chunk
GN_XX6	CMPI.L	#7,(A2)+		more chunks? . .
	BGT	GN_XX3		. . yes
	MOVEQ	#-1,D4		mark "no more"
	MOVE.W	-2(A2),D4 	set the count (1 to 7)
	BRA	GN_XX4
GN_XX3	MOVEQ	#7,D4		a full chunk
	BRA	GN_XX4
GN_XX5	MOVE.L	(A2)+,(A0)+	set the 'op' then the 'label'
GN_XX4	DBF	D4,GN_XX5
	TST.L	D4		end? . .
	BMI	GN_XX7		. . yes
	MOVEA.L	-32(A2),A2	to next chunk
	BRA	GN_XX6
GN_XX7	CLR.W	(A0)		mark end of EQU list
;
	MOVEQ	#3,D1		mark EQU list
;
GN_NOQ	ADDQ.L	#1,D1
GN_OT1	MOVEM.L	(A7)+,GNREG
	ADDQ.L	#4,A7		adjust for the initial PEAs
	RTS
;
; At entry 4(A7) = 1,2 for relocation of new area = 0,-1 otherwise
;	 8(A7) = space needed
;	$C(A7) = pointer to pointer to area
;
GSP	MOVEM.L	D0/A1,-(A7)
	MOVE.L	$10(A7),D0	space needed
	MOVEA.L	$14(A7),A1	pointer to area
	TST.L	(A1)		Any space yet? . .
	BEQ	GSP2		. . no
	CMP.L	4(A1),D0		space needed? . .
	BLE	GSP1		. . no
GSP2	BSR	EXTENS		get it
GSP1	MOVEM.L	(A7)+,D0/A1
	RTS
;
; This gets the next separator if EXP is on (bit 6 of DIP)
;
; On entry to GN_NS3:
;	D1.W = count - 1
;	D1.L is negative for A1 to be reduced
;	A1 -> the next character in the instruction
;
; On exit:
;	Z is set if D1 is a separator
;	Else error
;	No regs used save D1.
;
GN_NS	MOVEQ	#-1,D1		mark "step A1 back" LA
	BRA	GN_NS1
GN_NS2	MOVEQ	#7,D1		count of 8	HX
	BRA	GN_NS3
GN_NS4	MOVEQ	#31,D1		count of 32	BI
	BRA	GN_NS3
GN_NS21	MOVEQ	#10,D1		coiunt of 11	OC
	BRA	GN_NS3
GN_NS5	MOVEQ	#0,D1		ASC, DE
GN_NS1	MOVE.W	#BUF_SIZE-1,D1
;
GN_NS3	BTST	#6,DIP(A6)
	BEQ	GN_NS11 Not	EXPRESSION
	BSET	#15,D7		mark 1st time been
	BEQ	GN_NS11
	MOVEM.L	D0/A1,-(A7)
	CMPI.W	#32,D1
	BGT	GN_NS9
	CMPI.B	#'+',(A1)
	BEQ	GN_NS10
	CMPI.B	#'-',(A1)
	BNE	GN_NS9
GN_NS10	ADDQ.L	#1,A1		skip +, -
GN_NS9	TST.L	D1
	BPL	GN_NS6		A1 OK
	SUBQ.L	#1,A1
GN_NS6	MOVE.B	(A1)+,D0
	BSR	TST_SEP
	DBEQ	D1,GN_NS6
	BNE	GN_NS7
	CMPI.B	#'<',D0
	BEQ	GN_NS8		Could be <<
	CMPI.B	#'>',D0
	BEQ	GN_NS8		Could be >>
	SUBQ.L	#1,A1		Step back for comparison
GN_NS8	CMP.B	(A1),D0
	EXG	D0,D1
GN_NS7	MOVEM.L	(A7)+,D0/A1
	BEQ	GN_NS12
GN_NS11	RTS
GN_NS12	BSR	GN_COMPT
	BGE	GN_NS11
	ADDQ.L	#4,A7
	MOVE.L	D2,-(A7)
	BSR	GNUMA
GN_NS13	MOVE.L	D2,D5		set value to D5
	MOVE.L	(A7)+,D2
	SUBQ.W	#1,D1
	BEQ	GN_HX1		set the [ . . ] number in the stream.
	SUBQ.W	#3,D1
	BNE	GN_ER1	---->	only EQU lists allowed here
	BSR	GN_DUMQ		set a dummy label for the EQU list
	MOVE.B	D0,D4
	BRA	GN_L2
;
; To find the operator after (....)
;
GN_NS14	BTST	#6,DIP(A6)
	BNE	GN_NS20
	ADDQ.L	#4,A7		Error - only EXP_ON allowed here
	BRA	GN_ER1	---->
GN_NS20	BSET	#15,D7		1st time? . .
	BEQ	GN_NS11		. . yes
	MOVEM.L	D0/A1,-(A7)
	MOVE.W	#256,D1		fail safe
	MOVE.L	D6,-(A7)
	MOVEQ	#1,D6		keep count of "("
GN_NS15	MOVE.B	(A1)+,D0		next character
	CMPI.B	#10,D0		LF?
	BEQ	GN_NS18	---->
	CMPI.B	#")",D0
	BNE	GN_NS16
	SUBQ.W	#1,D6		count down "()"
	BEQ	GN_NS19		end of (....)
GN_NS16	CMPI.B	#"(",D0
	BNE	GN_NS17
	ADDQ.W	#1,D6		another (...)
GN_NS17	DBF	D1,GN_NS15
GN_NS18	LEA	16(A7),A7 	adjust stack
	BRA	GN_ER1	---->

GN_NS19	MOVE.B	(A1),D1		separator
	MOVE.L	(A7)+,D6
	MOVEQ	#0,D0		set Z
	BRA	GN_NS7

;
; GN_COMPT returns "LT" if we need [
; D1 contains the next separator returned by GN_NS
;
GN_COMPT
	MOVEM.L	D1-2,-(A7)
	MOVE.B	OP_TY+3(D3.W),D2
	SUBI.W	#'!',D1
	BLT	GN_COMPT1
	CMPI.W	#'>'-'!',D1
	BGT	GN_COMPT1
	MOVE.W	SP_TY(D1.W*2),D1
	BRA	GN_COMPT2
GN_COMPT1 MOVEQ	#-1,D1
GN_COMPT2 CMP.B	D1,D2
	MOVEM.L	(A7)+,D1-2
	RTS
;
; GN_CT compares the new operator with the one preceding [
; The old operator value was in D3 now stored on the stack
;
GN_CT	MOVEM.L	D1-2,-(A7)
	MOVE.B	OP_TY+3(D3.W),D2	new operator's precedence
	MOVE.L	12(A7),D1 	old D3
	CMP.B	OP_TY+3(D1.W),D2
	MOVEM.L	(A7)+,D1-2
	RTS
;
OP_TY	DC.B	10,10,0,10,0,1,2,2,3,3,1
SP_TY	DC.W	2,-1,-1,-1,-1,2
	DC.W	-1,-1,-1,1,0,-1,0
	DC.W	-1,1,-1,-1,-1,-1,-1,-1
	DC.W	-1,-1,-1,-1,-1,-1
	DC.W	3,-1,3
;
; ******	 EQU lists   ******
;
; The area at EQB(A6) is used to hold a number of addresses of areas
; which can be used in building up EQU lists during GNUM.
;
; GNUM is now recursive so that each new call must initiate a new area
; for this purpose.
;
; The format of EQB(A6) is:
;
;    W	  L     L 	   L
;  __________________________________
; |  k  |  a1  |  a2  | . . . |  ak  |
;
;  k is the number of addresses a1, a2 etc
;  Each address points to a 32-byte area which can be used by GNUM.
;  When an address is allocated the top bit of "ai" is set. This is
;  cleared when the area is no longer needed by GNUM.
;
;  The initial value of k is 0. If an address is needed, EQB is extended
;  by GSP. Each extension adds 15 more addresses to the list.
;
;  Each extension sets up a 480-byte area divided into 15 32-byte
;  sub-areas whose addresses are held in EQB.
;
;  The sub-areas so formed will contain all the "op"/"label" pairs needed
;  in the final EQU list in the format:
;
;     L	    L	  L
;  _______________________________________
; |   t	|  pr1  |  pr2  | . . . |  prn  |
;
;  t is either the number of "op"/"label" pairs (pr1, pr2 etc) or
;  the pointer to a further chunk containing more pairs.
;
; Two routines operate this system:
;	GN_GTL returns the address of a sub-area.
;	GN_RTA resets an area to "available".
;
;  When GN_GTL returns the address of a sub-area the first long word
;  has been zeroed to show it empty.
;
; ***************************
;
;
; To set the EQB address A2 as available
;
; On entry A2 = address in EQB list used in EQU list
; No registers are used
;
;
GN_RTA	MOVEM.L	D0-1/A0,-(A7)
	MOVE.W	([EQB,A6]),D0	number of addresses
	LEA	([EQB,A6],2),A0	-> 1st address
	BRA	GN_RTA1
GN_RTA2	MOVE.L	(A0)+,D1		address to D1
	BCLR	#31,D1		make it positive
	BEQ	GN_RTA1		it was, so try the next
	CMP.L	D1,A2		is this the address? . .
	BEQ	GN_RTA3		. . yes
GN_RTA1	DBF	D0,GN_RTA2	go through all addresses
	BRA	GN_RTA4		not found!!!
GN_RTA3	MOVE.L	D1,-4(A0) 	reset positive address
GN_RTA4	MOVEM.L	(A7)+,D0-1/A0
	RTS
;
; GN_GTL sets the address of a 32-byte area to A0
;
; No other registers are used
;
GN_GTL	MOVEM.L	D1/A1-2,-(A7)
	TST.L	EQB(A6)		Any addresses? . .
	BNE	GN_GTL8		. . yes
	MOVEQ	#15,D1		prepare for 1st extension
	SUBA.L	A2,A2		set 0 in A2 for no addresses
	BRA	GN_GTL9
GN_GTL8	MOVE.W	([EQB,A6]),D1	set the count of addresses . .
	MOVEA.W	D1,A2		. . and in A2
	SUBQ.W	#1,D1		(there must be at least one!)
GN_GTL2	TST.L	([EQB,A6],D1.W*4,2) available? . .
	DBPL	D1,GN_GTL2	. . not yet
	BPL	GN_GTL3		found
	MOVEQ	#15,D1
	ADD.W	([EQB,A6]),D1	new count
GN_GTL9	LSL.L	#2,D1
	ADDQ.L	#2,D1		new space needed
	PEA	EQB(A6)
	MOVE.L	D1,-(A7)
	PEA	0
	BSR	GSP		extend EQB as requested
	LEA	12(A7),A7 	reset stack
;
; Now we must fill the space with addresses
;
	MOVEQ	#15,D1
	LSL.L	#5,D1		480 (15 32-byte areas)
	BSR	NN_LG2		A0 -> space needed
	BNE	GN_GTL7	---->
	MOVE.L	A2,D1		old count of addresses
	MOVE.W	A2,([EQB,A6])	set old count in new space
	LEA	([EQB,A6],D1.W*4,2),A1  A1 -> start of new space
	MOVEQ	#15,D1		to count 15 addresses
	ADD.W	D1,([EQB,A6])	set new count
	LEA	480(A0),A2	point to END of area
	BRA	GN_GTL4
GN_GTL5	LEA	-32(A2),A2	decrease pointer by 32
	MOVE.L	A2,(A1,D1.W*4)	set address in EQB
GN_GTL4	DBF	D1,GN_GTL5
	BSET	#7,(A1)		mark "used"
GN_GTL6	CLR.L	(A0)		set initial pointer to 0
GN_GTL7	MOVEM.L	(A7)+,D1/A1-2
	RTS
GN_GTL3	MOVEA.L	([EQB,A6],D1.W*4,2),A0
	BSET	#7,([EQB,A6],D1.W*4,2)
	BRA	GN_GTL6

GN_ER1
GN_EROT	MOVEQ	#-1,D1
	BRA	GN_OT1
GN_EROT1	MOVEQ	#-2,D1
	BRA	GN_OT1
;
GN_ER50	MOVEQ	#50,D1
	BRA	GN_ER
GN_ER5	MOVEQ	#5,D1
	BRA	GN_ER
GN_ER47	MOVEQ	#47,D1
	BRA	GN_ER
GN_ER11	MOVEQ	#11,D1
	BRA	GN_ER
GN_ER2	MOVEQ	#2,D1
	BRA	GN_ER

GN_Q2	BSR	GN_EQ1
	BNE	GN_ER3	---->
GN_Q1	BSR	GN_SETQ
	BEQ	GN_L3

GN_ER3	MOVEQ	#3,D1
GN_ER	BSR	DO_ERR
	BRA	GN_EROT
;
; **********
; *  E A	 *     A5 is the current PC
; **********
; At entry EA:-  A6 -> DATA SPACE
;	       A1 -> 1st character of Effective Address
;	       D0.B is the preceding char
;
;
; At entry EA1:- A1 -> 2nd character of Effective Address
;	       D0.B is the 1st character of EA
;
;	       D7.W marks the EA modes allowed.
;	       Each bit from 0 to 11 represents a mode.
;	       If the bit is 0 the mode is allowed.
;
;	Bit  Addressing Mode  Mode Register  ............................
;				       .	    F_EA		    .
;	  0	Dn	   000	 -     .			    .
;	  1	An	   001	 -     . Bit 0 set = jump [EXT]   .
;	  2	(An)	   010	 -     .	   1     = 2nd EA	    .
;	  3	(An)+	   011	 -     .	   2     = pass all seps.
;	  4	-(An)	   100	 -     .	   3 - 5 see EA_EXIT1   .
;	  5	d(An)	   101	 -     .	(*)7     = signed W-test.
;	  6	d(An,Xn.S)   110	 -     ............................
;	  7	Abs short    111	000    .	    PCK		    .
;	  8	Abs long	   111	001    . (set in EA)	    .
;	  9	n(PC)	   111	010    . Bit 0 set = FP immediate .
;	 10	n(PC,Xn.S)   111	011    .	   1 set = ZPC / var ABS.
;	 11	#d	   111	100    .	   2 set = w -> 1 INS   .
;				       .	   3 set = w -> 3 . 7   .
;      Bits 12 -14 represent SR, CCR and USP   .	   4 set = ABS/PC var   .
;      If bit 15 is set MODE/REG will be       ............................
;      set in D5			       (*) F_EA bit 7 is 0 for MOVEM
;						 and 1 for FMOVEM
; At exit:-    D0.B is the separator ("," SPACE or ENTER)
;	     A1 -> the next character
;	     D1.L is the extension word (if any)
;	      ________________________________
;	     |.|reg no|.|0 0 0|constant       |
;	     |_|_____ |_|_____|_______________|
;	      	     
;	      0=D      0=W
;	      1=A      1=L
;
; Any extension words are put into OBUF
;
;
;					 Bit6 mode reg
;	         9 8      6    3    0
;	 ____________________________ 	 SR 0 111  101
;  D2.W = |_______|____|__|__|____|____|	CCR 0 111  110
;		      	mode reg		USP 0 111  111
;		|      0 (except for FP/ACC)	FPn 1 001  nnn
;		0= no {ext}                  FPCR 1 111  101
;		1= 1 extension word          FPSR 1 111  110
;		2= 2 extension words        FPIAR 1 111  111
;			F_EA bit 6 ON      ACCn 1 010  nnn
;			 (ColdFire)        MASK 1 011  000
;				        MACSR 1 100  000
;
;  D5.W is set if #d3, d4 or d8 is encountered
;     d3 -> bits 9-11
;     d4 -> bits 0- 3
;     d8 -> bits 0- 7
;
;  A5 is advanced to take account of [ext]
;
EA	MOVE.B	(A1)+,D0
EA1	MOVE.L	A7,EA_STK(A6)	keep A7 for ERRORs
	MOVEM.L	D3/D4/D6/A0/A2-4,-(A7)
	LEA	EXTBUF+4(A6),A0
	MOVE.L	A0,-4(A0) 	reset EXTBUF
	MOVEA.L	A1,A4		keep pointer
	MOVE.B	D0,D4		and character
	CMPI.B	#"(",D0
	BNE	EA_L2
	CMPI.B	#'[',(A1)
	BEQ	EA_IND		"([" -> indirection
	CMPI.B	#")",(A1)
	BEQ	EA_6_K4		"()" -> zero address
	CMPI.B	#'-',(A1)
	BEQ.S	EA_L3		must be number
	MOVEQ	#16,D1
	BSR	EA_GTR
	BPL	EA_L5
	ADDQ.L	#1,D1
	BEQ	EA_L6		not a reg
	BRA	EA_ER1	---->	bad string
EA_L5	MOVE.L	D1,D4
	SWAP	D4
	TST.W	D4		size
	BNE	EA_L8		size exists
	SUBQ.W	#8,D1
	BRA	EA_236
;
EA_L8	MOVEQ	#1,D6
	MOVEQ	#0,D2
	EXG	D1,D4
	SUBQ.W	#1,D1
	BEQ	EA_SEV2
	MOVEQ	#4,D1		set L
	BRA	EA_SEV2
;
EA_L6	MOVEA.L	A4,A1		reset pointer
	MOVE.B	D4,D0
EA_L3	BTST	#6,DIP(A6)	EXP_ON? . .
	BEQ	EA_L7		. . no
	BSR	EA_BR
	BEQ.S	EA_L10		"(" presaged an expression
EA_L7	BSR	GNUM
	TST.L	D1
	BMI	EA_ER1	---->
	CMPI.B	#",",D0
	BNE.S	EA_L4		not (d,
	CMPI.B	#",",(A1)
	BEQ	EA_6_1_5		(d,,
	BRA	EA_567		(d, = d(
EA_L4	CMPI.B	#")",D0
	BNE	EA_ER16	---->
	CMPI.B	#".",(A1)
	BNE	EA_6_1_4		(d)
	MOVE.B	(A1)+,D0		get next character (.)
	BRA	EA_S701		(d).
EA_L2	CMPI.B	#"-",D0
	BNE.S	EA_L1
	CMPI.B	#"(",(A1)
	BEQ	EA_4
	BRA.S	EA_NUM
EA_L1	MOVE.B	D0,D4
	CMPI.B	#"#",D0
	BEQ	EA_74
	MOVEA.L	A1,A0
	BSR	STRG1
	BMI	EA_ER13
	MOVEQ	#32,D1
	BTST	#6,F_EA(A6)	NEW
	BEQ	EA_L14		not ACC NEW
	ADDI.W	#63-32,D1 	allow ACC etc NEW
EA_L14	MOVEM.L	A0/A1,-(A7)
	LEA	D_LIST,A0
	MOVEA.L	A2,A1
	BSR	FIND1		look for Dn, An, SR etc FPn and FPcr
	MOVEM.L	(A7)+,A0/A1
	BPL	EA_01
EA_L9	MOVEA.L	A0,A1
	MOVE.B	D4,D0
EA_L10	BSR	GNUM1
	CMPI.B	#-6,D1		reg? . .
	BNE	EA_NUM1		. . no
	MOVE.W	D2,D1
	BRA	EA_01
;
EA_NUM	BSR	GNUM1
EA_NUM1	TST.L	D1
	BMI	EA_RG		could be reg list (-5)
	CMPI.B	#"(",D0
	BEQ	EA_567
	CMPI.B	#".",D0
	BEQ	EA_S701
	CMPI.B	#1,D1
	BEQ	EA_70_71
	BTST	#1,F_EA(A6)
	BNE.S	EA_L12		2nd <ea>
EA_L13	BFEXTU	D7{21:4},D3         is ABS allowed & PC not? ...
	CMPI.B	#12,D3
	BNE	EA_L11		... no
EA_L12	MOVE.B	D1,D6		type of number
	BRA	EA_S701A
EA_L11	MOVE.W	#$228,D3		set up for INS/DL
	CMPI.B	#4,D1
	BNE	EA_ZERO
	BSET	#4,PCK(A6)	suppress dummy label type
	BSR	EA_DL
EA_ZL2	MOVE.W	#$170,D1		[EXT]1
	MOVE.L	#$33B,D2		mode/reg 7(3)
	BRA	EA_EXIT
;
; reg list?
;
EA_RG	BFEXTU	F_EA(A6){2:3},D3
	CMPI.B	#7,D3		reg list? . .
	BNE	EA_ER1		. . no	---->
	TST.B	F_EA(A6)		FMOVEM? . .
	BMI	EA_RG1		. . yes
	ADDQ.L	#5,D1		get ready for 'reg list' test
	BRA	EA_RG2
EA_RG1	ADDQ.L	#7,D1		"         "
EA_RG2	BNE	EA_ER1		not reg list ---->
	MOVE.W	D2,D1
	MOVE.W	#$13C,D2
	BRA	EA_EX
;
EA_6_1_4	CMPI.B	#2,D1
	BEQ	EA_ER17	---->
	MOVE.W	#$200,D3
	CMPI.B	#1,D1
	BEQ.S	EA_6_K		N
	BMI.S	EA_6_L1		unknown LABEL
	BSR.S	EA_DL
EA_6_L2	MOVE.L	#$330,D2
	MOVE.W	#$1F0,D1
	BRA	EA_EXIT2
EA_6_L1	BSR	SET_LN
	BRA.S	EA_6_L2
EA_6_K	TST.L	D2
	BEQ	EA_6_K3		Zero address
	BSR	CMP_W1
	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BPL.S	EA_6_K1
	MOVE.L	D2,(A0)+		constant -> [EXT]
	MOVE.L	#$230,D2
	MOVE.W	#$1F0,D1
	BRA.S	EA_6_K2
EA_6_K4	MOVE.B	(A1)+,D0		set D0 = ")", A1 -> next
EA_6_K3	MOVE.L	#$130,D2		1 ext wd mode/reg 110 000
	MOVE.W	#$1D0,D1
	BRA	EA_EXIT2
EA_6_K1	MOVE.W	D2,(A0)+
	MOVE.L	#$330,D2
EA_6_K5	MOVE.W	#$1E0,D1
EA_6_K2	MOVE.L	A0,(A4)
	BRA	EA_EXIT2
;
;   n(PC) or ABS
; Set LAB to PC & set up INS
;
EA_ZERO

; New bit for JMP/JSR.L
; Here if J_SIZE <> 0 D1.B = 1 or 2 for W or L

****************************

	TST.L	J_SIZE(A6)	JSR/JMP.L or .W?
	BEQ	EA_ZERO1		. . no
	MOVE.W	D1,D6		set GNUM type to D6
	MOVE.B	J_SIZE(A6),D1	set D1,W 1 or 2
	BRA	EA_S701B		Treat as (label).L or .W
EA_ZERO1

****************************

	SWAP	D3
	MOVE.W	D2,D3
	BSR.S	EA_INS
	BRA	EA_ZL2
;
; For entry EA_DL:- D3.W = INS Type (GNUM type 4) w'out sign set
;	 and bits 8-9 contain the no of extra [EXT] words (NE)
;		         _________________
; For entry EA_INS:- D3.L = |INS Type | LAB No|
;
EA_DL	SWAP	D3
	BSR	SDUM		do dummy label
	BMI	EA_ER12	---->
	MOVE.L	D2,D1
	BCLR	#31,D1		clear sign bit
	MOVE.L	D1,VAL(A0)
	MOVE.W	#8,TYPE(A0)	prepare for EQU only
	BCLR	#4,PCK(A6)	set only for ABS/PC
	BNE	EA_INS
	TST.B	REL_SWTCH(A6)
	BEQ	EA_INS10		normal
	BRA	EA_INS
EA_INS10	MOVE.W	#9,TYPE(A0)	set EQlist|N
	BTST	#19,D3		PC?
	BEQ.S	EA_INS		no
	ADDQ.W	#1,TYPE(A0)	set to PC
EA_INS	SWAP	D0
	SWAP	D3
	MOVE.W	D3,D0
	EXT.W	D3		clear NE
	MOVE.L	A5,-(A7)		keep PC
	BTST	#0,F_EA(A6)
	BEQ.S	EA_INS6
	ADDQ.L	#2,A5		leap 1st [EXT]
EA_INS6	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	LSR.W	#8,D0
	BNE.S	EA_INS3		[EXT]
	BTST	#7,F_EA(A6)	signed test? ...
	BEQ	EA_INS5		... no
	MOVE.B	#4,D0		to set bit 2 of INSERT
	BRA	EA_INS5
EA_INS4	CLR.W	(A0)+
EA_INS3	DBF	D0,EA_INS4
	MOVE.L	A0,(A4)		update EXTBUF pointer
	BTST	#1,F_EA(A6)
	BEQ.S	EA_INS8
	BSET	#6,D3		set m
EA_INS8	BCLR	#0,PCK(A6)
	BEQ.S	EA_INS11		not FP immediate data
	CLR.B	D0
	BRA	EA_INS5
EA_INS11	MOVE.W	D3,D0
	ANDI.W	#7,D0
	ADD.W	D0,D0
	ADDA.W	D0,A5
	ADDQ.L	#2,A5		go past [EXT]1
	MOVE.B	D3,D0
	ANDI.B	#56,D0
	CMPI.B	#32,D0
	BNE.S	EA_INS7		not n(An)
	MOVE.B	#$86,D0
	BRA.S	EA_INS5
EA_INS7	BCLR	#1,PCK(A6)	ZPC or  Var ABS? . . .
	BEQ.S	EA_INS9		. . .    no
	TST.B	D0
	BEQ	EA_INS14
	MOVE.B	#$8C,D0		ZPC
	BRA.S	EA_INS5
EA_INS14	MOVE.B	#$8A,D0		Var ABS
	SUBQ.L	#2,A5		no [EXT]1 to jump over
	BRA	EA_INS5
EA_INS9	MOVE.B	#$84,D0		VAR INS code
EA_INS5	BSR	GBINS
	MOVEA.L	BINS(A6),A4
	MOVEA.L	(A4),A0		NEW
	MOVE.L	A5,2(A0)		NEW
;	 MOVE.L	 A5,(A0)+ 	 PC
	MOVEA.L	(A7)+,A5		restore PC
	OR.B	D0,(A0)		NEW
;	 OR.B	 D0,-4(A0)
	SWAP	D0
	SWAP	D3
;	 MOVE.W	 D3,(A0)+ 	 LAB No
	MOVE.W	D3,6(A0)		NEW
	SWAP	D3
	BTST	#31,D2
	BEQ.S	EA_INS2
	BSET	#7,D3
EA_INS2	BTST	#2,PCK(A6)	set w? . . .
	BEQ	EA_INS12		. . . no
	BFEXTU	PCK(A6){3:3},D2
	BFINS	D2,D3{21:3}         set w
	CLR.B	PCK(A6)
	MOVE.L	A1,-(A7)
;	 LEA	 -20(A0),A1
	LEA	-16(A0),A1	NEW
	CMPA.L	A1,A4
	BLE	EA_INS16		there is a previous INS
	MOVE.L	-4(A4),D2 	address of previous chunk
	BEQ	EA_INS15		no previous chunk
	LEA	([8,D2.L],-8),A1	set to previous INS - 4
EA_INS16	MOVE.W	CRT_SEC(A6),D2
;	 CMP.W	 12(A1),D2	 same section? . .
	CMP.W	14(A1),D2 	NEW
	BNE	EA_INS15		. . no
;	 BFEXTU	 4(A1){8:24},D2      PC
	MOVE.L	6(A1),D2		NEW
	CMP.L	PC_NOW(A6),D2
	BLT	EA_INS15		use *
	MOVE.L	D2,-6(A1) 	use previous PC
	BRA	EA_INS13
;EA_INS15  MOVE.L	 PC_NOW(A6),-6(A0)
EA_INS15	MOVE.L	PC_NOW(A6),2(A0)	NEW
EA_INS13	MOVEA.L	(A7)+,A1
;EA_INS12  MOVE.W	 D3,(A0)+ 	 INS Type
EA_INS12	MOVE.W	D3,8(A0)		NEW
	LEA	10(A0),A0 	NEW
	MOVE.W	CRT_SEC(A6),(A0)+
	MOVE.L	A0,(A4)
	MOVEQ	#0,D2		ready for EA output
	RTS
;
; SET_LN sets type label to 'N' unless REL_SWTCH is on
;
SET_LN	SWAP	D3
	MOVE.W	D2,D3
	TST.B	REL_SWTCH(A6)
	BNE	EA_INS
	MOVE.W	D2,D1
	BSR	LNPTR
	ORI.W	#1,TYPE(A0)
	BRA	EA_INS
;
;  DO_SIZE sets D1.W = -1 mistake
;		0 B
;		1 W
;		2 L
;
;  DO_SIZEF sets D1.W as for DO_SIZE and in addition
;		 11 S
;		 12 D
;		 13 X
;
; At entry	   At exit
;   ____________________   _____________________
;  |	|.| | |	      |	|.| | | |
;	 		 
;      D0.B |	       D0.B |
;	  A1		  A1
;
DO_SIZEX	MOVEQ	#13,D1		to allow S, D, X
	BRA	DO_SIZE1
DO_SIZEQ	MOVEQ	#19,D1		to allow S, D, X, P and Q
	BRA.S	DO_SIZE1
DO_SIZEF	MOVEQ	#14,D1		to allow S, D, X and P
	BRA.S	DO_SIZE1
DO_SIZE	MOVEQ	#2,D1		to allow only B, W and L
DO_SIZE1	SWAP	D1
	MOVE.B	(A1)+,D1		B, W or L
	BCLR	#5,D1		make upper case
	MOVE.B	(A1)+,D0		'Sep' to D0.B
	MOVEM.L	A0-1,-(A7)
	LEA	ITEM(A6),A1
	MOVE.B	D1,2(A1)
	LEA	SIZE_LST,A0
	SWAP	D1		sets count to 2, 14 or 19
	BSR	FIND
	MOVEM.L	(A7)+,A0-1
	RTS
;
SIZE_LST	DC.W	1
	DC.B	"B"		0
	DC.W	1
	DC.B	"W"		1
	DC.W	1
	DC.B	"L"		2
	DC.L	0,0,0,0		create 8 ""
	DC.W	1
	DC.B	"S"		11
	DC.W	1
	DC.B	"D"		12
	DC.W	1
	DC.B	"X"		13
	DC.W	1
	DC.B	"P"		14
	DC.L	0,0		create 4 ""
	DC.W	1
	DC.B	"Q"		19
;
; DO_SCALE sets 0,1,2 or 3 to bottom of D1 or ---->
;
DO_SCALE	MOVE.B	(A1)+,D0
	SUBI.B	#$30,D0		get 1 to 4
	SWAP	D1
	MOVE.W	#3,D1
DO_SC1	LSR.B	#1,D0
	DBCS	D1,DO_SC1
	BCC	EA_ER34	---->
	TST.B	D0
	BNE	EA_ER34	---->
	MOVEQ	#3,D0
	SUB.W	D1,D0
	SWAP	D1
	ADD.W	D0,D1
	MOVE.B	(A1)+,D0
	RTS
;
; The CMP_ routines set CCR N if D2.L is outside the range.
;  All tests are 'unsigned/signed' except CMP_B1 and CMP_W1
;  which are 'signed'.
;
CMP_S	TST.L	4(A2)
	BNE.S	CMP_WR
CMP_D	TST.L	(A2)
	BNE.S	CMP_WR
	BRA.S	CMP_OK
CMP_B1	CMPI.L	#128,D2
	BRA.S	CMP_B2
CMP_B	CMPI.L	#256,D2
CMP_B2	BGE	CMP_WR
	CMPI.L	#-128,D2
CMP_1	BLT.S	CMP_WR
CMP_OK	ANDI	#$17,CCR
CMP_EX	RTS
CMP_WR	ORI	#8,CCR
	RTS
CMP_W1	CMPI.L	#32768,D2
	BRA.S	CMP_W2
CMP_W	CMPI.L	#65536,D2
CMP_W2	BGE.S	CMP_WR
	CMPI.L	#-32768,D2
	BRA.S	CMP_1
CMP_d3	CMPI.L	#8,D2
CMP_3	BGT.S	CMP_WR
	CMPI.L	#1,D2
	BRA.S	CMP_1
CMP_d4	CMPI.L	#15,D2
CMP_2	BGT.S	CMP_WR
	CMPI.L	#0,D2
	BRA.S	CMP_1
CMP_d5_0	CMPI.L	#31,D2
	BRA.S	CMP_2
CMP_d3_0	CMPI.L	#7,D2
	BRA.S	CMP_2
CMP_d5_1	CMPI.L	#32,D2
	BRA.S	CMP_3
;
; EA_GTRL   RGL   D2-3/A0/A2
;
; To set register and size in D1
;
; Entry: D1.W = count for FIND (Negative for Ry.US - ColdFire) For U only D1.31=0 for scale factor too D1.31=1
;  For EA_GTR	A1 -> 1st character
;  For EA_GTR_1 A1 -> 2nd character
;
; Exit:  D0 = separator,  A1 -> next character
;  If D1.L positive
;   D1.L = size/US | register
;    size = 0 if no size, 1 if W and 2 if L
;    U/S	= total of U, L, S, B (L=0 U=1 S=6 B=2)
;  Else
;   D1.L = -1 if 'not found', -2 if 'bad string'
;
EA_GGR	REG	D2-6/A0/A2-3
EA_GTR_1	SUBQ.L	#1,A1
EA_GTR	MOVEM.L	EA_GGR,-(A7)
	MOVEQ	#1,D4
	MOVEQ	#2,D6		to take off .W etc
	MOVEQ	#0,D5		to allow byte -> word for comparison
	TST.W	D1		type of entry
	BPL	EA_GTR8		ordinary
	NEG.W	D1
	LEA	EA_TS,A3
	TST.L	D1
	BPL	EA_GTR9
	MOVEQ	#3,D4
	BRA	EA_GTR9
EA_GTR8	LEA	EA_TW,A3
EA_GTR9	BSR	STRG
EA_GTR7	BMI	EA_GTRE2	  ---->
	MOVEQ	#0,D2		mark no size
	MOVE.W	(A2),D3		length of string
	BEQ	EA_GTRE1	---->
	CMPI.W	#3,D3		was 1	NEW
;	 BLT	 EA_GTRE1    ---->
	BLT	EA_GTR1		can't be size       NEW
;	 BEQ	 EA_GTR6		 length 1, can only be label
	CMPI.B	#'.',(A2,D3.W)	possible size? . .
;	 BNE	 EA_GTR1		 . . no
	BNE	EA_GTR6		possible U/S	NEW

	MOVE.B	1(A2,D3.W),D5	letter for comparison	NEW
EA_GTR2	CMP.W	2(A3,D4.W*4),D5
	DBEQ	D4,EA_GTR2

;	 CMPI.B	 #'W',1(A2,D3.W)
;	 BEQ	 EA_GTR2
;	 CMPI.B	 #'L',1(A2,D3.W)
	BNE	EA_GTR4		not size

	MOVE.W	(A3,D4.W*4),D2	set value
;	ADDQ.W	#1,D2		mark L
;EA_GTR2	 ADDQ.W	 #1,D2		 mark W
;	SUBQ.W	#2,(A2)		prepare to FIND reg
	SUB.W	D6,(A2)		cut off ".size"	NEW
;
; search D_LIST, given D1
;
EA_GTR1	LEA	D_LIST,A0
	EXG	A2,A1
	BSR	FIND1		get regs (sp -> A7)
	EXG	A2,A1
	BMI	EA_GTR4		not found - try label
;
EA_GTR3	MOVE.B	-1(A1),D0 	replace sep
	SWAP	D1
	MOVE.W	D2,D1		set size
	SWAP	D1		sets cond codes
	MOVEM.L	(A7)+,EA_GGR
	RTS
;
EA_GTR6	BTST	#31,D1		ordinary size or just U/L? . .
	BEQ	EA_GTR1		. . yes
	CMPI.B	#'.',-1(A2,D3.W)	scale factor etc? . .
	BNE	EA_GTR1		. . no
	MOVEQ	#3,D4		2nd count
	LEA	EA_TSU,A3 	2nd comparison set
	MOVEQ	#3,D6		set to take off ".LS" etc.
	MOVE.W	(A2,D3.W),D5	set 2 characters for comparison
	BRA	EA_GTR2

EA_GTR4	CMPI.W	#32,(A2)
	BGT	EA_GTRE1	  ---->
	BSR	NLAB_NO		get label number
	BNE	EA_GTR5		not found
	BFEXTU	TYPE(A0){6:2},D3
	CMPI.B	#2,D3		reg? . .
	BNE	EA_GTR5		. . no
	MOVE.L	VAL(A0),D1	reg no to D1
	BRA	EA_GTR3		done!
;
EA_GTR5	TST.W	D2
	BEQ	EA_GTRE1	  ---->	fail
;
; Now try whole item (including .W/L)
;
	ADDQ.W	#2,(A2)		reset count
	MOVEQ	#0,D2		set size to 'none'
	BRA	EA_GTR4
;
EA_GTRE1	MOVEQ	#-1,D1
EA_GTRE3	MOVEQ	#-1,D2
	BRA	EA_GTR3
;
EA_GTRE2	MOVEQ	#-2,D1
	BRA	EA_GTRE3

EA_TW	DC.B	0,2,0,'L',0,1,0,'W'
EA_TS	DC.B	0,0,0,'L',0,1,0,'U',0,6,0,'S',0,2,0,'B'
EA_TSU	DC.W	7,'US',6,'LS',3,'UB',2,'LB'

;
EA_XD	MOVEQ	#16,D1
	BSR	EA_GTR
	BPL	EA_XD1
EA_XD4	ADDQ.L	#1,D1
	BMI	EA_ER1	---->
	BRA	EA_ER13	---->
;
EA_XD1	MOVE.W	D1,D6
	SWAP	D1
	TST.W	D1
	BNE	EA_XD2		size exists
	BSR	EA_WARN8		warning W
	MOVEQ	#0,D1		set size W
	BRA	EA_XD3
EA_XD2	SUBQ.W	#1,D1
	BEQ	EA_XD3
	MOVEQ	#4,D1		L
EA_XD3	RTS
;
; -(An) or  <expression>
;
EA_4	ADDQ.L	#1,A1		set A1 -> reg start
	BSR	EA_GETAL
	BMI	EA_ER13	---->
EA4_1	CMPI.B	#")",D0
	BNE	EA_ER14	---->
	ADDI.W	#32,D1		mode 4
	EXT.L	D1
	MOVE.L	D1,D2
	BRA	EA_EXIT2
;
EA_74	BSR	GNUM
	CMPI.B	#10,SIZE(A6)
	BGT	EA_74_FP
	TST.W	D1
	BMI	EA_ER1	---->
	BEQ.S	EA_74ZE
	SUBQ.W	#2,D1
	BMI	EA_7N		GNUM Type 1
	BNE	EA_74ZE		not Type 1 or 2
	CMPI.B	#2,SIZE(A6)
	BNE	EA_ER5		PC not size L must be error
	TST.B	REL_SWTCH(A6)
	BEQ	EA_ER5		PC label not allowed unless reloc.
	MOVEQ	#0,D1		set to 'unknown label'
EA_74ZE	MOVEQ	#-3,D3
	ADD.B	SIZE(A6),D3
	EXT.W	D3
	MOVE.W	D3,D6
	BPL.S	EA_74L
	ADDQ.W	#5,D3
EA_74L	TST.W	D1
	BEQ	EA_74ZF
	BSR	EA_DL
EA_74P	MOVEQ	#0,D1		clear for 1st EXT
	TST.W	D6
	BPL.S	EA_74M
	MOVE.L	D3,D2
	AND.B	#6,D2
	LSL.W	#7,D2		No of [EXT] wds
EA_74M	ADDI.W	#$3C,D2		mode|reg
	BRA	EA_EXIT
;
EA_74A	TST.W	D1
	BMI	EA_ER1	---->
	CMPI.B	#1,D1
	BEQ	EA_74A1		known N-type
	CMPI.B	#2,D1
	BEQ	EA_ER1	---->
	MOVEQ	#7,D3		type INS 7
	BSET	#2,PCK(A6)	to set w=1
	BTST	#0,D4		16 or 18? . . .
	BEQ	EA_74A4		. . . yes
	BSET	#3,PCK(A6)	to set w=3
EA_74A4	BTST	#1,D4		16 or 17? . . .
	BEQ	EA_74A5		. . . yes
	MOVEQ	#1,D3		type INS 1
EA_74A5	MOVEQ	#0,D6		(no [EXT])
	BRA	EA_74L
EA_74A1	MOVE.L	D2,D1
	MOVE.L	#$3C,D3
	CMPI.B	#17,D4
	BMI	EA_74A6
	PEA	EA_74A2
	BEQ	CMP_d3_0
	BRA	CMP_d4
EA_74A2	BMI	EA_ER16	---->
	BRA	EA_74A3
EA_74A6	BSR	CMP_d3_0
	BMI	EA_ER16	---->
	LSL.W	#5,D1
EA_74A3	LSL.W	#5,D1
	BRA	EA_7N31
;
EA_74_FP	MOVE.B	SIZE(A6),D4
	CMPI.B	#19,D4
	BEQ	EA_74_Q		quad word
	CMPI.B	#16,D4
	BGE	EA_74A		special INS type 7 (16-18)
	TST.W	D1
	BEQ	EA_74_FPZ 	unknown label
	BMI	EA_7F_7
;
; D1 = 1,2,4
;
	CMPI.B	#15,D4
	BNE	EA_ER1	---->
	CMPI.W	#2,D1
	BEQ	EA_ER1	---->
	BLT	EA_7F_5		known
	MOVE.W	#$33,D3		for INS
	BSR	EA_DL
	BRA.S	EA_7F_6
EA_7F_5	CMPI.L	#-64,D2		see if k fits
	BLT	EA_ER16	---->
	CMPI.L	#63,D2
	BGT	EA_ER16	---->
	BFINS	D2,D5{25:7}         set k in D5
EA_7F_6	MOVE.W	#$3C,D2 7(4)	for <ea>
	BRA	EA_EXIT
;
EA_7F_7	CMPI.B	#-3,D1
	BNE	EA_ER1	---->
	CMPI.B	#15,D4
	BGE	EA_ER1	---->
	MOVE.L	#$23C,D3
	MOVEQ	#4,D2		for X
	EXT.W	D4
	LEA	EA_FPT,A0
	ADDA.W	-22(A0,D4.W*2),A0
	JMP	(A0)
;
EA_FPT	DC.W	EA_7FS-EA_FPT
	DC.W	EA_7FD-EA_FPT
	DC.W	EA_7FX-EA_FPT
	DC.W	EA_7FP-EA_FPT
;
EA_7FD	LEA	BUF(A6),A0	-> FP no
	MOVE.L	D3,-(A7)
	BSR	FP_XD		.D
	BMI	EA_ER1	---->
	MOVE.L	(A7)+,D3
EA_7FD1	MOVEQ	#2,D2
EA_7FX	NEG.W	D2
	LEA	BUF+8(A6,D2.W*2),A2
	NEG.W	D2
	MOVE.W	(A2)+,D1		set 1st word to D1
	MOVEA.L	EXTBUF(A6),A0	pointer to EXTBUF
EA_7F_1	MOVE.W	(A2)+,(A0)+
	DBF	D2,EA_7F_1	set 3 or 5 words to EXTBUF
	MOVE.L	A0,EXTBUF(A6)	& update pointer
	BRA	EA_7N02
;
EA_7FP	LEA	BUF(A6),A0
	MOVE.W	D3,D1		keep D3
	BSR	FP_XP		get packed decimal format
	BMI	EA_ER1	---->
	MOVE.W	D1,D3		restore D3
	BRA	EA_7FX
;
EA_7FS	LEA	BUF(A6),A0	-> FP no
	MOVE.W	D3,D1		keep in D1
	BSR	FP_XS
	BMI	EA_ER1	---->
	MOVE.W	D1,D3		replace D3
	MOVE.L	(A0),D1
	BRA	EA_7N02
;
EA_74_FPZ MOVE.B	D4,D3
	EXT.W	D3
	MOVE.W	EA_FINS-22(D3.W*2),D3
	MOVE.W	#$11,D4		to test type
EA_7_F8	SWAP	D3
	MOVE.W	D2,D3		label no
	BTST	#24,D3		0=k, 1=S, D, X or P
	BEQ.S	EA_7F_4
	MOVE.W	D2,D1
	BSR	LNPTR		set A0 -> label info
	TST.W	TYPE(A0)
	BNE.S	EA_7F_2
	OR.W	D4,TYPE(A0)
EA_7F_3	BSET	#0,PCK(A6)	mark 'not variable insert'
	BSR	EA_INS
	MOVE.W	#$23C,D2
	BRA	EA_EXIT
EA_7F_2	CMP.W	TYPE(A0),D4
	BEQ.S	EA_7F_3
	ORI.W	#3,TYPE(A0)	mark error in LAB
	BRA	EA_ER5	---->
;
EA_7F_4	BSR	EA_INS
	BRA	EA_7F_6
;
EA_74_Q	TST.W	D1
	BEQ	EA_74QZ
	CMPI.W	#-4,D1
	BNE	EA_ER1	---->
	MOVE.L	#$23C,D3
	BRA	EA_7FD1
;
EA_74QZ	MOVE.W	#$321,D3		for INS
	MOVE.W	#$21,D4		for quad word
	BRA	EA_7_F8
;
EA_FINS	DC.W	$110		S (size 11)
	DC.W	$320		D (size 12)
	DC.W	$530		X (size 13)
	DC.W	$531		P (size 14)
	DC.W	$033		k (size 15)
;
; (An), (An)+ or (A,Xn.S)
;
EA_236	MOVE.W	D1,D4
	CMPI.B	#")",D0
	BEQ.S	EA_2_3
	CMPI.B	#",",D0
	BNE	EA_ER14	---->
; MODE 6
EA_6	CLR.B	B_CNST(A6)	zero constant for mode 6
EA_6X	BSR	EA_XD		constant comes from B_CNST ("." sep)
	CMPI.B	#"*",D0
	BNE.S	EA_6X1		assume scale 1
	BSR	DO_SCALE
EA_6X1	LSL.W	#3,D6
	ADD.W	D6,D1
	ADD.W	D1,D1
	LSL.W	#8,D1
	CMPI.B	#")",D0
	BNE	EA_ER14	---->
	OR.B	B_CNST(A6),D1	add constant
	MOVE.W	D4,D2
	EXT.L	D2
	ORI.W	#$130,D2
	BRA	EA_EXIT2
;
EA_2_3	MOVE.B	(A1)+,D0
	CMPI.B	#"+",D0
	BEQ.S	EA_THREE
	ORI.W	#$10,D4
EA_THL	EXT.L	D4
	MOVE.L	D4,D2
	BRA	EA_EXIT
EA_THREE	ORI.W	#$18,D4
	MOVE.B	(A1)+,D0
	BRA.S	EA_THL
;
EA_74ZF	BSR	SET_LN
	BRA	EA_74P
;
EA_7N	MOVE.L	D2,D1
	MOVE.L	#$3C,D3
	MOVE.B	SIZE(A6),D4
	EXT.W	D4
	BPL	EA_7N5
	MOVEQ	#1,D4		set no size to W
EA_7N5	LEA	EA_JT,A0
	ADDA.W	(A0,D4.W*2),A0	point to size routine
	JMP	(A0)
;
EA_JT	DC.W	EA_7N0-EA_JT
	DC.W	EA_7N1-EA_JT
	DC.W	EA_7N2-EA_JT
	DC.W	EA_7N3-EA_JT
	DC.W	EA_7N4-EA_JT
	DC.W	EA_705-EA_JT
	DC.W	EA_705-EA_JT
	DC.W	EA_705-EA_JT
	DC.W	EA_708-EA_JT
	DC.W	EA_709-EA_JT
	DC.W	EA_7N10-EA_JT
;
;     *************************
;     *	  D3 (bits 0 to 9)	*
;     *	       		*
;     * |9 8|7 6 5 4|3 2 1 0| *
;     * |---|-------|-------| *
;     * | k |. . 1 1|1 1 0 0| *
;     *************************
;	*  SIZE TEST k  *
;	*    0   B   1  *  [=256]
;	*    1   W   1  *
;	*    2   -   2  *  [=512]
;	*    3   d3  0  *
;	*    4   d4  0  *
;	*    5   B   0  *
;	*    8  d5_0 0  *
;	*    9  d5_1 0  *
;	*   10  d2_0 0  *
;	*   11   S   2  *  [=512]
;	*   12   D   2  *  [=512]
;	*   13   X   2  *  [=512]
;	*****************
;
EA_7N10	BSR	CMP_d3_0
	BMI	EA_ER16	---->
	ANDI.W	#7,D1
	BRA.S	EA_7N31
EA_705	BSR	CMP_B
	BMI	EA_ER16	---->
	MOVE.B	D1,D5
	BRA.S	EA_7N02
EA_708	BSR	CMP_d5_0
	BMI	EA_ER16	---->
	ANDI.W	#$1F,D1
	LSL.W	#6,D1
	BRA.S	EA_7N31
EA_709	BSR	CMP_d5_1
	BMI	EA_ER16	---->
	ANDI.W	#$1F,D1
	BRA.S	EA_7N31
;
EA_7N0	BSR	CMP_B

************************	Added 17/1/12 v 5.07

	BMI	EA_ER16	---->
	ANDI.W	#$FF,D1		keep byte

************************

EA_7N01	BMI	EA_ER16	---->
	ADD.W	#256,D3
EA_7N02	MOVE.L	D3,D2
	BRA	EA_EXIT
;
EA_7N1	PEA	EA_7N01
	BTST	#7,F_EA(A6)
	BEQ	CMP_W		unsigned test
	BRA	CMP_W1		signed test
EA_7N2	ADDI.W	#512,D3
	BRA.S	EA_7N02
EA_7N3	BSR	CMP_d3
	BMI	EA_ER16	---->
	ANDI.W	#7,D1
	ADD.W	D1,D1
	LSL.W	#8,D1
EA_7N31	OR.W	D1,D5
	BRA.S	EA_7N02
EA_7N4	BSR	CMP_d4
	BMI	EA_ER16	---->
	BRA.S	EA_7N31
;
; If F_EA bit 6 is on ACCetc are possibly there
;
EA_01	MOVEQ	#0,D2
	ADD.W	D1,D2
	MOVE.B	-1(A1),D0
	CMPI.B	#32,D1		NEW
	BLT	EA_011		NEW
	CMPI.B	#54,D1		NEW
	BLT	EA_L9		we shouldn't be here   NEW
	MOVE.B	EA_CFTB-54(D1.W),D2 NEW
	BRA	EA_EXIT		NEW

; D2 values for ACC etc		NEW

EA_CFTB	DC.B	$50,$51,$52,$53,$54,$55,$58,$60

EA_011	CMPI.B	#16,D1
	BLT	EA_EXIT		Dn, An
	CMPI.B	#18,D1
	BLT	EA_L9		PC, ZPC
	ADDI.W	#$2B,D2
	CMPI.B	#21,D1
	BLT	EA_EXIT		SR, CCR or USP
	ADDI.W	#$35-$2D,D2	FPn or FPcr
	CMPI.B	#29,D1
	BLT	EA_EXIT		FPn
	ADDI.W	#$62-$35,D2	FPcr
	BRA	EA_EXIT


;
EA_567	MOVE.W	D1,D6
	MOVEQ	#18,D1		get D0 - A7, PC, ZPC
	BSR	EA_GTR
	BMI	EA_XD4	---->
	MOVE.W	D1,D4		reg
	SWAP	D1		size
	TST.W	D1
	BNE	EA_567_2		size exists
	SWAP	D1		replace reg in D1
	CMPI.B	#8,D4		D? . .
	BLT.S	EA_567_3		. . yes
	CMPI.B	#")",D0
	BEQ	EA_FIVE
	CMPI.B	#",",D0
	BEQ	EA_SIX
	CMPI.B	#16,D4
	BGE	EA_ER13	---->
EA_567_3	BSR	EA_WARN8
	MOVEQ	#0,D1
	BRA	EA_SEV2
;
EA_567_2	SUBQ.W	#1,D1		size W? . .
	BEQ	EA_SEV2		. . yes
	MOVEQ	#4,D1		L
EA_SEV2	CMPI.B	#"*",D0
	BNE.S	EA_SEV1
	BSR	DO_SCALE
EA_SEV1	ADD.W	D1,D1
	ADDQ.W	#1,D1
	LSL.W	#4,D4
	ADD.W	D1,D4
	LSL.L	#8,D4
;	 _____________________
;    D4 = |D/A|rrr|Sze|Scle|'1'|
;	  (bits 8 - 15)
;
;    Now get constant for mode 7(3)
;      D6 = 0  LAB
;	  1  N
;	  2  PC
;	  4  EQ list
;
EA_SEVW	CMPI.B	#1,D6
	BEQ	EA_SEVNB		known N
	BMI.S	EA_SEVZA		LAB unknown
	CMPI.B	#2,D6
	BEQ.S	EA_SEVZ		PC known
	MOVE.W	#$238,D3		prepare for DL
	BSR	EA_DL
EA_SEVQ	MOVE.W	D4,D1
	ADDI.W	#$30,D1
	MOVE.L	#$33B,D2
	BRA	EA_EXIT2
EA_SEVZA	TST.L	D2
	BMI	EA_SEVZA1 	neg - must be MEM IND
EA_SEVZ	MOVE.W	#$238,D3
	SWAP	D3
	MOVE.W	D2,D3
	BSR	EA_INS
	BRA.S	EA_SEVQ
;
EA_SEVZA1 MOVE.W	#$200,D3		2[EXT]
	BSR	SET_LN
	MOVE.W	D4,D1
	ADDI.W	#$B0,D1		base suppress, no []
	MOVE.L	#$330,D2		3[EXT] & 6(0)
	BRA	EA_EXIT2
;
; "d(Xn . ." or "(d,Xn . ."  where d is type N
;      D4 = 8-15 of [EXT]
;      D2 = value(d)
;      D6 = type(d)
;
EA_SEVNB	MOVEA.L	EXTBUF(A6),A0
	TST.L	D2
	BNE.S	EA_SEVNB1
	MOVEQ	#16,D6		bd size 01 (zero)
	BRA.S	EA_SEVNB4
EA_SEVNB1 BSR	CMP_W1
	BMI.S	EA_SEVNB2 	"L"
	MOVEQ	#32,D6		bd size 10 (word)
	MOVE.W	D2,(A0)+		and put d in EXTBUF
	BRA.S	EA_SEVNB3
EA_SEVNB2 MOVEQ	#48,D6		bd size 11 (long)
	MOVE.L	D2,(A0)+		and put d to EXTBUF
EA_SEVNB3 MOVE.L	A0,EXTBUF(A6)	update pointer
EA_SEVNB4 BSET	#7,D4		base suppress
	MOVE.W	D4,D1		set D1 for EXIT
	MOVEQ	#0,D4		base reg (there isn't one)
	BRA	EA_SIL5
;
; mode 7(1) & 7(0) Absolute address with .S
;
EA_S701	MOVE.W	D1,D6
	BSR	DO_SIZE
	BMI	EA_ER16	---->
	BEQ	EA_ER16	---->
EA_S701B	MOVEQ	#3,D3		INS type 3     LAB (2nd <ea>) enters
	MOVE.L	#$138,D4		7(0)
	SUBQ.W	#1,D1
	BEQ.S	EA_S7R
	ADDI.W	#$101,D4		7(1)
	MOVEQ	#4,D3		INS type 4
EA_S7R	CMPI.B	#2,D6		type PC
	BEQ	EA_S7R1
	CMPI.B	#1,D6
	BEQ.S	EA_S7K
	TST.B	D6
	BEQ	EA_S7Z
	BSR	EA_DL
EA_S7B	MOVEQ	#0,D1
EA_S7B1	MOVE.W	D4,D2
	EXT.L	D2
	BRA	EA_EXIT
EA_S7R1	TST.B	REL_SWTCH(A6)
	BEQ	EA_ER5	---->
	TST.W	D1
	BEQ	EA_ER16	---->	.W not allowed
EA_S7Z	PEA	EA_S7B
	BRA	SET_LN
EA_S7K	BTST	#0,D4
	BNE.S	EA_S7K1
	BSR	CMP_W
	BMI	EA_ER16	---->
EA_S7K1	MOVE.L	D2,D1
	BRA.S	EA_S7B1
;
; Mode 7(0) & 7(1) - no size
;
EA_S701A	MOVE.W	#$239,D4		2 words and 7(1)
	CMPI.B	#2,D6		PC type? . .
	BEQ	EA_S7R2		. . yes
	CMPI.B	#1,D6		N? . .
	BEQ	EA_S7K2		. . yes
	MOVE.W	#$100,D3		INS type 0, one extra word
	BSET	#1,PCK(A6)	mark Variable ABS
	PEA	EA_S7B
	TST.B	D6
	BEQ	SET_LN		Do EA_INS / N-type label if not REL
	BRA	EA_DL
;
EA_S7R2	TST.B	REL_SWTCH(A6)
	BEQ	EA_ER5	---->
	MOVEQ	#4,D3		INS type 4
	BRA	EA_S7Z
;
EA_S7K2	BSR	CMP_W1		signed test added  - 27th February 1999
	BMI	EA_S7B1		'L'
	MOVE.W	#$138,D4		set 7(0) - 1 word
	BRA	EA_S7B1
;
;  n(An)
;
EA_FIVE	CMPI.B	#16,D1
	BGE	EA_PCF		PC, ZPC
	MOVE.W	#$220,D3
	CMPI.B	#2,D6
	BEQ	EA_ER5	---->
	BPL.S	EA_FIEQ		EQlist
	TST.W	D6
	BEQ.S	EA_FIZ		undetermined LABEL
	BSR	CMP_W1
	BMI.S	EA_6_1_7		Big size
	MOVE.W	D2,D1		constant set
	BNE.S	EA_FIL
	BSR	EA_MOVP		Is it MOVP?
	BEQ	EA_FIL		yes - don't collapse to (An)
	ANDI.W	#7,D4		keep reg no
	MOVEQ	#$10,D2		set (An) <ea>
	BRA.S	EA_FIL1
EA_FIL	MOVE.L	#$120,D2
EA_FIL1	OR.W	D4,D2		set reg
	BRA	EA_EXIT2
EA_FIEQ	BSR	EA_MOVP		is it MOVEP?
	BEQ	EA_OFIEQ		yes
	BSR	EA_DL
EA_FEQ1	MOVE.W	#$170,D1
	MOVE.W	D4,D2
	ANDI.W	#7,D2		reg
	ORI.W	#$330,D2
	BRA	EA_EXIT2
EA_FIZ	BSR	EA_MOVP		is it MOVEP?
	BEQ	EA_OFIZ		yes
	PEA	EA_FIZL
EA_FIZ1	BRA	SET_LN
EA_FIZL	MOVEQ	#0,D1
	BRA.S	EA_FEQ1
EA_6_1_7	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	MOVE.L	D2,(A0)+
	MOVE.L	A0,(A4)
	BRA.S	EA_FEQ1
;
EA_MOVP	LEA	PR18_R1,A0
	CMPA.L	([EA_STK,A6]),A0
	BEQ.S	EA_MOVP1
	LEA	PR18_R2,A0
	CMPA.L	([EA_STK,A6]),A0
EA_MOVP1	RTS
;
EA_OFIEQ	MOVEQ	#3,D3
	BSR	EA_DL
EA_OFIZL	MOVEQ	#0,D1
	BRA	EA_FIL
EA_OFIZ	MOVEQ	#3,D3
	PEA	EA_OFIZL
	BRA	EA_FIZ1
;
; LAB(PC, ZPC)
;
; D1 = reg (16 = PC, 17 = ZPC)
;
EA_PCF	BNE.S	EA_PCF9		ZPC
	MOVE.W	#$170,D4		for PC
	BRA.S	EA_PCF1
EA_PCF9	MOVE.W	#$1F0,D4
EA_PCF1	CMPI.B	#1,D6
	BNE	EA_PCF2
	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BSR	CMP_W1
	BPL.S	EA_PCF3		word size
	MOVE.L	D2,(A0)+
	MOVE.W	D4,D1		[EXT]
	MOVE.W	#$33B,D2
	BRA	EA_6_K2
;
EA_PCF3	CMPI.B	#16,D1		16=PC 17=ZPC
	BNE.S	EA_PCF4 ZPC
	MOVE.W	D2,D1
	MOVE.W	#$13A,D2
	BRA	EA_EXIT2
;
EA_PCF4	TST.L	D2
	BEQ.S	EA_PCF5		zero bd
	MOVE.W	D2,(A0)+
	MOVE.W	#$23B,D2
	BRA	EA_6_K5		Set D1=$1E0 & reset EXTBUF
;
EA_PCF5	MOVE.W	#$1D0,D1
	MOVE.W	#$13B,D2
	BRA	EA_EXIT2
;
EA_PCF2	MOVE.W	#$268,D3		for INS or DL
	CMPI.B	#16,D1
	BEQ.S	EA_PCF6		not ZPC
	BSET	#1,PCK(A6)	mark ZPC
EA_PCF6	CMPI.B	#4,D6
	BNE.S	EA_PCF8		not EQU list
	BSR	EA_DL
	BRA.S	EA_PCF7
EA_PCF8	SWAP	D3
	MOVE.W	D2,D3		LAB
	BSR	EA_INS
EA_PCF7	MOVE.W	D4,D1
	MOVE.W	#$33B,D2
	BRA	EA_EXIT2

;
;  d(An,Xn.S), d(PC,Xn.S) or d(ZPX,Xn.S)
;
EA_SIX	CMPI.B	#16,D1
	BLT	EA_SIX2		not PC, ZPC
	MOVEQ	#11,D4		set 'reg' for 7(3)
	CMPI.B	#1,D6
	BEQ	EA_SIX4
	CMPI.B	#16,D1
	BEQ.S	EA_SIX3		PC
	BSET	#1,PCK(A6)
EA_SIX3	MOVE.W	#$278,D3
	CMPI.B	#4,D6
	BEQ	EA_SIEQ		EQU list
	PEA	EA_SIZ1
	SWAP	D3
	MOVE.W	D2,D3
	BRA	EA_INS
EA_SIX4	CMPI.B	#16,D1
	BEQ	EA_SIX1		'PC'
	MOVE.W	#$80,D6		set base suppress for 'ZPC'
	BRA	EA_SIL
EA_SIX2	MOVE.W	#$230,D3
	ANDI.W	#7,D4		keep reg
	CMPI.B	#2,D6
	BEQ	EA_ER5	---->
	BPL.S	EA_SIEQ
	TST.B	D6
	BEQ.S	EA_SIZ
EA_SIX1	MOVEQ	#0,D6		prepare for [EXT]
	BSR	CMP_B1
	BMI.S	EA_SIL
	MOVE.B	D2,B_CNST(A6)
	BRA	EA_6X
EA_SIZ	PEA	EA_SIZ1
	BRA	EA_FIZ1
EA_SIZ1	MOVEQ	#48,D6		set BDs = 11
	BRA.S	EA_SIL3
EA_SIEQ	BSR	EA_DL
	BRA.S	EA_SIZ1
;
EA_SIL	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BSR	CMP_W1
	BMI.S	EA_SIL1
	ADDI.W	#32,D6
	MOVE.W	D2,(A0)+
	BRA.S	EA_SIL2
EA_SIL1	MOVE.L	D2,(A0)+
	ADDI.W	#48,D6
EA_SIL2	MOVE.L	A0,(A4)		update EXTBUF
EA_SIL3	SWAP	D6
	BSR	EA_XD
	CMPI.B	#"*",D0
	BNE.S	EA_SIL4
	BSR	DO_SCALE
EA_SIL4	CMPI.B	#")",D0
	BNE	EA_ER14	---->
	LSL.W	#3,D6
	ADD.W	D6,D1		index reg
	ADD.W	D1,D1
	ADDQ.W	#1,D1		set bit 8
	LSL.W	#8,D1
	SWAP	D6
EA_SIL5	ADD.W	D6,D1		add in BD size
	MOVE.W	D6,D2
	LSL.W	#4,D2
	ADD.B	D4,D2		add base reg
	ADDI.W	#$30,D2		set mode 6
	BRA	EA_EXIT2
;
;  (d,,
;
EA_6_1_5	MOVE.B	(A1)+,D0		step over ","
	MOVE.W	#$200,D3		set for INS
	CMPI.B	#1,D1
	BEQ	EA_615K		known d
	BMI	EA_615I		INS
	CMPI.B	#2,D1
	BEQ	EA_ER5	---->
	BSR	EA_DL
;
; now look for Xn.s*z
;
EA_615E	BSR	EA_XD
	CMPI.B	#"*",D0
	BNE.S	EA_615_1
	BSR	DO_SCALE
EA_615_1	CMPI.B	#")",D0
	BNE	EA_ER9	---->
	LSL.W	#3,D6
	ADD.W	D6,D1		add reg above W/L Scale
	ADD.W	D1,D1
	ADDQ.W	#1,D1		bit 18
	LSL.L	#8,D1
	LEA	4+EXTBUF(A6),A0
	MOVE.L	-4(A0),D2
	SUB.L	A0,D2		no of bytes in EXTBUF
	ADDQ.W	#2,D2
	LSL.W	#3,D2
	ADD.W	D2,D1
	BSET	#7,D1		base suppress
	LSL.W	#4,D2		set no of [EXT] wds in D2
	ADDI.W	#$30,D2		set mode/reg 6(0)
	BRA	EA_EXIT2
;
EA_615K	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BSR	CMP_W1
	BPL.S	EA_615K1
	MOVE.L	D2,(A0)+
	BRA.S	EA_615K2
EA_615K1	MOVE.W	D2,(A0)+
EA_615K2	MOVE.L	A0,(A4)
	BRA	EA_615E
;
EA_615I	BSR	SET_LN
	BRA	EA_615E
;
; Subroutine
;
EA_GETAL	MOVEM.L	D2/A4,-(A7)
	MOVEA.L	A1,A4
	BSR	STRGA
	BMI	EA_ER1	---->
	EXG	A1,A2
	LEA	A_LIST,A0
	MOVEQ	#8,D1
	BSR	FIND
	EXG	A1,A2
	BPL	EA_GETAL3 	found
	MOVEA.L	A4,A1
	BSR	GNUM
	ADDQ.L	#6,D1
	BNE	EA_GETAL5
	SUBQ.W	#8,D2
	BMI	EA_ER1	---->
	MOVE.W	D2,D1
EA_GETAL1 MOVEM.L	(A7)+,D2/A4
	RTS
;
EA_GETAL3 SUBQ.W	#8,D1
	BMI	EA_GETAL4
	SUBQ.W	#1,D1
EA_GETAL4 ADDQ.W	#8,D1
	BRA	EA_GETAL1
;
EA_GETAL5 BTST	#6,DIP(A6)	EXP_ON? . .
	BEQ	EA_ER1	---->	. . no
	MOVEM.L	(A7)+,D2/A4
	MOVE.B	D4,D0
	MOVEA.L	A4,A1
	ADDQ.L	#4,A7
	BRA	EA_NUM
;
EA_70_71	MOVEQ	#0,D4
	MOVE.L	D2,D1

; New bit for JSR/JMP.L

*************************

	 MOVE.B	J_SIZE(A6),D4
	 BEQ	EA_70_C
	 SUBQ.B	#1,D4
	 BEQ	EA_70_A
	 BRA	EA_70_B
;	 TST.B	 J_SIZE(A6)	 JSR/JMP.L? . .
;	 BNE	 EA_ZERO2 	 . . yes
EA_70_C
*************************

	BSR	CMP_W1		signed test - 27th February 1999
	BPL.S	EA_70_A
EA_70_B	MOVE.W	#$101,D4
EA_70_A	ADDI.W	#$138,D4
	MOVE.L	D4,D2
	BRA	EA_EXIT
;
; EA_IND deals with all indirection
;  starting ([ . . .
;
EA_IND	MOVEQ	#0,D6		clear reg
	MOVEQ	#0,D4		see that D4.top=0
	ADDQ.L	#1,A1		move over [
	MOVE.B	(A1)+,D0
	CMPI.B	#"-",D0
	BEQ.S	EA_IG1		must be number
	CMPI.B	#"]",D0
	BEQ	EA_IN1		[]
	CMPI.B	#",",D0
	BNE.S	EA_IG2		ignore extra ","
	MOVE.B	(A1)+,D0
EA_IG2	MOVE.B	D0,D4		keep character
	MOVEA.L	A1,A4
	MOVEQ	#16,D1
	BSR	EA_GTR_1
	BPL	EA_IG3
	ADDQ.L	#1,D1
	BEQ	EA_IG4
	BRA	EA_ER1	---->
EA_IG3	MOVE.L	D1,D3
	SWAP	D3
	SUBQ.W	#1,D3
	BMI	EA_IN3		no size
	LSL.W	#2,D3		set D3.W = 0 or 4
EA_IG3_1	BSET	#23,D4		base suppress
	BRA	EA_IN33A
EA_IG4	MOVE.B	D4,D0		restore character
	MOVEA.L	A4,A1
EA_IG1	BSR	GNUM1		get bd
	TST.L	D1
	BMI	EA_ER1	---->
	CMPI.B	#"]",D0
	BEQ	EA_IP1		bd]  . . .
	CMPI.B	#",",D0
	BNE	EA_ER1	---->
	MOVE.B	(A1)+,D0		[bd, . . .
	CMPI.B	#",",D0
	BNE.S	EA_IG6		ignore ","
	MOVE.B	(A1)+,D0		jump over ","
EA_IG6	CMPI.B	#"]",D0
	BNE.S	EA_IG7
	BSET	#18,D4		([bd,]	post indexed
	BRA	EA_IN4A		must be MEM IND
;
; D1 = Type no	    ([bd, . . .
; D2 = Value of no
;
EA_IG7	MOVE.W	D1,D4		keep type of bd
	MOVE.L	D2,D3		keep value of bd
	LEA	-1(A1),A4 	keep (and set) pointer
	MOVEQ	#18,D1		D0 - A7, PC, ZPC
	BSR	EA_GTR_1		  *************
	BMI	EA_XD4		---->	    *
	CMPI.W	#16,D1		  *    Get    *
	BLT	EA_IG8		  *   base    *
	BEQ	EA_IG9		  *    reg    *
	BSET	#23,D4		  *	    *
EA_IG9	BFTST	D1{0:16}              *************
	BNE	EA_ER26	---->
	MOVE.W	D3,D2		value -> D2
	MOVEQ	#11,D6		'reg' for 7(3)
	CMPI.W	#1,D4
	BEQ	EA_IN5		type 1
	MOVE.W	#$248,D3
	PEA	EA_IN7
	CMPI.W	#4,D4
	BEQ	EA_DL		EQU list
	SWAP	D3
	MOVE.W	D2,D3		LAB no
	BRA	EA_INS
;
EA_IG8	BFTST	D1{0:16}
	BNE	EA_IP2		PC (there was a size)
	SUBQ.W	#8,D1
	BMI	EA_IP2C		Dn.W assumed
;
; Now do 'bd'
;
;  D4.W = type of bd
;  D3.L = value of bd
;  D1	= 0 - 7 for base reg
;
	MOVE.L	D3,D2
	MOVE.W	D1,D6		keep reg
EA_IN31	MOVE.W	#$200,D3		set for DL
	CMPI.W	#1,D4
	BEQ	EA_IN5		known type 1
	BMI	EA_IN6		-> INS
	CMPI.W	#2,D4
	BEQ	EA_ER5	---->
	BSR	EA_DL
;
; ([bd,An . . .
;
; D4 top = 0
; D6 = base reg (0 - 7)
; bd entered & base suppress marked if needed
;
EA_IN7	MOVEQ	#0,D1		prepare for no W/L Scale
	CMPI.B	#"]",D0
	BNE.S	EA_IN9A		leave bit 2=0 (pre-indexed)
EA_IN30	BSET	#18,D4
	MOVE.B	(A1)+,D0
	CMPI.B	#")",D0
	BEQ	EA_IN10		([bd,An]) or ....An]
EA_IN9A	CMPI.B	#",",D0
	BNE	EA_ER19	---->
;
; ....An, (D4.18=0), or ....An], (D4.18=1)
; D6 = n
;
	BTST	#18,D4
	BEQ.S	EA_IN39		pre_indexed "An,"
	CMPI.B	#',',(A1)
	BNE.S	EA_IN39
	MOVE.B	(A1)+,D0		step over ','
EA_IN39	MOVEA.L	A1,A4		keep pointer
	MOVEQ	#16,D1
	BSR	EA_GTR		get index & size
	BPL	EA_IN39A
	ADDQ.L	#2,D1
	BEQ	EA_ER1	---->	bad string
	MOVEA.L	A4,A1		restore pointer
	BRA	EA_IN29A
EA_IN39A	MOVE.L	D1,D3
	SWAP	D3
	TST.W	D3
	BNE	EA_IN39B		there is a size
	BSR	EA_WARN8		no size to W
	BFEXTU	D3{0:16},D1         reset reg
	BRA	EA_IN33A
EA_IN39B	SUBQ.W	#1,D3
	BEQ	EA_IN33A
	MOVEQ	#4,D3		L
;
; it is Xn. D3=0 for W & 4 for L
;
EA_IN33A	MOVE.W	D1,D4		set index reg to D4.W
	MOVE.W	D3,D1		and 4*SIZE to D1
	BRA	EA_IN32
;
; D4= size|reg (PC + index so top D4 should -> 0)
;
EA_IN40	MOVEQ	#0,D1		for size W
	BCLR	#16,D4		clear W (If it is!)
	BCLR	#17,D4		clear & test L
	BEQ	EA_IN32		it was W
	MOVEQ	#4,D1		set L
EA_IN32	CMPI.B	#"*",D0		entry after "([d,X."
	BNE.S	EA_IN12
	BSR	DO_SCALE
EA_IN12	ADD.W	D1,D1
;
; D1   = W/L|Scale of Index reg
; D4.W = Index reg
; D6   = Base reg
;
	BTST	#18,D4
	BNE.S	EA_IN13
	CMPI.B	#"]",D0
	BNE	EA_ER37	---->
	MOVE.B	(A1)+,D0
EA_IN13	BSR	EA_IEXT1
	CMPI.B	#")",D0
	BEQ.S	EA_IN20		no od
	CMPI.B	#",",D0
	BNE	EA_ER19	---->
;
; Now get od
;
EA_IN28	BSR	GNUM
	CMPI.B	#")",D0
	BNE	EA_ER43	---->
	TST.L	D1
	BMI	EA_ER1	---->
	ADD.W	#$200,D3		prepare for INS
;
; D1 = type od
; D2 = value od
; D4 has been set by IEXT1 & contains Index reg
; D6 = Base reg
;
	CMPI.B	#1,D1
	BEQ.S	EA_IN15		known od type 1
	BMI.S	EA_IN16		INS type 0
	CMPI.B	#2,D1
	BEQ	EA_ER5	---->
	BSR	EA_DL
;
EA_IN17	ADD.B	#2,D4		set od size to max
EA_IN20	ADD.B	#1,D4
	BTST	#6,D4		IS
	BEQ.S	EA_IN20A		Index not suppressed
	BCLR	#2,D4		clear Post [] marker
EA_IN20A	MOVE.W	D4,D1
	MOVE.W	D6,D2
	ORI.W	#$130,D2
	MOVE.L	EXTBUF(A6),D6
	LEA	4+EXTBUF(A6),A0
	SUB.L	A0,D6
	LSL.W	#7,D6
	ADD.W	D6,D2
	BRA	EA_EXIT2
;
EA_IN10	BSET	#22,D4		no index
	CLR.W	D4		set index reg = 0
	BSR.S	EA_IEXT1
	BRA.S	EA_IN20
;
EA_IN15	TST.L	D2
	BEQ.S	EA_IN20
	BSR	CMP_W1
	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BPL.S	EA_IN19
	MOVE.L	D2,(A0)+
	ADDQ.B	#2,D4
	BRA.S	EA_IN18
EA_IN19	MOVE.W	D2,(A0)+
	ADDQ.B	#1,D4
EA_IN18	MOVE.L	A0,(A4)
	BRA.S	EA_IN20
;
EA_IN16	BSR	SET_LN
	BRA.S	EA_IN17
;
;		3    0
;		______
; On entry:-  D1 = |.|..|0|
;		  
;	         W/L Scale
;
;	  D4 is:-
;
;	23 22	18    15		  3  2-0
;  ________________________________________
; |	 . .	  |		D/A|rrr|
;	  	|
;	 | |	1= Post [] ---------
;	 | 1 = Index suppress (IS)	|
;	 1 = Base suppress	  (BS)	|
;				|
; On exit:-			|
;				|
;  D4.W is			|
;     15				|   0
;    _______________________________________
;   |D/A|rrr|W/L|Scle|1|BS|IS|bd size|0|.|0|0|
;
;
;
EA_IEXT1	ADDQ.W	#1,D1
	LSL.W	#4,D4
	ADD.W	D4,D1		add in index reg
	LSL.W	#8,D1
	SWAP	D4
	ADD.W	D1,D4
	MOVE.L	EXTBUF(A6),D1
	LEA	EXTBUF+4(A6),A0
	SUB.L	A0,D1
	MOVE.W	D1,D3
	ADDQ.W	#2,D1
	LSR.W	#1,D3
	LSL.W	#3,D1
	ADD.W	D1,D4
	RTS
;
EA_IN29	BTST	#18,D4
	BEQ	EA_ER13	---->
EA_IN29A	BSET	#22,D4		no index
	CLR.W	D4		no reg
	MOVEQ	#0,D1		no W/L Scale
	BSR.S	EA_IEXT1
	BRA	EA_IN28
;
; D1.W = type : D2.L = value
;
EA_IP1	BSET	#18,D4
	CMPI.B	#1,D1
	BEQ	EA_IN4A		LABEL type 1, must be MEM IND
	BTST	#10,D7
	BNE	EA_IN4A		PC not allowed, must be MEM IND
	TST.L	D2
	BMI	EA_IN4A		neg label - must be MEM IND
	PEA	EA_IN7
	BRA	EA_IP4
;
; D1 = zero size|Dn - 8 (assumed Xn but no .W)
;
EA_IP2C MOVE.L	D1,D2
	BSR	EA_WARN8
	MOVE.L	D2,D1
	ADDQ.L	#8,D1		resets Dn and puts size 'W'
;
; D1 = size|Xn : D3 = value : D4 = type
;
EA_IP2	MOVE.L	D3,D2
	CMPI.B	#1,D4
	BEQ.S	EA_IP2A		MEM IND
	BTST	#10,D7
	BEQ.S	EA_IP2B		PC  allowed
EA_IP2A	MOVEA.L	A4,A1		set A1 to start of Xn
	MOVE.B	-1(A1),D0 	and set character in D0
	BRA	EA_IN4
EA_IP2B	EXG	D1,D4
	PEA	EA_IN40
EA_IP4	MOVE.W	#$208,D3		set for INS
	CMPI.W	#1,D1
	BEQ	EA_ER5	---->
	BMI.S	EA_IP5
	CMPI.W	#4,D1
	BNE.S	EA_IP5
	BSR	EA_DL		and then go to EA_IN40
;
EA_IP3	MOVEQ	#$B,D6
	RTS
EA_IP5	SWAP	D3
	MOVE.W	D2,D3
	BSR	EA_INS
	BRA.S	EA_IP3
;
EA_IN5	TST.L	D2
	BEQ	EA_IN7
	BSR	CMP_W1
	LEA	EXTBUF(A6),A4
	MOVEA.L	(A4),A0
	BPL.S	EA_IN8
	MOVE.L	D2,(A0)+
	BRA.S	EA_IN9
EA_IN8	MOVE.W	D2,(A0)+
EA_IN9	MOVE.L	A0,(A4)
	BRA	EA_IN7
;
EA_IN6	BSR	SET_LN
	BRA	EA_IN7
;
EA_IN1	BSET	#23,D4		set base suppress
	MOVEQ	#0,D1		set W/L Scale -> 0
	BRA	EA_IN30
;
EA_IN3	SUBQ.W	#8,D1
	BMI	EA_IN3_1		set Dn.W
	MOVE.W	D1,D6		set base reg in D6
	BRA	EA_IN7
;
EA_IN3_1	ADDQ.W	#8,D1
	MOVE.W	D1,D3
	BSR	EA_WARN8
	MOVE.W	D3,D1
	MOVEQ	#0,D3		set 'W'
	BRA	EA_IG3_1
;
EA_IN4A	MOVE.W	D1,D4		type of "bd" to D4.W
EA_IN4	BSET	#23,D4		set base suppress
	MOVEQ	#0,D1		set base reg = 0
	BRA	EA_IN31
;
; EA_BR tests whether "(" is part of an expression or is a true "(".
; Z is set if it is part of an expression.
; No registers are used.
;
EA_BR	MOVEM.L	D0-2/A1,-(A7)
	MOVEQ	#BUF_SIZE-1,D2
	MOVEQ	#1,D1		count the 1st (
EA_BR3	MOVE.B	(A1)+,D0		next character
	CMPI.B	#")",D0
	BEQ	EA_BR1
	CMPI.B	#"'",D0
	BEQ	EA_BR5		test for short string
	CMPI.B	#'"',D0
	BEQ	EA_BR5
	CMPI.B	#"(",D0
	BNE	EA_BR2		() not found
	ADDQ.W	#1,D1		count ('s & set not-Z
EA_BR2	DBF	D2,EA_BR3 	stop at buf end
EA_BR4	MOVEM.L	(A7)+,D0-2/A1
	RTS
;
EA_BR1	SUBQ.W	#1,D1		adjust total of ('s
	BNE	EA_BR2		() not yet balanced
	MOVE.B	(A1),D0		next character
	BSR	TST_SEPB		sets Z if *, / etc inside expression
	BRA	EA_BR4
;
EA_BR5	MOVE.L	D1,-(A7)
	MOVEQ	#4,D1		allow up to 4 characters
EA_BR6	CMP.B	(A1)+,D0		has the string ended?
	DBEQ	D1,EA_BR6
	BEQ	EA_BR7		OK string
EA_BR8	MOVEM.L	(A7)+,D1
	BNE	EA_BR4		Not expression
	MOVE	#0,CCR		set non-Z
	BRA	EA_BR2		carry on
EA_BR7	SUBQ.W	#4,D1		- residual count
	ADD.W	D1,D2		adjust main count in D2
	BMI	EA_BR8		counted out!
	MOVEQ	#0,D1
	BRA	EA_BR8
;
; Test that EA mode is allowed
; and check that the separator (D0.B) is one of
;   , SPACE ENTER
;
EA_EXIT2	MOVE.B	(A1)+,D0		go past ")"
EA_EXIT	MOVE.B	D2,D4
	MOVE.B	F_EA(A6),D3
	CMPI.B	#",",D0
	BEQ.S	EA_EXIT1
	CMPI.B	#32,D0
	BEQ.S	EA_EXIT1
	CMPI.B	#10,D0
	BEQ.S	EA_EXIT1
	CMPI.B	#"{",D0
	BEQ.S	EA_EXIT1
	CMPI.B	#"}",D0
	BEQ.S	EA_EXIT1
	CMPI.B	#":",D0
	BEQ.S	EA_EXIT1
	CMPI.B	#")",D0
	BEQ.S	EA_EXIT1
	CMPI.B	#9,D0
	BEQ.S	EA_EXIT1
;
; See if ALL separators are allowed
;
	BTST	#2,D3
	BEQ	EA_ER9	---->
;	    _____
; Now in D3  |5 4 3|	(from bits 3 to 5 of F_EA)
;	    |_ _|
;	      |
;  if	      	Allow	   Disallow
;  bit	    0 0 1 An FPcr	   FPn USP etc
;   =	    0 1 1 FPn FPcr	   An  USP etc
;   1	    1 0 1 An FPn FPcr   -  USP etc
;
;	    1 1 1      Allow reg-list
;
EA_EXIT1	LSR.B	#3,D3
	ANDI.W	#7,D3
	BEQ.S	EA_EXIT3		not FP
	CMPI.B	#7,D3
	BEQ	EA_EXIT8		allowed reg lists
EA_EXIT9	CMPI.B	#$3D,D2
	BLT.S	EA_EXIT4		not USP etc
	CMPI.B	#$3F,D2
	BLE	EA_ER18	---->	SR, USP & CCR not allowed
EA_EXIT4	MOVE.B	D2,D6
	ANDI.W	#$78,D6		keep mode*8
	CMPI.B	#3,D3
	BMI.S	EA_EXIT5		'0 0 1' Disallow FPn
	BNE.S	EA_EXIT6		allow FPn and An
	CMPI.B	#8,D6
	BEQ	EA_ER18	---->	An not allowed
	BRA.S	EA_EXIT6
EA_EXIT5	CMPI.B	#$48,D6
	BEQ	EA_ER18	---->	FPn not allowed
EA_EXIT6	ANDI.B	#$3F,D4		FPn coding -> An
EA_EXIT3	MOVEQ	#1,D3
	LSR.B	#3,D4		mode
	CMPI.B	#7,D4
	BLT.S	EA_EX1
	MOVE.B	D2,D4
	ANDI.B	#7,D4
	ADDQ.B	#7,D4		reg + 7
EA_EX1	LSL.W	D4,D3
	AND.W	D7,D3
;	 BNE	 EA_ER18	 ---->
	BNE	EA_EXIT10 	EMACS NEW
EA_EXIT7	TST.W	D7
	BPL.S	EA_EX
	MOVE.W	D2,D4
	ANDI.W	#$3F,D4
	OR.W	D4,D5		insert mode|reg
;
; D2 8-10  = No of [EXT] words
; D1 contains up to 2 [EXT] words
;    3 to 5 more [EXT] words are in EXTBUF
;
EA_EX	CMPI.W	#256,D2
	BLT.S	EA_EX2		no [ext]
	LEA	OBUF(A6),A0
	MOVEA.L	(A0),A2
	MOVE.W	D2,D3
	SUBI.W	#512,D3
	BMI.S	EA_EX3
	LEA	EXTBUF+4(A6),A4
	MOVE.L	-4(A4),D6
	SUB.L	A4,D6		length of EXTBUF
	LSR.W	#1,D6		no of words
	BNE.S	EA_EX7
	MOVE.L	D1,(A2)+
	ADDQ.L	#2,A5
	BRA.S	EA_EX4
EA_EX7	MOVE.W	D1,(A2)+
	BRA.S	EA_EX5
EA_EX6	MOVE.W	(A4)+,(A2)+
	ADDQ.L	#2,A5
EA_EX5	DBF	D6,EA_EX6
	BRA.S	EA_EX4
EA_EX3	MOVE.W	D1,(A2)+
EA_EX4	MOVE.L	A2,(A0)		update pointer
	ADDQ.L	#2,A5
EA_EX2	MOVEM.L (A7)+,D3/D4/D6/A0/A2-4
	RTS
;
EA_EXIT8	TST.B	F_EA(A6)		MOVEM? . .
	BPL	EA_EXIT3		. . yes
	MOVEQ	#3,D3		replace FP codes for FMOVEM
	BRA	EA_EXIT9
;
; Test if ColdFire registers ACC etc	NEW
;
EA_EXIT10
	BTST	#6,F_EA(A6)
	BEQ	EA_ER18	---->	not ACC etc
	BFEXTU	D2{25:4},D3
	SUBI.B	#10,D3
	BMI	EA_ER18	---->	not ACC etc
	SUBQ.B	#3,D3
	BPL	EA_ER18	---->	not ACC etc
	BRA	EA_EXIT7
;
EA_WARN8	MOVEQ	#-8,D1
	BRA	DO_ERR
EA_WARN19 MOVEQ	#-19,D1
	BRA	DO_ERR
;
EA_ER1	MOVEQ	#1,D1
EA_ERX	MOVE.L	EA_STK(A6),A7	reset STACK
EA_ERX1	MOVE.B	ER_EA(A6),D0	stack adj in words
	EXT.W	D0
	LEA	4(A7,D0.W*2),A7	jump over RTS etc
	SF	F_EA(A6)		clear 2nd EA marker
	SF	PCK(A6)		clear ZPC marker
	LEA	EXTBUF+4(A6),A0
	MOVE.L	A0,-4(A0) 	reset EXTBUF
	BSR	DO_ERR
	BSR	PUT_W
	BRA	INST_ED2		replaces A5 and resets INS position
EA_ER2	MOVEQ	#2,D1
	BRA.S	EA_ERX
EA_ER5	MOVEQ	#5,D1
	BRA.S	EA_ERX
EA_ER9	MOVEQ	#9,D1
	BRA.S	EA_ERX
EA_ER12	MOVEQ	#12,D1
	BRA.S	EA_ERX
EA_ER13	MOVEQ	#13,D1
	BRA.S	EA_ERX
EA_ER14	MOVEQ	#14,D1
	BRA.S	EA_ERX
EA_ER15	MOVEQ	#15,D1
	BRA.S	EA_ERX
EA_ER16	MOVEQ	#16,D1
	BRA.S	EA_ERX
EA_ER17	MOVEQ	#17,D1
	BRA.S	EA_ERX
EA_ER18	MOVEQ	#18,D1
	BRA.S	EA_ERX
EA_ER19	MOVEQ	#19,D1
	BRA.S	EA_ERX
EA_ER26	MOVEQ	#26,D1
	BRA.S	EA_ERX
EA_ER32	MOVEQ	#32,D1
	BRA.S	EA_ERX
EA_ER34	MOVEQ	#34,D1
	BRA.S	EA_ERX
EA_ER35	MOVEQ	#35,D1
	BRA	EA_ERX
EA_ER36	MOVEQ	#36,D1
	BRA	EA_ERX
EA_ER37	MOVEQ	#37,D1
	BRA	EA_ERX
EA_ER43	MOVEQ	#43,D1
	BRA	EA_ERX
