; GW49_VER_ASM on win1_ass_dv1
; This allows an easier change of version number by
; obviating the need to alter INIT_ASM in which VERSION appears.

VERSION EQU	?"5.07"

	END
Version 5.07
1. Use only a byte for immediate <ea>s of size B.
2. Allow JSR.x and JMP.x for absolute addresses (x = W or L).
This affects eg MOVE.B #-1,D0
Version 5.06
1. Corrected RAS in 5_asm. Error introduced in v5.04
Version 5.05
1. Corrected the call to MT_ALCHP in NN_LG5 - Job ID added
Version 5.04
1. Allow octal input.
Version 5.03
1. correct MOVEC error introduced in v5.01.
Version 5.02
1. Correct COMMON when assembled outside RAM1_ etc.
Version 5.01
1. Allow ColdFire instructions
2. Allow 32-bit addressing
Version 4.33
1. Replace old method of 68020+ test - since this now works on QPC2
Version 4.32
1. Correction of a mistake when an error is reported and there are no inserts.
Version 4.31
1. LTODZ (gw49_5_asm) now converts -2^31 correctly.
Version 4.30
1. Allows operation on QPC2
Version 4.29
1. Corrects CNOP and ALIGNx which stopped working after v4.26.
Version 4.28
1. Corrects GLABA for recursion (gw49_5_asm)
2. Allows (p1-p2) etc, inside complex expressions where p1 and p2 are PC type
labels. This is also true inside instructions which may collapse. However,
these instructions can no longer be allowed to collapse. If LOW_EA is ON the
ultimate value of the insert is checked and an error might be signalled.
Version 4.27
1. Sets zeros for DS instructions and for byte padding to word boundaries
2. Corrects errors in absolute address <ea>s for XREFs with LOW_EA on.
Version 4.26
1. The previous version did not allow the D/ parameter option to enter QM_PAR.
This is now corrected.
Version 4.25
1. Now correctly deals with translation of Qmac parameters to none.
Version 4.24
1. Allow either GWASS or Qmac type parameters for macros.
2. Some small changes to fatal errors.
3. Larger size macro parameters are not allowed.
Version 4.23
1. Allow "|" and "~" to be in macros.
2. PC labels can be inside [] of expressions provided the result
   is type N.
Version 4.22
1. Correction to GOTO. Instead of each GOTO issuing one ENDIF, the number of
ENDIFs is determioned by program. PR30, PR81 and PR108 in 3_ASM are altered.
Version 4.21
1. Correction to Expressions like 1+(2-3)*4
Version 4.20
1. No signalling of errors/warnings if IF_SW off.
2. GENIF and ENDGEN are alternatives to IF and ENDIF.
Version 4.19
1. Allows expressions and allows filenames for IN and LIB to be in
quotes or apostrophes.
2. BHS/SHS are allowed for BCC/SCC as well as BLO/SLO for BCS/SCS.
3. The effect of LOW_EA has been altered to make it easier to write programs
using relocatable modules. Thus where XREFs to PC labels are used in
instructions, these instructions will take the 68000/8 form. Also, since long
word branches are not permitted in the low ea set, all references to long
branches are treated as word. Thus BEQ.L will be taken as BEQ.W.
4. The macro facility has been enhanced in several ways.
 a. \. is taken as the label on the line of a macro call.
 b. |#REPL(n)~ returns the actual macro string for parameter n.
 c. |#LCASE<string>~ sets the <string> to lower case.
 d. |#OPTS~ returns the numerical value of the options set.
 e. Up to 61 parameters are now allowed (0 - 9, a - z, A - Z).
 f. A macro line can start with "|" to allow a "value".
5. A line containing only comments can now start after the first column.
6. IN and LIB will now accept filenames in quotes or inverted commas.
7. Two new WARNING messages have been added:
	 '68020+ EA used', and
	 'Bcc coould be short'.
8. One new ERROR has been added:
	 'MACRO name must not start with .'
9. Some faults have been corrected.
 In a macro \0 now does not return a leading space with a single digit.
 ANDI/ORI/EORI #n,SR now work if n is negative.
 The default number 512 (for COM_ALL) now works.
 If ZPC is used the "low ea" warning is sent if LOW_EA is on.
