; GW48_4_ASM
; 19th January 2012
;
; Altered - 19th January 2012
;  1. JSR and JMP allow W L
;
; Altered - 15th May 2008
;  1. Some ColdFire instructions added
;
; Altered - 21st January 2006
;  1. At QERX_6 allow a jump to GWAG1 without a long branch.
;
; Altered - 10th January 2005
;  1. PUT_BCT obliterated.
;
; Altered - 22nd October 2004
;  1. QM_PAR and GW_PAR added
;
; Altered (for v4.20) - 25th May 2003
;  1. GENIF & ENDGEN now equal IF & ENDIF
;
; Altered - 19th February 2003
;  1. EXP_ON and EXP_OFF added
;  2. Allow B/SHS to be the same as B/SCC
;  3. ALLOW B/SLO TO BR THE SAME AS B/SCS
;  4. Alter MACROP to allow 61 parameters
;
; Altered - 4th October 2002
;  1. FSMOVE and FDMOVE template $7002 -> $7000
;  2. Add separator types E
;
; Set to clear "AT 0,4" on return from fatal error - 29th December 1998
;
; Immediate data allowed in TST <ea> - 22 Jan 1999
;
; LIST/NOLIST as PR110 added - 25th September 1998
;
; An ASSEMBLER program
;    PART 4
;
;     QUIT
;       &
;    STORAGE
;
; On entry
; D1 = space in O_BUF
; D3 = size
; D4 = number of bytes to be PUT
;

;
; FATAL ERROR ROUTINES
;		        11 10-8 7-5 4-0
;	         ________________________
; On entry D7.W = |          Q|  F | m2| m1|
;		            
;    m1 & m2	         |   0 = no file
;      are	         |   1 = chid (A5)
;   1st & 2nd	         |   2 = BUF
;    message	         |   3 = name (A4)
;    numbers	         |   4 = MAC_BUF
;		         |   5 = EQU_SYM
;		         |   6 =	-
;		         |   7 = no file - don't print '@ line'
;		         |
;		         0 = QUIT
;		         1 = RESTART
;
; Bits 8 to 10 of D7 determine whether a file is involved. Zero means there
; is no file. If there is a file the numbers, 1 to 7, determine which program
; to pick using the Table QER_LST containing their addresses.
;
; The first message is accessed by a number (1, 2 etc) giving the position in
; WQMES of the address of the string.
;
; The second message is derived similarly from the table WQMES1.
;
; If there is no file there can be no 2nd message.
;
; Often D0 contains the error code to be passed to D3 on quitting.
;
;			  Q  F  m2  m1
;
QER1A	MOVEQ	#0,D0
QER1	MOVE.W	#$104,D7	  0  1	   4
	BRA	QERX
QER2	MOVE.W	#$101,D7	  0  1	   1
	BRA	QERX
QER3A	MOVEQ	#0,D0
QER3	MOVE.W	#$102,D7	  0  1	   2
	BRA	QERX
QER4	MOVEQ	#7,D7	  0  0	   7
	BRA	QER36_1
QER5	MOVEQ	#10,D7	  0  0	  10
	BRA	QER36_1
QER6A	MOVEQ	#0,D0
QER6	MOVE.W	#$A8B,D7	  1  2   4  11
	BRA	QERX
QER7	MOVE.W	#$809,D7	  1  0	   9
	BRA	QER36_1
QER8	MOVE.W	#$903,D7	  1  1	   3
	BRA	QERX
QER9	MOVE.W	#$905,D7	  1  1	   5
	BRA	QERX
QER10	MOVE.W	#$B00,D7	  1  3   3  11
QERX1	ADDI.W	#12,D0
	BPL	QERX1_1
	MOVEQ	#0,D0
QERX1_1	CMPI.W	#9,D0
	BLE	QERX1_2
	MOVEQ	#9,D0
QERX1_2	MOVE.B	QTEB(D0.W),D7	set m2 according to D0
	BRA	QERX
;
QTEB	DC.B	$8B,$B,$B,$EB,$B,$4B,$2B,$B,$B,$6B
;
QER11	MOVE.W	#$819,D7	  1  0   0  25
	BRA	QERX
QER12	MOVE.W	#$B2B,D7	  1  3   1  11
	BRA	QERX
QER13	MOVE.W	#$500,D7
	BRA	QERX1
QER15	MOVE.W	#$52B,D7	  0  5   1  11
	BRA	QERX
QER16	MOVE.W	#$C00,D7
	BRA	QERX
QER18	MOVE.W	#$006,D7	  0  0	   6
	BRA	QER36_1		clear D0
QER19	MOVE.W	#$008,D7	  0  0	   8
	BRA	QER36_1
QER20	MOVE.W	#$00C,D7	  0  0	  12
	BRA	QER36_1
QER21	MOVE.W	#$00D,D7	  0  0	  13
	BRA	QER36_1
QER22	MOVE.W	#$00E,D7	  0  0	  14
	BRA	QER36_1
QER23	MOVE.W	#$00F,D7	  0  0	  15
	BRA	QER36_1
QER24	MOVE.W	#$5B0,D7	  0  5   5  16
	BRA	QERX
QER25	MOVE.W	#$5D0,D7	  0  5   6  16
	BRA	QER36_1
QER26	LEA	O_BUF+4(A6),A2    filename
	MOVE.W	#$300,D7
	BRA	QERX1
QER28	MOVE.W	#$32B,D7	  0  3   1  11
	BRA	QERX
QER29	MOVE.W	#$12,D7	  0  0	  18  QMES24
	BRA	QER36_1
QER30	MOVE.W	#$13,D7	  0  0	  19  QMES25
	BRA	QER36_1
QER31	MOVE.W	#$14,D7	  0  0	  20  QMES26
	BRA	QER36_1
QER32	MOVE.W	#$715,D7	  0  7	  21  QMES27
	BRA	QERX
QER33	MOVE.W	#$716,D7	  0  7	  22  QMES28
	BRA	QERX
QER34	MOVE.W	#$817,D7	  1  0	  23  QMES29
	BRA	QERX
QER35	MOVE.W	#$818,D7	  1  0	  24  QMES12
	BRA	QER36_1
QER36	MOVE.W	#$01A,D7	  0  0	  26  QMES32
QER36_1	MOVEQ	#0,D0
QERX	MOVEA.L	A2,A4	just in case (file name)
	MOVEA.L	A0,A5	    "        (chan ID)
	BTST	#11,D7
	BNE.S	QERX_1	Not QUIT
	MOVE.W	#$704,D4	WHITE/GREEN
	CMPI.L	#-2,D0
	BGT	QERX_4
	CMPI.L	#-21,D0
	BGE	QERX_5
QERX_4	MOVEQ	#-15,D0
QERX_5	MOVE.L	D0,DATA(A6)	an unused space (now!)
	BRA	QERX_6
QERX_1	MOVE.W	#$407,D4	GREEN/WHITE
QERX_6	TST.B	DV_WMVEC(A6)
	BPL	QERX_7
	LEA	GWX1,A0	         (Returns to QERX_3 - [D4.W > 0])
	ADDA.L	(A0),A0
	JMP	(A0)
QERX_7	MOVEA.L	ID_CON(A6),A0
	MOVEQ	#-1,D3
	AT	0,4
	CLS_BOT
;
; Print message (file) (message)
;
QERX_3	MOVE.B	D7,D4
	ANDI.W	#$1F,D4	m1
	LEA	WQMES,A1
	ADD.W	D4,D4
	ADDA.W	-2(A1,D4.W),A1	address of m1
	BSR	UMT1
	MOVE.W	D7,D0
	LSR.W	#8,D0
	ANDI.W	#7,D0	F
	LEA	QER_LST,A1
	ADD.W	D0,D0
	ADDA.W	(A1,D0.W),A1
	JMP	(A1)

GWX1	DC.L	GWAG1-*


;
; Pointers to programs to print file info
; (1st is "no File")
;
QER_LST	DC.W	QERX_NF-QER_LST
	DC.W	QERX_F1-QER_LST
	DC.W	QERX_F2-QER_LST
	DC.W	QERX_F3-QER_LST
	DC.W	QERX_F4-QER_LST
	DC.W	QERX_F5-QER_LST
	DC.W	QERX_F6-QER_LST
	DC.W	QERX_NF2-QER_LST
;
QERX_F6	LEA	B_FLS(A6),A1
	BRA	QERX_F
QERX_F5	TST.L	D5
	BEQ.S	QERX_F5A
	MOVEA.L	D5,A1	-> new EQU_SYM filename
	BRA.S	QERX_F
QERX_F5A	LEA	EQU_SYM,A1
	BRA.S	QERX_F
QERX_F2	LEA	BUF(A6),A1
	MOVE.W	#8,(A1)	   set length to 8
	BRA.S	QERX_F
QERX_F3	MOVEA.L	A4,A1
	BRA.S	QERX_F
QERX_F4	LEA	MAC_BUF(A6),A1
	BRA.S	QERX_F
QERX_FQ	LEA	BLOP,A1
	BRA.S	QERX_F
QERX_F1	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVEA.L	SV_CHBAS(A0),A3
	MOVE.L	A5,D6	chid
	LSL.W	#2,D6
	MOVE.L	(A3,D6.W),D0
	BMI	QERX_FQ	NOT OPEN!!!
	MOVEA.L	D0,A1
	LEA	FS_FNAME(A1),A1
QERX_F	BSR	UMT
	LEA	LF,A1
	MOVE.B	D7,D4
	LSR.B	#5,D4
	EXT.W	D4
	BEQ.S	QERX_NF1	no second message
	LEA	WQMES1,A1 2nd message table
	ADDA.W	-2(A1,D4.W*2),A1
QERX_NF1	BSR	UMT1
QERX_NF	LEA	AT_L,A1	'@ line number'
	BSR	UMT1
	LEA	20+O_BUF(A6),A0
	MOVE.L	A0,D2
	MOVE.L	LINE_NO(A6),D0
	BSR	LTOD
	SUB.L	A0,D2
	MOVE.W	D2,-(A0)
	MOVEA.L	A0,A1
	BSR	UMT
QERX_NF2	BSR	BLP	make a noise
	BTST	#11,D7
	BNE	REQDO
	BSR	PAUSE
	MOVE.L	DATA(A6),D3	set error code
	BRA	QUIT2
;
; REQDO for restart
;
; Close IN files
; Delete _SYM, _BIN, _TMP, _LST  MACRO files
;
REQDO	MOVEA.L	CH_LST(A6),A3
	MOVE.W	CH_NO(A6),D4
	MOVE.L	CH_IN(A6),D0
	BRA.S	REQ_1
REQ_3	MOVE.L	(A3)+,D0
REQ_1	BPL.S	REQ_2	Not macro
	BCLR	#31,D0
REQ_2	MOVEA.L	D0,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	DBF	D4,REQ_3
;
; Now delete _SYM etc
;
	LEA	TRAIL2,A5
	LEA	TMP_NME(A6),A0
	LEA	BUF(A6),A3
	LEA	CH_OUT(A6),A4
	MOVE.W	(A0)+,D0	length of _TMP
	MOVE.W	D0,(A3)+
	SUBQ.W	#4,D0	length without _TMP
	BRA.S	REQ_6
REQ_7	MOVE.B	(A0)+,(A3)+
REQ_6	DBF	D0,REQ_7
	MOVEQ	#4,D7	up to 5 files
REQ_8	MOVE.L	(A4)+,D0	channel id
	BEQ	REQ_10	no more (_o file not there)
	MOVEA.L	D0,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVEQ	#3,D0	count for _BIN etc
	MOVEA.L	A3,A1	place for trailer
REQ_9	MOVE.B	(A5)+,(A1)+
	DBF	D0,REQ_9
	LEA	BUF(A6),A0
	TST.W	D7	last time? . .
	BNE	REQ_11	. . no
	SUBQ.W	#1,(A0)	reduce count of '_o' filename
REQ_11	BSR	DELETEFILE
	DBF	D7,REQ_8
REQ_10	MOVEQ	#-1,D5
	BRA	PA_END5	to delete MACRO files
;
; Pause and then return
;
QEND	BSR	PAUSE
	MOVEA.L	STACK(A6),A7
	MOVE.L	#-1,NO_ERRS(A6)
	TST.B	DV_WMVEC(A6)
	BMI	GWAG	not ptr
	MOVEQ	#-1,D3	timeout
	MOVEA.L	ID_CON(A6),A0
	AT	0,4
	CLS_BOT
	BRA	GWAG
;
PAUSE	MOVEQ	#-1,D1	this job
	SUBA.L	A1,A1
	MOVEQ	#MT_SUSJB,D0
	MOVE.W	#150,D3	timeout
	TRAP	#1
	RTS
;
; QUIT1 is the normal QUIT (no error)
; QUIT2 should have the error code set in D3
;
QUIT1	MOVEQ	#0,D3	no error code
QUIT2	MOVEQ	#MT_FRJOB,D0
	MOVEQ	#-1,D1
	TRAP	#1
;
AT_L	DC.W	15
	DC.B	" @ line number "
LF	DC.W	1
	DC.B	10
BLOP	DC.W	4
	DC.B	"????"
QMES1	DC.W	22
	DC.B	10,"Can't read header of",10
QMES2	DC.W	12
	DC.B	10,"Can't load",10
QMES3	DC.W	10
	DC.B	10,"Fault in",10
QMES4	DC.W	18
	DC.B	10,"Unknown error in",10
QMES5	DC.W	16
	DC.B	10,"Drive full for",10
QMES6	DC.W	18
	DC.B	10,"Too many channels"
QMES7	DC.W	14
	DC.B	10,"Out of memory"
QMES8	DC.W	15
	DC.B	10,"File not found"
QMES9	DC.W	17
	DC.B	10,"Program too long"
QMES10	DC.W	29
	DC.B	10,"Unknown error in",10," LABEL list"
QMES11	DC.W	12
	DC.B	10,"Can't open",10
QMES12	DC.W	QMES12E-QMES12-2
	DC.B	10,"No room - increase DATA SPACE"
QMES12E	DS.B	0
QMES13	DC.W	11
	DC.B	10,"Name wrong"
QMES14	DC.W	23
	DC.B	10,"Batch string too long",10
QMES15	DC.W	23
	DC.B	10,"Fault in batch string",10
QMES16	DC.W	23
	DC.B	10,"EQU_SYM name too long",10
QMES17	DC.W	24
	DC.B	10,"Too many batched files",10
QMES18	DC.W	18
	DC.B	10,"No batched files",10
QMES19	DC.W	27
	DC.B	10,"/ missing in batch string",10
QMES20	DC.W	11
	DC.B	10,"Length of",10
QMES21	DC.W	24
	DC.B	10,"is not a multiple of 32"
QMES22	DC.W	6
	DC.B	10,"File",10
QMES23	DC.W	16
	DC.B	10,"is wrong length"
QMES24	DC.W	19
	DC.B	10,"Fault in Q string",10
QMES25	DC.W	29
	DC.B	10,"Fault in default string (D)",10
QMES26	DC.W	33
	DC.B	10,"/ missing in default string (D)",10
QMES27	DC.W	30
	DC.B	10,"This machine is not a 68020+",10
QMES28	DC.W	24
	DC.B	10,"Fault in EQU_SYM table",10
QMES29	DC.W	17
	DC.B	10,"Too many MACROs",10
	MSG	30,<10,>,<"in use">,QMES
	MSG	31,<"ENDM missing in MACRO">,<,10>,QMES
	MSG	32,<"Substitutes for | & ~ are equal">,<,10>,QMES
;
WQMES	DC.W	QMES1-WQMES
	DC.W	QMES2-WQMES
	DC.W	QMES3-WQMES
	DC.W	QMES4-WQMES
	DC.W	QMES5-WQMES
	DC.W	QMES14-WQMES
	DC.W	QMES7-WQMES
	DC.W	QMES15-WQMES
	DC.W	QMES9-WQMES
	DC.W	QMES10-WQMES
	DC.W	QMES11-WQMES
	DC.W	QMES16-WQMES
	DC.W	QMES17-WQMES
	DC.W	QMES18-WQMES
	DC.W	QMES19-WQMES
	DC.W	QMES20-WQMES
	DC.W	QMES22-WQMES
	DC.W	QMES24-WQMES
	DC.W	QMES25-WQMES
	DC.W	QMES26-WQMES
	DC.W	QMES27-WQMES
	DC.W	QMES28-WQMES
	DC.W	QMES29-WQMES
	DC.W	QMES12-WQMES
	DC.W	QMES31-WQMES
	DC.W	QMES32-WQMES	26
;
WQMES1	DC.W	QMES6-WQMES1
	DC.W	QMES8-WQMES1
	DC.W	QMES7-WQMES1
	DC.W	QMES13-WQMES1
	DC.W	QMES21-WQMES1
	DC.W	QMES23-WQMES1
	DC.W	QMES30-WQMES1
;
HEAD0	DC.W	HEAD0_1-HEAD0-2
	DC.B	"               GDG ASSEMBLER",VNUM," V",VERSION,10,10
HEAD0_1	DS.B	0
	HED	<10,'GDG ASSEMBLER',VNUM,' V',VERSION,10>,HEAD0_B
	HED	<'GDG ASSEMBLER',VNUM,' V',VERSION>,HEAD0_C
HEAD0A	DC.W	20
	DC.B	"1  Start assembling",10
HEAD0B	DC.W	8
	DC.B	"2  QUIT",10
HEAD1	DC.W	21
	DC.B	"Give source filename "
;
;
NC_LIST	DC.W	2	For CINV & CPUSH
	DC.B	'NC'	-> no cache
	DC.W	2
	DC.B	'DC'	-> data cache
	DC.W	2
	DC.B	'IC'	-> instruction cache
	DC.W	2
	DC.B	'BC'	-> both caches
D_LIST	DC.W	2
	DC.B	'D0'   1
	DC.W	2
	DC.B	'D1'
	DC.W	2
	DC.B	'D2'
	DC.W	2
	DC.B	'D3'
	DC.W	2
	DC.B	'D4'
	DC.W	2
	DC.B	'D5'
	DC.W	2
	DC.B	'D6'
	DC.W	2
	DC.B	'D7'
A_LIST	DC.W	2
	DC.B	'A0'
	DC.W	2
	DC.B	'A1'
	DC.W	2
	DC.B	'A2'
	DC.W	2
	DC.B	'A3'
	DC.W	2
	DC.B	'A4'
	DC.W	2
	DC.B	'A5'
	DC.W	2
	DC.B	'A6'
	DC.W	2
	DC.B	'A7'
	DC.W	2
	DC.B	'SP'
	DC.W	2
	DC.B	'PC'
	DC.W	3
	DC.B	'ZPC'
	DC.W	2
	DC.B	'SR'  20
	DC.W	3
	DC.B	'CCR'
	DC.W	3
	DC.B	'USP'
FP_LIST	DC.W	3
	DC.B	'FP0'
	DC.W	3
	DC.B	'FP1'
	DC.W	3
	DC.B	'FP2'
	DC.W	3
	DC.B	'FP3'
	DC.W	3
	DC.B	'FP4'
	DC.W	3
	DC.B	'FP5'
	DC.W	3
	DC.B	'FP6'
	DC.W	3
	DC.B	'FP7'   30
	DC.W	4
	DC.B	'FPCR'
	DC.W	4
	DC.B	'FPSR'
	DC.W	5
	DC.B	'FPIAR'
CR_LIST	DC.W	3
	DC.B	'USP'		1
	DC.W	3
	DC.B	'SFC'
	DC.W	3
	DC.B	'DFC'
	DC.W	4
	DC.B	'CACR'
	DC.W	3
	DC.B	'VBR'
	DC.W	4
	DC.B	'CAAR'
	DC.W	3
	DC.B	'MSP'   40
	DC.W	3
	DC.B	'ISP'
; CR_List extensions for 68040 and 68060 control registers
	DC.W	2
	DC.B	'TC'
	DC.W	4
	DC.B	'ITT0'		10
	DC.W	4
	DC.B	'ITT1'
	DC.W	4
	DC.B	'DTT0'
	DC.W	4
	DC.B	'DTT1'
	DC.W	5
	DC.B	'MMUSR'
	DC.W	3
	DC.B	'URP'
	DC.W	3
	DC.B	'SRP'

; End of 68040 MMU group; 68EC040 synonyms follow
;
	DC.W	5
	DC.B	'IACR0'  50
	DC.W	5
	DC.B	'IACR1'
	DC.W	5
	DC.B	'DACR0'
	DC.W	5
	DC.B	'DACR1'		20

; 68060 uses the above extras plus these two

	DC.W	5
	DC.B	'BUSCR'
	DC.W	3
	DC.B	'PCR'    55

; Added for ColdFire v 5.01

	HED	<'ACC0'>,CF_ACC
	HED	<'ACC1'>
	HED	<'ACC2'>
	HED	<'ACC3'>
	HED	<'ACCEXT01'>  60
	HED	<'ACCEXT23'>
	HED	<'MASK'>
	HED	<'MACSR'> 63	30

	HED	<'ASID'>
	HED	<'ACR0'>
	HED	<'ACR1'>
	HED	<'ACR2'>
	HED	<'ACR3'>
	HED	<'MMUBAR'>
	HED	<'ROMBAR0'>  70
	HED	<'ROMBAR1'>
	HED	<'RAMBAR0'>
	HED	<'RAMBAR1'>	 40
	HED	<'MPCR'>
	HED	<'EDRAMBAR'>
	HED	<'SECMBAR'>
	HED	<'MBAR'>
	HED	<'PCR1U0'>
	HED	<'PCR1L0'>
	HED	<'PCR2U0'>  80
	HED	<'PCR2L0'>
	HED	<'PCR3U0'>
	HED	<'PCR3L0'>         50
	HED	<'PCR1U1'>
	HED	<'PCR1L1'>
	HED	<'PCR2U1'>
	HED	<'PCR2L1'>
	HED	<'PCR3U1'>
	HED	<'PCR3L1'>  89     56
	HED	<'PC'>		57

MMU_R1	DC.W	2
	DC.B	"TC"
	DC.W	3
	DC.B	'DRP'
	DC.W	3
	DC.B	'SRP'
	DC.W	3
	DC.B	'CRP'
	DC.W	3
	DC.B	'CAL'
	DC.W	3
	DC.B	'VAL'
	DC.W	3
	DC.B	'SCC'
	DC.W	2
	DC.B	'AC'
	DC.W	3
	DC.B	'PSR'
	DC.W	4
	DC.B	'PCSR'
	DC.W	3
	DC.B	'TT0'
	DC.W	3
	DC.B	'TT1'
	DC.W	5
	DC.B	'MMUSR'
MMU_R2	DC.W	3
	DC.B	'AC0'
	DC.W	3
	DC.B	'AC1'
	DC.W	5
	DC.B	'ACUSR'
	DC.W	4
	DC.B	'BAD0'
	DC.W	4
	DC.B	'BAD1'
	DC.W	4
	DC.B	'BAD2'
	DC.W	4
	DC.B	'BAD3'
	DC.W	4
	DC.B	'BAD4'
	DC.W	4
	DC.B	'BAD5'
	DC.W	4
	DC.B	'BAD6'
	DC.W	4
	DC.B	'BAD7'
	DC.W	4
	DC.B	'BAC0'
	DC.W	4
	DC.B	'BAC1'
	DC.W	4
	DC.B	'BAC2'
	DC.W	4
	DC.B	'BAC3'
	DC.W	4
	DC.B	'BAC4'
	DC.W	4
	DC.B	'BAC5'
	DC.W	4
	DC.B	'BAC6'
	DC.W	4
	DC.B	'BAC7'

;
MC_TAB	DC.W	$800,0
	DC.W	1,2,$801,$802,$803,$804
	DC.W	3,4,5,6,7,$805,$806,$807 ; Added by SNG
	DC.W	4,5,6,7		     ; 68EC040 synonyms
	DC.W	8,$808		     ; 68060 additions
; ColdFire additions
	DC.W	3,4,5,6,7,8
	DC.W	$C00,$C01,$C04,$C05,$C0C,$C0D
	DC.W	$C0E,$C0F,$D02,$D03,$D04,$D05
	DC.W	$D06,$D07,$D0A,$D0B,$D0C,$D0D
	DC.W	$D0E,$D0F,$80F
;
; The PRO_LST is made up of three words and
; two bytes:-
;
;  W1   Instruction word (Template) -> D5
;  W2/3 Disallowed <ea>s (see Sr EA) These words
;	 are together placed in D7
;       For most FP instructions the high word
;	of D7 is the 2nd instruction word
;  B1   PR number (9 -> PR9)
;  B2   Separator types allowed
;	0 = SPACE
;	1 = SPACE or ENTER
;	2 = SPACE .S (->B), B, W or L (Bcc)
;	3 = SPACE or .B, W, or L
;	4 = SPACE (->W) or.B, W or L
;	5 = SPACE (->W) .W or L
;	6 = SPACE, ENTER .W or L
;	7 = SPACE (->X) or .B, W, L, S, D, X or P
;	8 = SPACE (->X) .X or L
;	9 = SPACE .W or L
;	A = SPACE (->W) .B, W, L, S, D, X, P or Q
;	B = SPACE (->L) or .L
;	C = SPACE (->X) or .X
;	D = SPACE .S (->W), B, W or L (XREF)
;	E = SPACE (->X) B, W, L, S, D, X
;
PRO_LST	DC.W	0,0,0,0			EQU
	DC.W	0,0,0,0			SET
	DC.W	0,0,0,0			REG
	DC.W	0,0,0,$1B01		OPT
	DC.W	0,0,0,$1B01		TTL
	DC.W	0,0,0,$6D0A		DCB
	DC.W	0,0,2,$5400		ORG
	DC.W	0,0,$8005,$5701		LST
	DC.W	0,0,5,$5701		ERR
	DC.W	1,0,-3,$CF00		IFC
	DC.W	$F240,$000F,$FE02,$3C00	FST
	DC.W	$F240,0,$FE02,$3C00 	FSF
	DC.W	$4E74,$77FF,0,$4400 	RTD
	DC.W	$F28F,0,$50,$4D09		FBT
	DC.W	$F280,0,$50,$4D09		FBF
	DC.W	$D000,$7E00,$F000,$0604	ADD
	DC.W	$E100,$FFFE,$7602,$0404	ASL
	DC.W	$E000,$FFFE,$7602,$0404	ASR
	DC.W	$04C0,0,$FFFE,$0F0B 	FF1   v 5.01
	DC.W	$7100,$7FFE,$F000,$7004	MVS   v 5.01
	DC.W	$7180,$7FFE,$F000,$7004	MVZ   v 5.01
	DC.W	$51F8,0,$77FF,$2D06 	TPF   v 5.01
	DC.W	$A000,$7FFC,0,$7405 	MAC   v 5.01
	DC.W	$6400,0,0,$0202		BHS   Added 2/4/03
	DC.W	$6400,0,0,$0202		BCC
	DC.W	$6500,0,0,$0202		BLO   Added 20/4/03
	DC.W	$6500,0,0,$0202		BCS
	DC.W	$6700,0,0,$0202		BEQ
	DC.W	$6C00,0,0,$0202		BGE
	DC.W	$6E00,0,0,$0202		BGT
	DC.W	$6200,0,0,$0202		BHI
	DC.W	$6F00,0,0,$0202		BLE
	DC.W	$6300,0,0,$0202		BLS
	DC.W	$6D00,0,0,$0202		BLT
	DC.W	$6B00,0,0,$0202		BMI
	DC.W	$6600,0,0,$0202		BNE
	DC.W	$6A00,0,0,$0202		BPL
	DC.W	$6800,0,0,$0202		BVC
	DC.W	$6900,0,0,$0202		BVS
	DC.W	$6000,0,0,$0202		BRA
	DC.W	$4200,0,$FE02,$0E04 	CLR
	DC.W	$B000,$7FFC,$F000,$0604	CMP
	DC.W	$51C8,$77FF,$FFF2,$0300	DBF
	DC.W	$50C8,$77FF,$FFF2,$0300	DBT
	DC.W	$B100,$FE02,$7FFE,$1C04	EOR
	DC.W	$C140,$FFFC,$7FFC,$100B	EXG
	DC.W	$E108,$FFFE,$7602,$0404	LSL
	DC.W	$E008,$FFFE,$7602,$0404	LSR
	DC.W	$4400,0,$FE02,$0E04 	NEG
	DC.W	$4E71,0,0,$0101		NOP
	DC.W	$4E75,0,0,$0101		RTS
	DC.W	$54C0,0,$FE02,$3903 	SCC
	DC.W	$55C0,0,$FE02,$3903 	SCS
	DC.W	$54C0,0,$FE02,$3903 	SHS
	DC.W	$55C0,0,$FE02,$3903 	SLO
	DC.W	$57C0,0,$FE02,$3903 	SEQ
	DC.W	$5CC0,0,$FE02,$3903 	SGE
	DC.W	$5EC0,0,$FE02,$3903 	SGT
	DC.W	$52C0,0,$FE02,$3903 	SHI
	DC.W	$5FC0,0,$FE02,$3903 	SLE
	DC.W	$53C0,0,$FE02,$3903 	SLS
	DC.W	$5DC0,0,$FE02,$3903 	SLT
	DC.W	$5BC0,0,$FE02,$3903 	SMI
	DC.W	$56C0,0,$FE02,$3903 	SNE
	DC.W	$5AC0,0,$FE02,$3903 	SPL
	DC.W	$58C0,0,$FE02,$3903 	SVC
	DC.W	$59C0,0,$FE02,$3903 	SVS
	DC.W	$9000,$7E00,$F000,$0604	SUB
	DC.W	$4A00,0,$F000,$0E04 	TST #k allowed Jan 99
	DC.W	$41C0,$7FFD,$F81B,$0D0B	LEA
	DC.W	$C000,$7E02,$F002,$0604	AND
	DC.W	$4800,0,$FFFE,$0F05 	EXT
	DC.W	$4E80,0,$F81B,$3409 	JSR W and L allowed v5.07
	DC.W	0,$CE02,$77FF,$0804 	ORI
	DC.W	$6100,0,0,$0202		BSR
	DC.W	$4180,$7FFE,$F002,$3205	CHK
	DC.W	$4EC0,0,$F81B,$3409 	JMP W and L allowed v5.07
	DC.W	$4600,0,$FE02,$0E04 	NOT
	DC.W	$4840,0,$F81B,$390B 	PEA
	DC.W	$E118,$FFFE,$7602,$0404	ROL
	DC.W	$E018,$FFFE,$7602,$0404	ROR
	DC.W	$4E73,0,0,$0101		RTE
	DC.W	$4E77,0,0,$0101		RTR
	DC.W	$4AC0,0,$FE02,$3903 	TAS
	DC.W	PCK,0,8,$1900		PCK
	DC.W	0,0,0,$1A00		LIB
	DC.W	$08C0,$FE03,$FFFE,$2704	CAS
	DC.W	$06C0,0,$FFFC,$2C00 	RTM
	DC.W	0,0,0,$3501		END
	DC.W	$A000,$7FFC,$0100,$7405	MSAC	v 5.01
	DC.W	$4C40,$FFFE,$FF82,$710B	REMU	V 5.01
	DC.W	$4C40,$7FFE,$FF82,$710B	REMS	V 5.01
	DC.W	$4C80,0,$FFFE,$780B 	SATS	v 5.01
	DC.W	0,0,0,$FC00		FREG
	DC.W	0,0,0,$6E01		LIST	altered 25.9.98
	DC.W	0,0,0,$1B01		PAGE
	DC.W	0,0,0,$6C00		GOTO
	DC.W	0,0,-2,$CF00		IFLT
	DC.W	1,0,-2,$CF00		IFEQ
	DC.W	2,0,-2,$CF00		IFGT
	DC.W	3,0,-2,$CF00		IFLE
	DC.W	4,0,-2,$CF00		IFNE
	DC.W	5,0,-2,$CF00		IFGE
	DC.W	4,0,-3,$CF00		IFNC
	DC.W	0,0,0,$FD00		EQUR
	DC.W	$F040,0,$FE02,$3C00 	PSBS
	DC.W	$F040,1,$FE02,$3C00 	PSBC
	DC.W	$F040,2,$FE02,$3C00 	PSLS
	DC.W	$F040,3,$FE02,$3C00 	PSLC
	DC.W	$F040,4,$FE02,$3C00 	PSSS
	DC.W	$F040,5,$FE02,$3C00 	PSSC
	DC.W	$F040,6,$FE02,$3C00 	PSAS
	DC.W	$F040,7,$FE02,$3C00 	PSAC
	DC.W	$F040,8,$FE02,$3C00 	PSWS
	DC.W	$F040,9,$FE02,$3C00 	PSWC
	DC.W	$F040,10,$FE02,$3C00	PSIS
	DC.W	$F040,11,$FE02,$3C00	PSIC
	DC.W	$F040,12,$FE02,$3C00	PSGS
	DC.W	$F040,13,$FE02,$3C00	PSGC
	DC.W	$F040,14,$FE02,$3C00	PSCS
	DC.W	$F040,15,$FE02,$3C00	PSCC
	DC.W	$F080,0,$0050,$4D09 	PBBS
	DC.W	$F081,0,$0050,$4D09 	PBBC
	DC.W	$F082,0,$0050,$4D09 	PBLS
	DC.W	$F083,0,$0050,$4D09 	PBLC
	DC.W	$F084,0,$0050,$4D09 	PBSS
	DC.W	$F085,0,$0050,$4D09 	PBSC
	DC.W	$F086,0,$0050,$4D09 	PBAS
	DC.W	$F087,0,$0050,$4D09 	PBAC
	DC.W	$F088,0,$0050,$4D09 	PBWS
	DC.W	$F089,0,$0050,$4D09 	PBWC
	DC.W	$F08A,0,$0050,$4D09 	PBIS
	DC.W	$F08B,0,$0050,$4D09 	PBIC
	DC.W	$F08C,0,$0050,$4D09 	PBGS
	DC.W	$F08D,0,$0050,$4D09 	PBGC
	DC.W	$F08E,0,$0050,$4D09 	PBCS
	DC.W	$F08F,0,$0050,$4D09 	PBCC
	DC.W	$F200,$001D,$7000,$3607	FCOS
	DC.W	$F200,$0001,$7000,$3607	FINT
	DC.W	$F200,$0021,$7000,$3707	FMOD
	DC.W	$F200,$0025,$7000,$3707	FREM
	DC.W	$F200,$000E,$7000,$3607	FSIN
	DC.W	$F200,$000F,$7000,$3607	FTAN
	DC.W	0,0,5,$5500		XDEF
	DC.W	0,0,4,$550D		XREF
	DC.W	0,0,0,$D101		ENDC = ENDIF
	DC.W	0,0,1,$D000		ORIF
	DC.W	0,0,0,$D201		ELSE
	DC.W	0,0,0,$4E00		CNOP
	DC.W	$4AC8,0,0,$0101		HALT - added by SNG
	DC.W	$4AFA,0,0,$0101		BGND - added by SNG
	DC.W	$F200,$003A,$7000,$3B07	FTST
	DC.W	$F200,$0028,$7000,$3707	FSUB
	DC.W	$F240,$000F,$FE02,$3C00	FSRA
	DC.W	$F240,$001F,$FE02,$3C00	FSST
	DC.W	$F240,$0010,$FE02,$3C00	FSSF
	DC.W	$F240,$0008,$FE02,$3C00	FSUN
	DC.W	$F240,$0007,$FE02,$3C00	FSOR
	DC.W	$F240,$0016,$FE02,$3C00	FSGL
	DC.W	$F240,$0015,$FE02,$3C00	FSLE
	DC.W	$F240,$0014,$FE02,$3C00	FSLT
	DC.W	$F240,$0013,$FE02,$3C00	FSGE
	DC.W	$F240,$0012,$FE02,$3C00	FSGT
	DC.W	$F240,$000E,$FE02,$3C00	FSNE
	DC.W	$F240,$0001,$FE02,$3C00	FSEQ
	DC.W	$F280,0,0,$3801		FNOP
	DC.W	$F200,$001A,$7000,$3607	FNEG
	DC.W	$F800,$FFFE,$F80E,$4704	TBLU
	DC.W	$F800,$FFFE,$F80E,$4504	TBLS
	DC.W	$F200,$0023,$7000,$3707	FMUL
	DC.W	$F200,$0020,$7000,$3707	FDIV
	DC.W	$F248,$000F,$FFFE,$3A00	FDBT
	DC.W	$F248,$0000,$FFFE,$3A00	FDBF
	DC.W	$F200,$0038,$7000,$3707	FCMP
	DC.W	$F28F,0,$50,$4D09		FBRA
	DC.W	$F29F,0,$50,$4D09		FBST
	DC.W	$F290,0,$50,$4D09		FBSF
	DC.W	$F288,0,$50,$4D09		FBUN
	DC.W	$F287,0,$50,$4D09		FBOR
	DC.W	$F296,0,$50,$4D09		FBGL
	DC.W	$F295,0,$50,$4D09		FBLE
	DC.W	$F294,0,$50,$4D09		FBLT
	DC.W	$F293,0,$50,$4D09		FBGE
	DC.W	$F292,0,$50,$4D09		FBGT
	DC.W	$F28E,0,$50,$4D09		FBNE
	DC.W	$F281,0,$50,$4D09		FBEQ
	DC.W	$F200,$0022,$7000,$3707	FADD
	DC.W	$F200,$0018,$7000,$3607	FABS
	DC.W	$0600,$FE02,$77FF,$0804	ADDI
	DC.W	$5000,$FE00,$77FF,$0A04	ADDQ
	DC.W	$D100,$7FEF,$FFEE,$0904	ADDX
	DC.W	$D0C0,$7FFD,$F000,$0B05	ADDA
	DC.W	$B0C0,$7FFD,$F000,$0B05	CMPA
	DC.W	$0C00,$F802,$77FF,$0804	CMPI
	DC.W	$54C8,$77FF,$FFF2,$0300	DBCC
	DC.W	$55C8,$77FF,$FFF2,$0300	DBCS
	DC.W	$57C8,$77FF,$FFF2,$0300	DBEQ
	DC.W	$51C8,$77FF,$FFF2,$0300	DBRA
	DC.W	$5CC8,$77FF,$FFF2,$0300	DBGE
	DC.W	$5EC8,$77FF,$FFF2,$0300	DBGT
	DC.W	$52C8,$77FF,$FFF2,$0300	DBHI
	DC.W	$5FC8,$77FF,$FFF2,$0300	DBLE
	DC.W	$53C8,$77FF,$FFF2,$0300	DBLS
	DC.W	$5DC8,$77FF,$FFF2,$0300	DBLT
	DC.W	$5BC8,$77FF,$FFF2,$0300	DBMI
	DC.W	$56C8,$77FF,$FFF2,$0300	DBNE
	DC.W	$5AC8,$77FF,$FFF2,$0300	DBPL
	DC.W	$58C8,$77FF,$FFF2,$0300	DBVC
	DC.W	$80C0,$7FFE,$F002,$2F05	DIVU
	DC.W	$81C0,$7FFE,$F002,$2E05	DIVS
	DC.W	$0A00,$CE02,$77FF,$0804	EORI
	DC.W	$C0C0,$7FFE,$F002,$2F05	MULU
	DC.W	$C1C0,$7FFE,$F002,$2E05	MULS
	DC.W	$59C8,$77FF,$FFF2,$0300	DBVS
	DC.W	$90C0,$7FFD,$F000,$0B05	SUBA
	DC.W	$4840,0,$FFFE,$0F00 	SWAP
	DC.W	$4E40,0,$77FF,$1600 	TRAP
	DC.W	$0200,$CE02,$77FF,$0804	ANDI
	DC.W	$C100,$7FEF,$FFEE,$0900	ABCD
	DC.W	$0040,$FE02,$77FE,$0C03	BCHG
	DC.W	$0080,$FE02,$77FE,$0C03	BCLR
	DC.W	$00C0,$FE02,$77FE,$0C03	BSET
	DC.W	$0000,$F802,$77FE,$0C03	BTST
	DC.W	$B100,$7FF7,$FFF7,$0904	CMPM
	DC.W	$4E50,$77FF,$FFFD,$1405	LINK
	DC.W	$4800,0,$FE02,$3903 	NBCD
	DC.W	$4000,0,$FE02,$0E04 	NEGX
	DC.W	$E110,$FFFE,$7602,$0404	ROXL
	DC.W	$E010,$FFFE,$7602,$0404	ROXR
	DC.W	$8100,$7FEF,$FFEE,$0900	SBCD
	DC.W	$4E72,0,$77FF,$1500 	STOP
	DC.W	$0400,$FE02,$77FF,$0804	SUBI
	DC.W	$9100,0,$FE02,$0904 	SUBX
	DC.W	$4E58,0,$FFFD,$0F00 	UNLK
	DC.W	DATA,0,0,$1900		DATA
	DC.W	$5100,$FE00,$77FF,$0A04	SUBQ
	DC.W	$49C0,0,$FFFE,$330B 	EXTB
	DC.W	$8180,$77FF,$FFEE,$2B00	UNPK
	DC.W	$8140,$77FF,$FFEE,$2B00	PACK
	DC.W	$00C0,$FFFC,$F81B,$2A04	CMP2
	DC.W	$00C0,$FFFC,$F81B,$2904	CHK2
	DC.W	$08FC,$7FFC,$FFFE,$2805	CAS2
	DC.W	$4848,0,$77FF,$2500 	BKPT
	DC.W	PWID,70,132,$1900		PWID
	DC.W	0,$0E00,$8000,$0504 	MOVE
	DC.W	0,0,0,$FE0A		RS
	DC.W	0,0,-1,$CF00		IF
	DC.W	$51C0,0,$FE02,$3903 	SF
	DC.W	$50C0,0,$FE02,$3903 	ST
	DC.W	$8000,$7E02,$F002,$0604	OR
	DC.W	0,0,0,$170A		DS
	DC.W	0,0,0,$180A		DC
	DC.W	0,0,1,$1A00		IN
	DC.W	$A000,0,1,$7205		MAAAC	v 5.01
	DC.W	$A000,0,3,$7205		MASAC	v 5.01
	DC.W	$A000,0,$101,$7205		MSAAC	v 5.01
	DC.W	$A000,0,$103,$7205		MSSAC	v 5.01
	DC.W	$A140,$FE00,$77FF,$6F0B	MOV3Q	v 5.01
	DC.W	0,0,1,$FD00		FEQUR
	DC.W	0,0,-1,$CF00		GENIF
	DC.W	0,0,0,$1B01		TITLE
	DC.W	0,0,0,$6B00		ERROR
	DC.W	0,0,0,$6A00		RSSET
	DC.W	$F048,0,$FFFE,$3A00 	PDBBS
	DC.W	$F048,1,$FFFE,$3A00 	PDBBC
	DC.W	$F048,2,$FFFE,$3A00 	PDBLS
	DC.W	$F048,3,$FFFE,$3A00 	PDBLC
	DC.W	$F048,4,$FFFE,$3A00 	PDBSS
	DC.W	$F048,5,$FFFE,$3A00 	PDBSC
	DC.W	$F048,6,$FFFE,$3A00 	PDBAS
	DC.W	$F048,7,$FFFE,$3A00 	PDBAC
	DC.W	$F048,8,$FFFE,$3A00 	PDBWS
	DC.W	$F048,9,$FFFE,$3A00 	PDBWC
	DC.W	$F048,$A,$FFFE,$3A00	PDBIS
	DC.W	$F048,$B,$FFFE,$3A00	PDBIC
	DC.W	$F048,$C,$FFFE,$3A00	PDBGS
	DC.W	$F048,$D,$FFFE,$3A00	PDBGC
	DC.W	$F048,$E,$FFFE,$3A00	PDBCS
	DC.W	$F048,$F,$FFFE,$3A00	PDBCC
	DC.W	0,0,0,$5C01		68040
	DC.W	0,0,1,$5C01		68030
	DC.W	0,0,3,$5C01		68851
	DC.W	$F100,0,$FE0B,$3900 	PSAVE
	DC.W	0,0,3,$FF00		PMOVE
	DC.W	$F200,$001C,$7000,$3607	FACOS
	DC.W	$F200,$000C,$7000,$3607	FASIN
	DC.W	$F200,$000A,$7000,$3607	FATAN
	DC.W	$F200,$0019,$7000,$3607	FCOSH
	DC.W	$F200,$0010,$7000,$3607	FETOX
	DC.W	$F200,$0016,$7000,$3607	FLOG2
	DC.W	$F200,$0014,$7000,$3607	FLOGN
	DC.W	$F200,$0002,$7000,$3607	FSINH
	DC.W	$F200,$0009,$7000,$3607	FTANH
	DC.W	0,0,0,$D000		ANDIF
	DC.W	0,0,1,$D000		OR_IF
	DC.W	0,0,0,$D101		ENDIF
	DC.W	$4ACC,0,0,$0101		PULSE - added by SNG
	DC.W	$F408,0,$7FFB,$4A00 	CINVL
	DC.W	$F410,0,$7FFB,$4A00 	CINVP
	DC.W	$F418,0,0,$4900		CINVA
	DC.W	$F5C8,0,$7FFB,$4000 	PLPAR - SNG & GDG
	DC.W	$F588,0,$7FFB,$4000 	PLPAW - SNG & GDG
	DC.W	$F300,0,$FE0B,$3900 	FSAVE
	DC.W	$F200,$006C,$7000,$3707	FDSUB
	DC.W	$F200,$0068,$7000,$3707	FSSUB
	DC.W	$F200,$0004,$7000,$3607	FSQRT
	DC.W	$F240,$001E,$FE02,$3C00	FSSNE
	DC.W	$F240,$0011,$FE02,$3C00	FSSEQ
	DC.W	$F240,$0009,$FE02,$3C00	FSUEQ
	DC.W	$F240,$0006,$FE02,$3C00	FSOGL
	DC.W	$F240,$000A,$FE02,$3C00	FSUGT
	DC.W	$F240,$0005,$FE02,$3C00	FSOLE
	DC.W	$F240,$000B,$FE02,$3C00	FSUGE
	DC.W	$F240,$0004,$FE02,$3C00	FSOLT
	DC.W	$F240,$000C,$FE02,$3C00	FSULT
	DC.W	$F240,$0003,$FE02,$3C00	FSOGE
	DC.W	$F240,$000D,$FE02,$3C00	FSULE
	DC.W	$F240,$0002,$FE02,$3C00	FSOGT
	DC.W	$F240,$0017,$FE02,$3C00	FSGLE
	DC.W	$F240,$0019,$FE02,$3C00	FSNGL
	DC.W	$F240,$001A,$FE02,$3C00	FSNLE
	DC.W	$F240,$001B,$FE02,$3C00	FSNLT
	DC.W	$F240,$001C,$FE02,$3C00	FSNGE
	DC.W	$F240,$001D,$FE02,$3C00	FSNGT
	DC.W	$F200,$005E,$7000,$3607	FDNEG
	DC.W	$F200,$005A,$7000,$3607	FSNEG
	DC.W	$F800,$FFFE,$FE08,$4804	TBLUN
	DC.W	$F800,$FFFE,$FE08,$4604	TBLSN
	DC.W	$F200,$0067,$7000,$3707	FDMUL
	DC.W	$F200,$0063,$7000,$3707	FSMUL
	DC.W	$F200,0,0,$3E07		FMOVE
	DC.W	$F200,$0064,$7000,$3707	FDDIV
	DC.W	$F200,$0060,$7000,$3707	FSDIV
	DC.W	$F248,$000F,$FFFE,$3A00	FDBRA
	DC.W	$F248,$001F,$FFFE,$3A00	FDBST
	DC.W	$F248,$0010,$FFFE,$3A00	FDBSF
	DC.W	$F248,$0008,$FFFE,$3A00	FDBUN
	DC.W	$F248,$0007,$FFFE,$3A00	FDBOR
	DC.W	$F248,$0016,$FFFE,$3A00	FDBGL
	DC.W	$F248,$0015,$FFFE,$3A00	FDBLE
	DC.W	$F248,$0014,$FFFE,$3A00	FDBLT
	DC.W	$F248,$0013,$FFFE,$3A00	FDBGE
	DC.W	$F248,$0012,$FFFE,$3A00	FDBGT
	DC.W	$F248,$000E,$FFFE,$3A00	FDBNE
	DC.W	$F248,$0001,$FFFE,$3A00	FDBEQ
	DC.W	$F29E,0,$50,$4D09		FBSNE
	DC.W	$F291,0,$50,$4D09		FBSEQ
	DC.W	$F289,0,$50,$4D09		FBUEQ
	DC.W	$F286,0,$50,$4D09		FBOGL
	DC.W	$F28A,0,$50,$4D09		FBUGT
	DC.W	$F285,0,$50,$4D09		FBOLE
	DC.W	$F28B,0,$50,$4D09		FBUGE
	DC.W	$F284,0,$50,$4D09		FBOLT
	DC.W	$F28C,0,$50,$4D09		FBULT
	DC.W	$F283,0,$50,$4D09		FBOGE
	DC.W	$F28D,0,$50,$4D09		FBULE
	DC.W	$F282,0,$50,$4D09		FBOGT
	DC.W	$F297,0,$50,$4D09		FBGLE
	DC.W	$F299,0,$50,$4D09		FBNGL
	DC.W	$F29A,0,$50,$4D09		FBNLE
	DC.W	$F29B,0,$50,$4D09		FBNLT
	DC.W	$F29C,0,$50,$4D09		FBNGE
	DC.W	$F29D,0,$50,$4D09		FBNBT
	DC.W	$F200,$0066,$7000,$3707	FDADD
	DC.W	$F200,$0062,$7000,$3707	FSADD
	DC.W	$F200,$005C,$7000,$3607	FDABS
	DC.W	$F200,$0058,$7000,$3607	FSABS
	DC.W	$4E7A,0,$7FFC,$2000 	MOVEC
	DC.W	$2040,$7FFD,$F000,$1105	MOVEA
	DC.W	$7000,$7FFE,$77FF,$130B	MOVEQ
	DC.W	$4880,$FE0B,$7810,$0705	MOVEM alt to allow reg list
	DC.W	$0180,$7FFE,$FFDE,$1205	MOVEP
	DC.W	$4E70,0,0,$0101		RESET
	DC.W	$4E76,0,0,$0101		TRAPV
	DC.W	0,0,0,$1E01		MACRO
	DC.W	$50F8,0,$77FF,$2D06 	TRAPT
	DC.W	$51F8,0,$77FF,$2D06 	TRAPF
	DC.W	$0E00,$FE03,$FE00,$2104	MOVES
	DC.W	$4C40,$FFFE,$8002,$310B	DIVUL
	DC.W	$4C40,$FFFE,$8002,$300B	DIVSL
	DC.W	$06C0,$F81B,$77FF,$2600	CALLM
	DC.W	$EFC0,$FE1A,$7FFE,$2400	BFINS
	DC.W	$EDC0,$77FE,$F81A,$2300	BFFFO
	DC.W	$E8C0,$77FE,$F81A,$2200	BFTST
	DC.W	$EEC0,$77FE,$FE1A,$2200	BFSET
	DC.W	$ECC0,$77FE,$FE1A,$2200	BFCLR
	DC.W	$EAC0,$77FE,$FE1A,$2200	BFCHG
	DC.W	$FB00,0,$FE03,$0E04 	WDDATA	v 5.01
	DC.W	$FBC0,0,$FF9B,$770B 	WDEBUG	V 5.01
	DC.W	$A1C0,0,$FFFC,$F305 	MOVCLR	V 5.01
	DC.W	$00C0,0,$FFFE,$0F0B 	BITREV	v 5.01
	DC.W	0,0,7,$5701		QM_PAR	added 22.10.04
	DC.W	0,0,$8007,$5701		GW_PAR	added 22.10.04
	DC.W	0,0,6,$5701		EXP_ON	added 19.2.03
	DC.W	0,0,0,$1A00		INCBIN
	DC.W	0,$8000,0,$6E01		NOLIST	altered 25.9.98
	DC.W	0,0,0,$1B01		EXPAND
	DC.W	0,0,0,$D101		ENDGEN
	DC.W	1,0,$8003,$5601		O_FILE	added 23.9.97
	DC.W	0,0,61,$1E01		MACROP
	DC.W	0,0,1,$5400		COMMON
	DC.W	0,0,0,$6A00		RS_SET
	DC.W	0,0,$8002,$5601		PC_REL
	DC.W	0,0,5,$FF00		PLOADR
	DC.W	0,0,6,$FF00		PLOADW
	DC.W	$2800,$FE1B,$FFFD,$6600	PVALID
	DC.W	0,0,4,$5701		LOW_EA
	DC.W	$F200,$000D,$7000,$3607	FATANH
	DC.W	$F200,$0003,$7000,$3607	FINTRZ
	DC.W	$F200,$0015,$7000,$3607	FLOG10
	DC.W	$F200,$0026,$7000,$3707	FSCALE
	DC.W	0,0,0,$5800		MODULE
	DC.W	0,0,2,$5601		NON_PC
	DC.W	0,0,0,$D101		END_IF
	DC.W	0,0,-1,$D300		ELSEIF
	DC.W	0,0,0,$D000		AND_IF
	DC.W	0,0,0,$4201		ALIGN8
	DC.W	0,0,0,$4101		ALIGN4
	DC.W	$F278,$77FF,$000F,$3D06	FTRAPT
	DC.W	$F278,$77FF,$0000,$3D06	FTRAPF
	DC.W	$F200,$0045,$7000,$3607	FDSQRT
	DC.W	$F200,$0041,$7000,$3607	FSSQRT
	DC.W	$F240,$0018,$FE02,$3C00	FSNGLE
	DC.W	$F800,$77FF,$01C0,$4C00	LPSTOP
	DC.W	$F200,$C000,$0E09,$3F08	FMOVEM
	DC.W	$F200,$0044,$7000,$3E0E	FDMOVE   * altered OCT 02 *
	DC.W	$F200,$0040,$7000,$3E0E	FSMOVE   * altered OCT 02 *
	DC.W	$F248,$001E,$FFFE,$3A00	FDBSNE
	DC.W	$F248,$0011,$FFFE,$3A00	FDBSEQ
	DC.W	$F248,$0009,$FFFE,$3A00	FDBUEQ
	DC.W	$F248,$0006,$FFFE,$3A00	FDBOGL
	DC.W	$F248,$000A,$FFFE,$3A00	FDBUGT
	DC.W	$F248,$0005,$FFFE,$3A00	FDBOLE
	DC.W	$F248,$000B,$FFFE,$3A00	FDBUGE
	DC.W	$F248,$0004,$FFFE,$3A00	FDBOLT
	DC.W	$F248,$000C,$FFFE,$3A00	FDBULT
	DC.W	$F248,$0003,$FFFE,$3A00	FDBOGE
	DC.W	$F248,$000D,$FFFE,$3A00	FDBULE
	DC.W	$F248,$0002,$FFFE,$3A00	FDBOGT
	DC.W	$F248,$0017,$FFFE,$3A00	FDBGLE
	DC.W	$F248,$0019,$FFFE,$3A00	FDBNGL
	DC.W	$F248,$001A,$FFFE,$3A00	FDBNLE
	DC.W	$F248,$001B,$FFFE,$3A00	FDBNLT
	DC.W	$F248,$001C,$FFFE,$3A00	FDBNGE
	DC.W	$F248,$001D,$FFFE,$3A00	FDBNGT
	DC.W	$F298,0,$50,$4D09		FBNGLE
	DC.W	$59F8,0,$77FF,$2D06 	TRAPVS
	DC.W	$58F8,0,$77FF,$2D06 	TRAPVC
	DC.W	$5AF8,0,$77FF,$2D06 	TRAPPL
	DC.W	$56F8,0,$77FF,$2D06 	TRAPNE
	DC.W	$5BF8,0,$77FF,$2D06 	TRAPMI
	DC.W	$5DF8,0,$77FF,$2D06 	TRAPLT
	DC.W	$53F8,0,$77FF,$2D06 	TRAPLS
	DC.W	$5FF8,0,$77FF,$2D06 	TRAPLE
	DC.W	$52F8,0,$77FF,$2D06 	TRAPHI
	DC.W	$5EF8,0,$77FF,$2D06 	TRAPGT
	DC.W	$5CF8,0,$77FF,$2D06 	TRAPGE
	DC.W	$57F8,0,$77FF,$2D06 	TRAPEQ
	DC.W	$55F8,0,$77FF,$2D06 	TRAPCS
	DC.W	$54F8,0,$77FF,$2D06 	TRAPCC
	DC.W	$E9C0,$77FE,$F81A,$2300	BFEXTU
	DC.W	$EBC0,$77FE,$F81A,$2300	BFEXTS
	DC.W	$F600,$7EF7,$7EF3,$4B00	MOVE16
	DC.W	0,0,4,$FF00		PTESTW
	DC.W	0,0,0,$FF00		PTESTR
	DC.W	0,0,1,$FF00		PFLUSH
	DC.W	$F428,0,$7FFB,$4A00 	CPUSHL
	DC.W	$F430,0,$7FFB,$4A00 	CPUSHP
	DC.W	$F438,0,0,$4900		CPUSHA
	DC.W	$40E7,$46FC,$77FF,$7600	STRLDSR	v 5.01
	DC.W	$F420,0,$FFFD,$7500 	INTOUCH	v 5.01
	DC.W	$02C0,0,$FFFE,$0F0B 	BYTEREV	v 5.01
	DC.W	0,0,$8006,$5701		EXP_OFF	added 19.2.03
	DC.W	0,0,$8004,$5601		COM_DUM
	DC.W	0,0,4,$5601		COM_ALL
	DC.W	PWID,70,132,$1900		PAGEWID
	DC.W	0,0,0,$1B01		PAGELEN
	DC.W	0,0,1,$6B00		WARNING
	DC.W	0,0,$8001,$5601		UND_ERR
	DC.W	0,0,$8004,$5701		HIGH_EA
	DC.W	0,0,2,$5C01		68EC030
	DC.W	$0100,0,$FE1B,$6100 	PMOVEFD
	DC.W	$F000,$A000,$F003,$6900	PFLUSHR
	DC.W	$3400,$FE1B,$77FF,$6400	PFLUSHS
	DC.W	$F078,$77FF,0,$3D06 	PTRAPBS
	DC.W	$F078,$77FF,1,$3D06 	PTRAPBC
	DC.W	$F078,$77FF,2,$3D06 	PTRAPLS
	DC.W	$F078,$77FF,3,$3D06 	PTRAPLC
	DC.W	$F078,$77FF,4,$3D06 	PTRAPSS
	DC.W	$F078,$77FF,5,$3D06 	PTRAPSC
	DC.W	$F078,$77FF,6,$3D06 	PTRAPAS
	DC.W	$F078,$77FF,7,$3D06 	PTRAPAC
	DC.W	$F078,$77FF,8,$3D06 	PTRAPWS
	DC.W	$F078,$77FF,9,$3D06 	PTRAPWC
	DC.W	$F078,$77FF,$A,$3D06	PTRAPIS
	DC.W	$F078,$77FF,$B,$3D06	PTRAPIC
	DC.W	$F078,$77FF,$C,$3D06	PTRAPGS
	DC.W	$F078,$77FF,$D,$3D06	PTRAPGC
	DC.W	$F078,$77FF,$E,$3D06	PTRAPCS
	DC.W	$F078,$77FF,$F,$3D06	PTRAPCC
	DC.W	$F200,$0008,$7000,$3607	FETOXM1
	DC.W	$F200,$001E,$7000,$3607	FGETEXP
	DC.W	$F200,$001F,$7000,$3607	FGETMAN
	DC.W	$F200,$0006,$7000,$3607	FLOGNP1
	DC.W	$F200,$77FF,$5C00,$5A0C	FMOVECR
	DC.W	$F200,$0030,$7000,$5B07	FSINCOS
	DC.W	$F200,$0012,$7000,$3607	FTENTOX
	DC.W	$F200,$0011,$7000,$3607	FTWOTOX
	DC.W	0,0,1,$1A00		INCLUDE
	DC.W	0,0,0,$5900		COMMENT
	DC.W	0,0,0,$5400		SECTION
	DC.W	0,0,-1,$D300		ELSE_IF
	DC.W	$4AFC,0,0,$0101		ILLEGAL
	DC.W	0,0,0,$4301		ALIGN16
	DC.W	$F278,$77FF,$000F,$3D06	FTRAPRA
	DC.W	$F278,$77FF,$001F,$3D06	FTRAPST
	DC.W	$F278,$77FF,$0010,$3D06	FTRAPSF
	DC.W	$F278,$77FF,$0008,$3D06	FTRAPUN
	DC.W	$F278,$77FF,$0007,$3D06	FTRAPOR
	DC.W	$F278,$77FF,$0016,$3D06	FTRAPGL
	DC.W	$F278,$77FF,$0015,$3D06	FTRAPLE
	DC.W	$F278,$77FF,$0014,$3D06	FTRAPLT
	DC.W	$F278,$77FF,$0013,$3D06	FTRAPGE
	DC.W	$F278,$77FF,$0012,$3D06	FTRAPGT
	DC.W	$F278,$77FF,$000E,$3D06	FTRAPNE
	DC.W	$F278,$77FF,$0001,$3D06	FTRAPEQ
	DC.W	$F200,$0027,$7000,$3707	FSGLMUL
	DC.W	$F200,$0024,$7000,$3707	FSGLDIV
	DC.W	$F248,$0018,$FFFE,$3A00	FDBNGLE
	DC.W	0,0,2,$FF00		PFLUSHA
	DC.W	$F500,0,$7FFB,$4000 	PFLUSHN
	DC.W	0,0,0,$1B01		NOEXPAND
	DC.W	1,0,3,$5601		REL_FILE added 26.9.97
	DC.W	0,0,$8000,$5701		CASE_IND
	DC.W	$F140,0,$F813,$3900 	PRESTORE alt 6.6.97
	DC.W	0,0,1,$5601		UND_XREF
	DC.W	FLTYP,0,254,$1900		FILETYPE
	DC.W	$F340,0,$F813,$3900 	FRESTORE
	DC.W	$F278,$77FF,$001E,$3D06	FTRAPSNE
	DC.W	$F278,$77FF,$0011,$3D06	FTRAPSEQ
	DC.W	$F278,$77FF,$0009,$3D06	FTRAPUEQ
	DC.W	$F278,$77FF,$0006,$3D06	FTRAPOGL
	DC.W	$F278,$77FF,$000A,$3D06	FTRAPUGT
	DC.W	$F278,$77FF,$0005,$3D06	FTRAPOLE
	DC.W	$F278,$77FF,$000B,$3D06	FTRAPUGE
	DC.W	$F278,$77FF,$0004,$3D06	FTRAPOLT
	DC.W	$F278,$77FF,$000C,$3D06	FTRAPULT
	DC.W	$F278,$77FF,$0003,$3D06	FTRAPOGE
	DC.W	$F278,$77FF,$000D,$3D06	FTRAPULE
	DC.W	$F278,$77FF,$0002,$3D06	FTRAPOGT
	DC.W	$F278,$77FF,$0017,$3D06	FTRAPGLE
	DC.W	$F278,$77FF,$0019,$3D06	FTRAPNGL
	DC.W	$F278,$77FF,$001A,$3D06	FTRAPNLE
	DC.W	$F278,$77FF,$001B,$3D06	FTRAPNLT
	DC.W	$F278,$77FF,$001C,$3D06	FTRAPNGE
	DC.W	$F278,$77FF,$001D,$3D06	FTRAPNGT
	DC.W	$F510,0,0,$0101		PFLUSHAN
	DC.W	0,0,0,$5701		CASE_DIFF
	DC.W	$F278,$77FF,$0018,$3D06	FTRAPNGLE
;
; PTABLE2 contains the PRO_LST entries for 15 ambiguous instructions.
; The code for these instructions depends on the target processor
; which is one of 68040, 68030, 68EC030 and 68851. Which one to use
; is given in bits 1-3 of DIP(A6) the values being 0, 1, 2 and 3
; respectively.
;
PTABLE2	DC.W	$F548,0,$7FFB,$4000 	PTESTR  68040
	DC.W	$F508,0,$7FFB,$4000 	PFLUSH	"
	DC.W	$F518,0,0,$0101		PFLUSHA	"
	DC.W	$8200,$FE1B,$77FF,$5E00	PTESTR  68030/68EC030
	DC.W	$3000,$FE1B,$77FF,$6300	PFLUSH	    "
	DC.W	$2400,0,0,$6501		PFLUSHA 68030/68EC030
;					        and 68851
	DC.W	0,$FE1B,$FE1B,$5F00 	PMOVE   68030
	DC.W	0,$FE1B,$FE1B,$5D00 	PMOVE   68EC030
	DC.W	$8200,$FE1B,$77FF,$6200	PTESTR  68851
	DC.W	$3000,$FE1B,$77FF,$6400	PFLUSH	"
	DC.W	$4000,$FE00,$F000,$6000	PMOVE	"
	DC.W	$F548,0,$7FFB,$4000 	PTESTW  68040
	DC.W	$8000,$FE1B,$77FF,$5E00	PTESTW  68030/68EC030
	DC.W	$8000,$FE1B,$77FF,$6200	PTESTW  68851
	DC.W	$2200,$FE1B,$77FF,$6700	PLOADR  68030
	DC.W	$2200,$FE1B,$77FF,$6800	PLOADR  68851
	DC.W	$2000,$FE1B,$77FF,$6700	PLOADW  68030
	DC.W	$2000,$FE1B,$77FF,$6800	PLOADW  68851
;
INST_2	DC.W	7
	DC.W	'IN'
	DC.W	'DC'
	DC.W	'DS'
	DC.W	'OR'
	DC.W	'ST'
	DC.W	'SF'
	DC.W	'IF'
	DC.W	'RS'
INST_3	DC.W	88	v 5.01
	DC.B	'END',0
	DC.B	'RTM',0
	DC.B	'CAS',0
	DC.B	'LIB',0
	DC.B	'PCK',0
	DC.B	'TAS',0
	DC.B	'RTR',0
	DC.B	'RTE',0
	DC.B	'ROR',0
	DC.B	'ROL',0
	DC.B	'PEA',0
	DC.B	'NOT',0
	DC.B	'JMP',0
	DC.B	'CHK',0
	DC.B	'BSR',0
	DC.B	'ORI',0
	DC.B	'JSR',0
	DC.B	'EXT',0
	DC.B	'AND',0
	DC.B	'LEA',0
	DC.B	'TST',0
	DC.B	'SUB',0
	DC.B	'SVS',0
	DC.B	'SVC',0
	DC.B	'SPL',0
	DC.B	'SNE',0
	DC.B	'SMI',0
	DC.B	'SLT',0
	DC.B	'SLS',0
	DC.B	'SLE',0
	DC.B	'SHI',0
	DC.B	'SGT',0
	DC.B	'SGE',0
	DC.B	'SEQ',0
	DC.B	'SLO',0
	DC.B	'SHS',0
	DC.B	'SCS',0
	DC.B	'SCC',0
	DC.B	'RTS',0
	DC.B	'NOP',0
	DC.B	'NEG',0
	DC.B	'LSR',0
	DC.B	'LSL',0
	DC.B	'EXG',0
	DC.B	'EOR',0
	DC.B	'DBT',0
	DC.B	'DBF',0
	DC.B	'CMP',0
	DC.B	'CLR',0
	DC.B	'BRA',0
	DC.B	'BVS',0
	DC.B	'BVC',0
	DC.B	'BPL',0
	DC.B	'BNE',0
	DC.B	'BMI',0
	DC.B	'BLT',0
	DC.B	'BLS',0
	DC.B	'BLE',0
	DC.B	'BHI',0
	DC.B	'BGT',0
	DC.B	'BGE',0
	DC.B	'BEQ',0
	DC.B	'BCS',0
	DC.B	'BLO',0
	DC.B	'BCC',0
	DC.B	'BHS',0
	DC.B	'MAC',0	v 5.01
	DC.B	'TPF',0	v 5.01
	DC.B	'MVZ',0	v 5.01
	DC.B	'MVS',0	v 5.01
	DC.B	'FF1',0	v 5.01
	DC.B	'ASR',0
	DC.B	'ASL',0
	DC.B	'ADD',0
	DC.B	'FBF',0
	DC.B	'FBT',0
	DC.B	'RTD',0
	DC.B	'FSF',0
	DC.B	'FST',0
	DC.B	'IFC',0
	DC.B	'ERR',0
	DC.B	'LST',0
	DC.B	'ORG',0
	DC.B	'DCB',0
	DC.B	'TTL',0
	DC.B	'OPT',0
	DC.B	'REG',0
	DC.B	'SET',0
	DC.B	'EQU',0
INST_4	DC.W	155	   ; SNG - was 56
	DC.B	'MOVE'	   ; SNG - moved to start
	DC.B	'PWID'
	DC.B	'BKPT'
	DC.B	'CAS2'
	DC.B	'CHK2'
	DC.B	'CMP2'
	DC.B	'PACK'
	DC.B	'UNPK'
	DC.B	'EXTB'
	DC.B	'SUBQ'
	DC.B	'DATA'
	DC.B	'UNLK'
	DC.B	'SUBX'
	DC.B	'SUBI'
	DC.B	'STOP'
	DC.B	'SBCD'
	DC.B	'ROXR'
	DC.B	'ROXL'
	DC.B	'NEGX'
	DC.B	'NBCD'
	DC.B	'LINK'
	DC.B	'CMPM'
	DC.B	'BTST'
	DC.B	'BSET'
	DC.B	'BCLR'
	DC.B	'BCHG'
	DC.B	'ABCD'
	DC.B	'ANDI'
	DC.B	'TRAP'
	DC.B	'SWAP'
	DC.B	'SUBA'
	DC.B	'DBVS'
	DC.B	'MULS'
	DC.B	'MULU'
	DC.B	'EORI'
	DC.B	'DIVS'
	DC.B	'DIVU'
	DC.B	'DBVC'
	DC.B	'DBPL'
	DC.B	'DBNE'
	DC.B	'DBMI'
	DC.B	'DBLT'
	DC.B	'DBLS'
	DC.B	'DBLE'
	DC.B	'DBHI'
	DC.B	'DBGT'
	DC.B	'DBGE'
	DC.B	'DBRA'
	DC.B	'DBEQ'
	DC.B	'DBCS'
	DC.B	'DBCC'
	DC.B	'CMPI'
	DC.B	'CMPA'
	DC.B	'ADDA'
	DC.B	'ADDX'
	DC.B	'ADDQ'
	DC.B	'ADDI'
	DC.B	'FABS'
	DC.B	'FADD'
	DC.B	'FBEQ'
	DC.B	'FBNE'
	DC.B	'FBGT'
	DC.B	'FBGE'
	DC.B	'FBLT'
	DC.B	'FBLE'
	DC.B	'FBGL'
	DC.B	'FBOR'
	DC.B	'FBUN'
	DC.B	'FBSF'
	DC.B	'FBST'
	DC.B	'FBRA'
	DC.B	'FCMP'
	DC.B	'FDBF'
	DC.B	'FDBT'
	DC.B	'FDIV'
	DC.B	'FMUL'
	DC.B	'TBLS'
	DC.B	'TBLU'
	DC.B	'FNEG'
	DC.B	'FNOP'
	DC.B	'FSEQ'
	DC.B	'FSNE'
	DC.B	'FSGT'
	DC.B	'FSGE'
	DC.B	'FSLT'
	DC.B	'FSLE'
	DC.B	'FSGL'
	DC.B	'FSOR'
	DC.B	'FSUN'
	DC.B	'FSSF'
	DC.B	'FSST'
	DC.B	'FSRA'
	DC.B	'FSUB'
	DC.B	'FTST'
	DC.B	'BGND'	     ; SNG - extra for 68330/68340/CPU32
	DC.B	'HALT'	     ; SNG - extra for 68060
	DC.B	'CNOP'
	DC.B	'ELSE'
	DC.B	'ORIF'
	DC.B	'ENDC'
	DC.B	'XREF'
	DC.B	'XDEF'
	DC.B	'FTAN'
	DC.B	'FSIN'
	DC.B	'FREM'
	DC.B	'FMOD'
	DC.B	'FINT'
	DC.B	'FCOS'
	DC.B	'PBCC'
	DC.B	'PBCS'
	DC.B	'PBGC'
	DC.B	'PBGS'
	DC.B	'PBIC'
	DC.B	'PBIS'
	DC.B	'PBWC'
	DC.B	'PBWS'
	DC.B	'PBAC'
	DC.B	'PBAS'
	DC.B	'PBSC'
	DC.B	'PBSS'
	DC.B	'PBLC'
	DC.B	'PBLS'
	DC.B	'PBBC'
	DC.B	'PBBS'
	DC.B	'PSCC'
	DC.B	'PSCS'
	DC.B	'PSGC'
	DC.B	'PSGS'
	DC.B	'PSIC'
	DC.B	'PSIS'
	DC.B	'PSWC'
	DC.B	'PSWS'
	DC.B	'PSAC'
	DC.B	'PSAS'
	DC.B	'PSSC'
	DC.B	'PSSS'
	DC.B	'PSLC'
	DC.B	'PSLS'
	DC.B	'PSBC'
	DC.B	'PSBS'
	DC.B	'EQUR'
	DC.B	'IFNC'
	DC.B	'IFGE'
	DC.B	'IFNE'
	DC.B	'IFLE'
	DC.B	'IFGT'
	DC.B	'IFEQ'
	DC.B	'IFLT'
	DC.B	'GOTO'
	DC.B	'PAGE'
	DC.B	'LIST'
	DC.B	'FREG'
	DC.B	'SATS'
	DC.B	'REMS'
	DC.B	'REMU'
	DC.B	'MSAC'
INST_5	DC.W	133	      ; SNG - was 19
	DC.B	'BFCHG',0
	DC.B	'BFCLR',0
	DC.B	'BFSET',0
	DC.B	'BFTST',0
	DC.B	'BFFFO',0
	DC.B	'BFINS',0
	DC.B	'CALLM',0
	DC.B	'DIVSL',0
	DC.B	'DIVUL',0
	DC.B	'MOVES',0
	DC.B	'TRAPF',0
	DC.B	'TRAPT',0
	DC.B	'MACRO',0
	DC.B	'TRAPV',0
	DC.B	'RESET',0
	DC.B	'MOVEP',0
	DC.B	'MOVEM',0
	DC.B	'MOVEQ',0
	DC.B	'MOVEA',0
	DC.B	'MOVEC',0
	DC.B	'FSABS',0
	DC.B	'FDABS',0
	DC.B	'FSADD',0
	DC.B	'FDADD',0
	DC.B	'FBNGT',0
	DC.B	'FBNGE',0
	DC.B	'FBNLT',0
	DC.B	'FBNLE',0
	DC.B	'FBNGL',0
	DC.B	'FBGLE',0
	DC.B	'FBOGT',0
	DC.B	'FBULE',0
	DC.B	'FBOGE',0
	DC.B	'FBULT',0
	DC.B	'FBOLT',0
	DC.B	'FBUGE',0
	DC.B	'FBOLE',0
	DC.B	'FBUGT',0
	DC.B	'FBOGL',0
	DC.B	'FBUEQ',0
	DC.B	'FBSEQ',0
	DC.B	'FBSNE',0
	DC.B	'FDBEQ',0
	DC.B	'FDBNE',0
	DC.B	'FDBGT',0
	DC.B	'FDBGE',0
	DC.B	'FDBLT',0
	DC.B	'FDBLE',0
	DC.B	'FDBGL',0
	DC.B	'FDBOR',0
	DC.B	'FDBUN',0
	DC.B	'FDBSF',0
	DC.B	'FDBST',0
	DC.B	'FDBRA',0
	DC.B	'FSDIV',0
	DC.B	'FDDIV',0
	DC.B	'FMOVE',0
	DC.B	'FSMUL',0
	DC.B	'FDMUL',0
	DC.B	'TBLSN',0
	DC.B	'TBLUN',0
	DC.B	'FSNEG',0
	DC.B	'FDNEG',0
	DC.B	'FSNGT',0
	DC.B	'FSNGE',0
	DC.B	'FSNLT',0
	DC.B	'FSNLE',0
	DC.B	'FSNGL',0
	DC.B	'FSGLE',0
	DC.B	'FSOGT',0
	DC.B	'FSULE',0
	DC.B	'FSOGE',0
	DC.B	'FSULT',0
	DC.B	'FSOLT',0
	DC.B	'FSUGE',0
	DC.B	'FSOLE',0
	DC.B	'FSUGT',0
	DC.B	'FSOGL',0
	DC.B	'FSUEQ',0
	DC.B	'FSSEQ',0
	DC.B	'FSSNE',0
	DC.B	'FSQRT',0
	DC.B	'FSSUB',0
	DC.B	'FDSUB',0
	DC.B	'FSAVE',0
	DC.B	'PLPAW',0        ; SNG - 68060 extra
	DC.B	'PLPAR',0        ; SNG - 68060
	DC.B	'CINVA',0        ; GDG - 68040
	DC.B	'CINVP',0        ; GDG - 68040
	DC.B	'CINVL',0        ; GDG - 68040
	DC.B	'PULSE',0        ; SNG - 68060
	DC.B	'ENDIF',0
	DC.B	'OR_IF',0
	DC.B	'ANDIF',0
	DC.B	'FTANH',0
	DC.B	'FSINH',0
	DC.B	'FLOGN',0
	DC.B	'FLOG2',0
	DC.B	'FETOX',0
	DC.B	'FCOSH',0
	DC.B	'FATAN',0
	DC.B	'FASIN',0
	DC.B	'FACOS',0
	DC.B	'PMOVE',0
	DC.B	'PSAVE',0
	DC.B	'68851',0
	DC.B	'68030',0
	DC.B	'68040',0
	DC.B	'PDBCC',0
	DC.B	'PDBCS',0
	DC.B	'PDBGC',0
	DC.B	'PDBGS',0
	DC.B	'PDBIC',0
	DC.B	'PDBIS',0
	DC.B	'PDBWC',0
	DC.B	'PDBWS',0
	DC.B	'PDBAC',0
	DC.B	'PDBAS',0
	DC.B	'PDBSC',0
	DC.B	'PDBSS',0
	DC.B	'PDBLC',0
	DC.B	'PDBLS',0
	DC.B	'PDBBC',0
	DC.B	'PDBBS',0
	DC.B	'RSSET',0
	DC.B	'ERROR',0
	DC.B	'TITLE',0
	DC.B	'GENIF',0
	DC.B	'FEQUR',0
	DC.B	'MOV3Q',0
	DC.B	'MSSAC',0
	DC.B	'MSAAC',0
	DC.B	'MASAC',0
	DC.B	'MAAAC',0
INST_6	DC.W	81
	DC.B	'CPUSHA'	       ; GDG - 68040
	DC.B	'CPUSHP'	       ;	    "
	DC.B	'CPUSHL'	       ;	    "
	DC.B	'PFLUSH'	       ;	    "
	DC.B	'PTESTR'	       ;	    "
	DC.B	'PTESTW'	       ;	    "
	DC.B	'MOVE16'	       ;	    "
	DC.B	'BFEXTS'
	DC.B	'BFEXTU'
	DC.B	'TRAPCC'
	DC.B	'TRAPCS'
	DC.B	'TRAPEQ'
	DC.B	'TRAPGE'
	DC.B	'TRAPGT'
	DC.B	'TRAPHI'
	DC.B	'TRAPLE'
	DC.B	'TRAPLS'
	DC.B	'TRAPLT'
	DC.B	'TRAPMI'
	DC.B	'TRAPNE'
	DC.B	'TRAPPL'
	DC.B	'TRAPVC'
	DC.B	'TRAPVS'
	DC.B	'FBNGLE'
	DC.B	'FDBNGT'
	DC.B	'FDBNGE'
	DC.B	'FDBNLT'
	DC.B	'FDBNLE'
	DC.B	'FDBNGL'
	DC.B	'FDBGLE'
	DC.B	'FDBOGT'
	DC.B	'FDBULE'
	DC.B	'FDBOGE'
	DC.B	'FDBULT'
	DC.B	'FDBOLT'
	DC.B	'FDBUGE'
	DC.B	'FDBOLE'
	DC.B	'FDBUGT'
	DC.B	'FDBOGL'
	DC.B	'FDBUEQ'
	DC.B	'FDBSEQ'
	DC.B	'FDBSNE'
	DC.B	'FSMOVE'
	DC.B	'FDMOVE'
	DC.B	'FMOVEM'
	DC.B	'LPSTOP'
	DC.B	'FSNGLE'
	DC.B	'FSSQRT'
	DC.B	'FDSQRT'
	DC.B	'FTRAPF'
	DC.B	'FTRAPT'
	DC.B	'ALIGN4'
	DC.B	'ALIGN8'
	DC.B	'AND_IF'
	DC.B	'ELSEIF'
	DC.B	'END_IF'
	DC.B	'NON_PC'
	DC.B	'MODULE'
	DC.B	'FSCALE'
	DC.B	'FLOG10'
	DC.B	'FINTRZ'
	DC.B	'FATANH'
	DC.B	'LOW_EA'
	DC.B	'PVALID'
	DC.B	'PLOADW'
	DC.B	'PLOADR'
	DC.B	'PC_REL'
	DC.B	'RS_SET'
	DC.B	'COMMON'
	DC.B	'MACROP'
	DC.B	'O_FILE'
	DC.B	'ENDGEN'
	DC.B	'EXPAND'
	DC.B	'NOLIST'
	DC.B	'INCBIN'
	DC.B	'EXP_ON'
	DC.B	'GW_PAR'
	DC.B	'QM_PAR'
	DC.B	'BITREV'
	DC.B	'MOVCLR'
	DC.B	'WDEBUG'
	DC.B	'WDDATA'
INST_7	DC.W	61
	DC.B	'PFLUSHN',0
	DC.B	'PFLUSHA',0
	DC.B	'FDBNGLE',0
	DC.B	'FSGLDIV',0
	DC.B	'FSGLMUL',0
	DC.B	'FTRAPEQ',0
	DC.B	'FTRAPNE',0
	DC.B	'FTRAPGT',0
	DC.B	'FTRAPGE',0
	DC.B	'FTRAPLT',0
	DC.B	'FTRAPLE',0
	DC.B	'FTRAPGL',0
	DC.B	'FTRAPOR',0
	DC.B	'FTRAPUN',0
	DC.B	'FTRAPSF',0
	DC.B	'FTRAPST',0
	DC.B	'FTRAPRA',0
	DC.B	'ALIGN16',0
	DC.B	'ILLEGAL',0
	DC.B	'ELSE_IF',0
	DC.B	'SECTION',0
	DC.B	'COMMENT',0
	DC.B	'INCLUDE',0
	DC.B	'FTWOTOX',0
	DC.B	'FTENTOX',0
	DC.B	'FSINCOS',0
	DC.B	'FMOVECR',0
	DC.B	'FLOGNP1',0
	DC.B	'FGETMAN',0
	DC.B	'FGETEXP',0
	DC.B	'FETOXM1',0
	DC.B	'PTRAPCC',0
	DC.B	'PTRAPCS',0
	DC.B	'PTRAPGC',0
	DC.B	'PTRAPGS',0
	DC.B	'PTRAPIC',0
	DC.B	'PTRAPIS',0
	DC.B	'PTRAPWC',0
	DC.B	'PTRAPWS',0
	DC.B	'PTRAPAC',0
	DC.B	'PTRAPAS',0
	DC.B	'PTRAPSC',0
	DC.B	'PTRAPSS',0
	DC.B	'PTRAPLC',0
	DC.B	'PTRAPLS',0
	DC.B	'PTRAPBC',0
	DC.B	'PTRAPBS',0
	DC.B	'PFLUSHS',0
	DC.B	'PFLUSHR',0
	DC.B	'PMOVEFD',0
	DC.B	'68EC030',0
	DC.B	'HIGH_EA',0
	DC.B	'UND_ERR',0
	DC.B	'WARNING',0
	DC.B	'PAGELEN',0
	DC.B	'PAGEWID',0
	DC.B	'COM_ALL',0
	DC.B	'COM_DUM',0
	DC.B	'EXP_OFF',0
	DC.B	'BYTEREV',0	v 5.01
	DC.B	'INTOUCH',0	v 5.01
	DC.B	'STRLDSR',0	v 5.01
INST_8	DC.W	25
	DC.B	'PFLUSHAN'
	DC.B	'FTRAPNGT'
	DC.B	'FTRAPNGE'
	DC.B	'FTRAPNLT'
	DC.B	'FTRAPNLE'
	DC.B	'FTRAPNGL'
	DC.B	'FTRAPGLE'
	DC.B	'FTRAPOGT'
	DC.B	'FTRAPULE'
	DC.B	'FTRAPOGE'
	DC.B	'FTRAPULT'
	DC.B	'FTRAPOLT'
	DC.B	'FTRAPUGE'
	DC.B	'FTRAPOLE'
	DC.B	'FTRAPUGT'
	DC.B	'FTRAPOGL'
	DC.B	'FTRAPUEQ'
	DC.B	'FTRAPSEQ'
	DC.B	'FTRAPSNE'
	DC.B	'FRESTORE'
	DC.B	'FILETYPE'
	DC.B	'UND_XREF'
	DC.B	'PRESTORE'
	DC.B	'CASE_IND'
	DC.B	'REL_FILE'
	DC.B	'NOEXPAND'
INST_9	DC.W	1
	DC.B	'FTRAPNGLE',0
	DC.B	'CASE_DIFF',0
;
PR	DC.L	PR1-PR
	DC.L	PR2-PR
	DC.L	PR3-PR
	DC.L	PR4-PR
	DC.L	PR5-PR
	DC.L	PR6-PR
	DC.L	PR7-PR
	DC.L	PR8-PR
	DC.L	PR9-PR
	DC.L	PR10-PR
	DC.L	PR11-PR
	DC.L	PR12-PR
	DC.L	PR13-PR
	DC.L	PR14-PR
	DC.L	PR15-PR
	DC.L	PR16-PR
	DC.L	PR17-PR
	DC.L	PR18-PR
	DC.L	PR19-PR
	DC.L	PR20-PR
	DC.L	PR21-PR
	DC.L	PR22-PR
	DC.L	PR23-PR
	DC.L	PR24-PR
	DC.L	PR25-PR
	DC.L	PR26-PR
	DC.L	PR27-PR
	DC.L	PR28-PR
	DC.L	PR29-PR
	DC.L	PR30-PR
	DC.L	PR31-PR
	DC.L	PR32-PR
	DC.L	PR33-PR
	DC.L	PR34-PR
	DC.L	PR35-PR
	DC.L	PR36-PR
	DC.L	PR37-PR
	DC.L	PR38-PR
	DC.L	PR39-PR
	DC.L	PR40-PR
	DC.L	PR41-PR
	DC.L	PR42-PR
	DC.L	PR43-PR
	DC.L	PR44-PR
	DC.L	PR45-PR
	DC.L	PR46-PR
	DC.L	PR47-PR
	DC.L	PR48-PR
	DC.L	PR49-PR
	DC.L	PR50-PR
	DC.L	PR51-PR
	DC.L	PR52-PR
	DC.L	PR53-PR
	DC.L	PR54-PR
	DC.L	PR55-PR
	DC.L	PR56-PR
	DC.L	PR57-PR
	DC.L	PR58-PR
	DC.L	PR59-PR
	DC.L	PR60-PR
	DC.L	PR61-PR
	DC.L	PR62-PR
	DC.L	PR63-PR
	DC.L	PR64-PR
	DC.L	PR65-PR
	DC.L	PR66-PR
	DC.L	PR67-PR
	DC.L	PR68-PR
	DC.L	PR69-PR
	DC.L	PR70-PR
	DC.L	PR71-PR
	DC.L	PR72-PR
	DC.L	PR73-PR
	DC.L	PR74-PR
	DC.L	PR75-PR
	DC.L	PR76-PR
	DC.L	PR77-PR
	DC.L	PR78-PR
	DC.L	PR79-PR
	DC.L	PR80-PR
	DC.L	PR81-PR
	DC.L	PR82-PR
	DC.L	PR83-PR
	DC.L	PR84-PR
	DC.L	PR85-PR
	DC.L	PR86-PR
	DC.L	PR87-PR
	DC.L	PR88-PR
	DC.L	PR89-PR
	DC.L	PR90-PR
	DC.L	PR91-PR
	DC.L	PR92-PR
	DC.L	PR93-PR
	DC.L	PR94-PR
	DC.L	PR95-PR
	DC.L	PR96-PR
	DC.L	PR97-PR
	DC.L	PR98-PR
	DC.L	PR99-PR
	DC.L	PR100-PR
	DC.L	PR101-PR
	DC.L	PR102-PR
	DC.L	PR103-PR
	DC.L	PR104-PR
	DC.L	PR105-PR
	DC.L	PR106-PR
	DC.L	PR107-PR
	DC.L	PR108-PR
	DC.L	PR109-PR
	DC.L	PR110-PR
	DC.L	PR111-PR
	DC.L	PR112-PR
	DC.L	PR113-PR
	DC.L	PR114-PR
	DC.L	PR115-PR
	DC.L	PR116-PR
	DC.L	PR117-PR
	DC.L	PR118-PR
	DC.L	PR119-PR
	DC.L	PR120-PR
; PR52	  EQU	  PR1	  there is no PR52!
PR120	EQU	PR118_1
